Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.codehaus.groovy.runtime
Class DefaultGroovyMethods

    java.lang.Object
      org.codehaus.groovy.runtime.DefaultGroovyMethodsSupport
          org.codehaus.groovy.runtime.DefaultGroovyMethods

    public class DefaultGroovyMethods

extends DefaultGroovyMethodsSupport

This class defines all the new groovy methods which appear on normal JDK classes inside the Groovy environment. Static methods are used with the first parameter the destination class.

Version:
  $Revision: 13717 $
Author:
  James Strachan, Jeremy Rayner, Sam Pullara, Rod Cope, Guillaume Laforge, John Wilson, Hein Meling, Dierk Koenig, Pilho Kim, Marc Guillemot, Russel Winder, bing ran, Jochen Theodorou, Paul King, Michael Baehr, Joachim Baumann

Nested Class Summary
`protected static class` | `DefaultGroovyMethods.ProcessRunner` A Runnable which waits for a process to complete together with a notification scheme allowing another thread to wait a maximum number of seconds for the process to complete before killing it.

Nested classes/interfaces inherited from class org.codehaus.groovy.runtime.DefaultGroovyMethodsSupport
`DefaultGroovyMethodsSupport.RangeInfo`

Constructor Summary
`DefaultGroovyMethods()`

Method Summary
`static double` | `abs(Double number)` Get the absolute value
`static float` | `abs(Float number)` Get the absolute value
`static long` | `abs(Long number)` Get the absolute value
`static int` | `abs(Number number)` Get the absolute value
`static Socket` | `accept(ServerSocket serverSocket, Closure closure)` Accepts a connection and passes the resulting Socket to the closure which runs in a new Thread.
`static void` | `addShutdownHook(Object self, Closure closure)` Allows the usage of addShutdownHook without getting the runtime first.
`static BitSet` | `and(BitSet left, BitSet right)` Bitwise AND together two BitSets.
`static Boolean` | `and(Boolean left, Boolean right)`
`static Number` | `and(Number left, Number right)` Bitwise AND together two Numbers.
`static boolean` | `any(Map self, Closure closure)` Iterates over the entries of a map, and checks whether a predicate is valid for at least one entry
`static boolean` | `any(Object self)` Iterates over the elements of a collection, and checks whether at least one element is true according to the Groovy Truth.
`static boolean` | `any(Object self, Closure closure)` Iterates over the contents of an object or collection, and checks whether a predicate is valid for at least one element.
`static void` | `append(File file, byte[] bytes)` Append bytes to the end of a File.
`static void` | `append(File file, Object text)` Append the text at the end of the File.
`static void` | `append(File file, Object text, String charset)` Append the text at the end of the File, using a specified encoding.
`static Collection` | `asImmutable(Collection self)` A convenience method for creating an immutable Collection.
`static List` | `asImmutable(List self)` A convenience method for creating an immutable list
`static Map` | `asImmutable(Map self)` A convenience method for creating an immutable map.
`static Set` | `asImmutable(Set self)` A convenience method for creating an immutable list.
`static SortedMap` | `asImmutable(SortedMap self)` A convenience method for creating an immutable sorted map.
`static SortedSet` | `asImmutable(SortedSet self)` A convenience method for creating an immutable sorted set.
`static List` | `asList(Collection self)` Converts this collection to a List.
`static Collection` | `asSynchronized(Collection self)` A convenience method for creating a synchronized Collection.
`static List` | `asSynchronized(List self)` A convenience method for creating a synchronized List.
`static Map` | `asSynchronized(Map self)` A convenience method for creating a synchronized Map.
`static Set` | `asSynchronized(Set self)` A convenience method for creating a synchronized Set.
`static SortedMap` | `asSynchronized(SortedMap self)` A convenience method for creating a synchronized SortedMap.
`static SortedSet` | `asSynchronized(SortedSet self)` A convenience method for creating a synchronized SortedSet.
`static Object` | `asType(Closure cl, Class clazz)` Coerces the closure to an implementation of the given class.
`static Object` | `asType(Collection col, Class clazz)` Converts the given collection to another type.
`static Object` | `asType(File f, Class c)` Converts this File to a `Writable` or delegates to default `asType(Object,Class)`.
`static Object` | `asType(GString self, Class c)` Converts the GString to a File, or delegates to the default `asType(Object,Class)`
`static Object` | `asType(Map map, Class clazz)` Coerces this map to the given type, using the map's keys as the public method names, and values as the implementation.
`static Object` | `asType(Number self, Class c)` Transform this number to a the given type, using the 'as' operator.
`static Object` | `asType(Object[] ary, Class clazz)` Converts the given array to either a List, Set, or SortedSet.
`static Object` | `asType(Object obj, Class type)` Converts a given object to a type.
`static Object` | `asType(String self, Class c)` Provides a method to perform custom 'dynamic' type conversion to the given class using the `as` operator.
`static File` | `asWritable(File file)` Converts this File to a `Writable`.
`static File` | `asWritable(File file, String encoding)` Allows a file to return a Writable implementation that can output itself to a Writer stream.
`static BitSet` | `bitwiseNegate(BitSet self)` Bitwise NEGATE a BitSet.
`static Pattern` | `bitwiseNegate(String self)` Turns a String into a regular expression pattern
`protected static Object` | `callClosureForLine(Closure closure, String line, int counter)`
`protected static Object` | `callClosureForMapEntry(Closure closure, Map.Entry entry)`
`protected static Object` | `callClosureForMapEntryAndCounter(Closure closure, Map.Entry entry, int counter)`
`static String` | `center(String self, Number numberOfChars)` Center a String and padd it with spaces appended around it
`static String` | `center(String self, Number numberOfChars, String padding)` Center a String and padd it with the characters appended around it
`static List` | `collect(Collection self, Closure closure)` Iterates through this collection transforming each entry into a new value using the closure as a transformer, returning a list of transformed values.
`static Collection` | `collect(Collection self, Collection collection, Closure closure)` Iterates through this collection transforming each value into a new value using the closure as a transformer, returning an initial collection plus the transformed values.
`static List` | `collect(Map self, Closure closure)` Iterates through this Map transforming each entry into a new value using the closure as a transformer, returning a list of transformed values.
`static Collection` | `collect(Map self, Collection collection, Closure closure)` Iterates through this Map transforming each entry into a new value using the closure as a transformer, returning a list of transformed values.
`static List` | `collect(Object self, Closure closure)` Iterates through this object transforming each value into a new value using the closure as a transformer, returning a list of transformed values.
`static Collection` | `collect(Object self, Collection collection, Closure closure)` Iterates through this object transforming each object into a new value using the closure as a transformer and adding it to the collection, returning the resulting collection.
`static List` | `collectAll(Collection self, Closure closure)` Recursively iterates through this collection transforming each non-Collection value into a new value using the closure as a transformer.
`static Collection` | `collectAll(Collection self, Collection collection, Closure closure)` Recursively iterates through this collection transforming each non-Collection value into a new value using the closure as a transformer.
`static List` | `combinations(Collection self)` Adds GroovyCollections#combinations(Collection) as a method on collections.
`static int` | `compareTo(Character left, Character right)` Compare two Characters.
`static int` | `compareTo(Character left, Number right)` Compare a Character and a Number.
`static int` | `compareTo(Number left, Character right)` Compare a Number and a Character.
`static int` | `compareTo(Number left, Number right)` Compare two Numbers.
`static void` | `consumeProcessErrorStream(Process self, OutputStream err)` Gets the error stream from a process and reads it to keep the process from blocking due to a full buffer.
`static void` | `consumeProcessErrorStream(Process self, StringBuffer error)` Gets the error stream from a process and reads it to keep the process from blocking due to a full buffer.
`static void` | `consumeProcessErrorStream(Process self, Writer err)` Gets the error stream from a process and reads it to keep the process from blocking due to a full buffer.
`static void` | `consumeProcessOutput(Process self)` Gets the output and error streams from a process and reads them to keep the process from blocking due to a full output buffer.
`static void` | `consumeProcessOutput(Process self, OutputStream output, OutputStream error)` Gets the output and error streams from a process and reads them to keep the process from blocking due to a full output buffer.
`static void` | `consumeProcessOutput(Process self, StringBuffer output, StringBuffer error)` Gets the output and error streams from a process and reads them to keep the process from blocking due to a full output buffer.
`static void` | `consumeProcessOutputStream(Process self, OutputStream output)` Gets the output stream from a process and reads it to keep the process from blocking due to a full output buffer.
`static void` | `consumeProcessOutputStream(Process self, StringBuffer output)` Gets the output stream from a process and reads it to keep the process from blocking due to a full output buffer.
`static void` | `consumeProcessOutputStream(Process self, Writer output)` Gets the output stream from a process and reads it to keep the process from blocking due to a full output buffer.
`static boolean` | `contains(String self, String text)` Provide an implementation of contains() like `Collection.contains(Object)` to make Strings more polymorphic.
`static int` | `count(Collection self, Object value)` Counts the number of occurrences of the given value inside this collection.
`static int` | `count(Iterator self, Object value)` Counts the number of occurrences of the given value from the items within this Iterator.
`static int` | `count(String self, String text)` Count the number of occurencies of a substring.
`protected static StringBufferWriter` | `createStringBufferWriter(StringBuffer self)`
`protected static StringWriter` | `createStringWriter(String self)`
`static byte[]` | `decodeBase64(String value)` Decode the String from Base64 into a byte array.
`static boolean` | `disjoint(Collection left, Collection right)` Returns `true` if the intersection of two collections is empty.
`static Number` | `div(Character left, Character right)` Divide one Character by another.
`static Number` | `div(Character left, Number right)` Divide a Character by a Number.
`static Number` | `div(Number left, Character right)` Divide a Number by a Character.
`static Number` | `div(Number left, Number right)` Divide two Numbers.
`static void` | `downto(BigDecimal self, Number to, Closure closure)` Iterates from this number down to the given number, inclusive, decrementing by one each time.
`static void` | `downto(BigInteger self, Number to, Closure closure)` Iterates from this number down to the given number, inclusive, decrementing by one each time.
`static void` | `downto(double self, Number to, Closure closure)` Iterates from this number down to the given number, inclusive, decrementing by one each time.
`static void` | `downto(Double self, Number to, Closure closure)` Iterates from this number down to the given number, inclusive, decrementing by one each time.
`static void` | `downto(float self, Number to, Closure closure)` Iterates from this number down to the given number, inclusive, decrementing by one each time.
`static void` | `downto(Float self, Number to, Closure closure)` Iterates from this number down to the given number, inclusive, decrementing by one each time.
`static void` | `downto(long self, Number to, Closure closure)` Iterates from this number down to the given number, inclusive, decrementing by one each time.
`static void` | `downto(Long self, Number to, Closure closure)` Iterates from this number down to the given number, inclusive, decrementing by one each time.
`static void` | `downto(Number self, Number to, Closure closure)` Iterates from this number down to the given number, inclusive, decrementing by one each time.
`static String` | `dump(Object self)` Generates a detailed dump string of an object showing its class, hashCode and fields.
`static Map` | `each(Map self, Closure closure)` Allows a Map to be iterated through using a closure.
`static Matcher` | `each(Matcher self, Closure closure)` Process each matched substring of the given group matcher.
`static Object` | `each(Object self, Closure closure)` Iterates through an aggregate type or data structure, passing each item to the given closure.
`static void` | `eachByte(byte[] self, Closure closure)` Traverse through each byte of this byte array.
`static void` | `eachByte(Byte[] self, Closure closure)` Traverse through each byte of this Byte array.
`static void` | `eachByte(File self, Closure closure)` Traverse through each byte of this File
`static void` | `eachByte(InputStream is, Closure closure)` Traverse through each byte of the specified stream.
`static void` | `eachByte(URL url, Closure closure)` Reads the InputStream from this URL, passing each byte to the given closure.
`static void` | `eachDir(File self, Closure closure)` Invokes the closure for each directory in this directory, ignoring regular files.
`static void` | `eachDirMatch(File self, Object filter, Closure closure)` Invokes the closure for each directory whose name (dir.name) matches the given filter in the given directory - calling the isCase() method to determine if a match occurs.
`static void` | `eachDirRecurse(File self, Closure closure)` Invokes the closure for each descendant directory of this directory.
`static void` | `eachFile(File self, Closure closure)` Invokes the closure for each file in the given directory
`static void` | `eachFileMatch(File self, Object filter, Closure closure)` Invokes the closure for each file whose name (file.name) matches the given filter in the given directory - calling the isCase() method to determine if a match occurs.
`static void` | `eachFileRecurse(File self, Closure closure)` Invokes the closure for each descendant file in this directory.
`static Object` | `eachLine(File self, Closure closure)` Iterates through this file line by line.
`static Object` | `eachLine(File self, int firstLine, Closure closure)` Iterates through this file line by line.
`static Object` | `eachLine(InputStream stream, Closure closure)` Iterates through this stream, passing each line to the given 1 or 2 arg closure.
`static Object` | `eachLine(InputStream stream, int firstLine, Closure closure)` Iterates through this stream, passing each line to the given 1 or 2 arg closure.
`static Object` | `eachLine(InputStream stream, String charset, Closure closure)` Iterates through this stream reading with the provided charset, passing each line to the given 1 or 2 arg closure.
`static Object` | `eachLine(InputStream stream, String charset, int firstLine, Closure closure)` Iterates through this stream reading with the provided charset, passing each line to the given 1 or 2 arg closure.
`static Object` | `eachLine(Reader self, Closure closure)` Iterates through the given reader line by line.
`static Object` | `eachLine(Reader self, int firstLine, Closure closure)` Iterates through the given reader line by line.
`static Object` | `eachLine(String self, Closure closure)` Iterates through this String line by line.
`static Object` | `eachLine(String self, int firstLine, Closure closure)` Iterates through this String line by line.
`static Object` | `eachLine(URL url, Closure closure)` Iterates through the lines read from the URL's associated input stream passing each line to the given 1 or 2 arg closure.
`static Object` | `eachLine(URL url, int firstLine, Closure closure)` Iterates through the lines read from the URL's associated input stream passing each line to the given 1 or 2 arg closure.
`static Object` | `eachLine(URL url, String charset, Closure closure)` Iterates through the lines read from the URL's associated input stream passing each line to the given 1 or 2 arg closure.
`static Object` | `eachLine(URL url, String charset, int firstLine, Closure closure)` Iterates through the lines read from the URL's associated input stream passing each line to the given 1 or 2 arg closure.
`static void` | `eachMatch(String self, String regex, Closure closure)` Process each regex group matched substring of the given string.
`static void` | `eachObject(File self, Closure closure)` Iterates through the given file object by object.
`static void` | `eachObject(ObjectInputStream ois, Closure closure)` Iterates through the given object stream object by object.
`static Object` | `eachWithIndex(Map self, Closure closure)` Allows a Map to be iterated through using a closure.
`static Object` | `eachWithIndex(Object self, Closure closure)` Iterates through an aggregate type or data structure, passing each item and the item's index (a counter starting at zero) to the given closure.
`static Writable` | `encodeBase64(byte[] data)` Produce a Writable object which writes the Base64 encoding of the byte array.
`static Writable` | `encodeBase64(Byte[] data)` Produce a Writable object which writes the Base64 encoding of the byte array.
`static Writable` | `encodeBase64(byte[] data, boolean chunked)` Produce a Writable object which writes the Base64 encoding of the byte array.
`static Writable` | `encodeBase64(Byte[] data, boolean chunked)` Produce a Writable object which writes the Base64 encoding of the byte array.
`static boolean` | `equals(int[] left, int[] right)` Compare the contents of this array to the contents of the given array.
`static boolean` | `equals(List left, List right)` Compare the contents of two Lists.
`static boolean` | `equals(List left, Object[] right)` Determines if the contents of this list are equal to the contents of the given array in the same order.
`static boolean` | `equals(Object[] left, List right)` Determines if the contents of this array are equal to the contents of the given list, in the same order.
`static boolean` | `every(Map self, Closure closure)` Iterates over the entries of a map, and checks whether a predicate is valid for all entries.
`static boolean` | `every(Object self)` Iterates over every element of a collection, and checks whether all elements are `true` according to the Groovy Truth.
`static boolean` | `every(Object self, Closure closure)` Used to determine if the given predicate closure is valid (i.e.
`static Process` | `execute(List commandList)` Executes the command specified by the `String` list that is the parameter.
`static Process` | `execute(String self)` Executes the given string as a command line process.
`static Process` | `execute(String[] commandArray)` Executes the command specified by the `String` array that is the parameter.
`static Process` | `execute(String self, List envp, File dir)` Executes the command specified by the `self` with environments `envp` under the working directory `dir`.
`static Process` | `execute(String self, String[] envp, File dir)` Executes the command specified by the `self` with environments `envp` under the working directory `dir`.
`static Writable` | `filterLine(File self, Closure closure)` Filters the lines of a File and creates a Writeable in return to stream the filtered lines.
`static void` | `filterLine(File self, Writer writer, Closure closure)` Filter the lines from this File, and write them to the given writer based on the given closure predicate.
`static Writable` | `filterLine(InputStream self, Closure predicate)` Filter lines from an input stream using a closure predicate.
`static void` | `filterLine(InputStream self, Writer writer, Closure predicate)` Uses a closure to filter lines from this InputStream and pass them to the given writer.
`static Writable` | `filterLine(Reader reader, Closure closure)` Filter the lines from this Reader, and return a Writable which can be used to stream the filtered lines to a destination.
`static void` | `filterLine(Reader reader, Writer writer, Closure closure)` Filter the lines from a reader and write them on the writer, according to a closure which returns true if the line should be included.
`static Object` | `find(Collection self, Closure closure)` Finds the first value matching the closure condition.
`static Object` | `find(Map self, Closure closure)` Finds the first entry matching the closure condition.
`static Object` | `find(Object self, Closure closure)` Finds the first value matching the closure condition
`static Collection` | `findAll(Collection self, Closure closure)` Finds all values matching the closure condition.
`static Map` | `findAll(Map self, Closure closure)` Finds all entries matching the closure condition.
`static List` | `findAll(Object self, Closure closure)` Finds all items matching the closure condition.
`static int` | `findIndexOf(Object self, Closure closure)` Iterates over the elements of an iterable collection of items and returns the index of the first item that matches the condition specified in the closure.
`static int` | `findIndexOf(Object self, int startIndex, Closure closure)` Iterates over the elements of an iterable collection of items, starting from a specified startIndex, and returns the index of the first item that matches the condition specified in the closure.
`static List` | `findIndexValues(Object self, Closure closure)` Iterates over the elements of an iterable collection of items and returns the index values of the items that match the condition specified in the closure.
`static List` | `findIndexValues(Object self, int startIndex, Closure closure)` Iterates over the elements of an iterable collection of items, starting from a specified startIndex, and returns the index values of the items that match the condition specified in the closure.
`static int` | `findLastIndexOf(Object self, Closure closure)` Iterates over the elements of an iterable collection of items and returns the index of the last item that matches the condition specified in the closure.
`static int` | `findLastIndexOf(Object self, int startIndex, Closure closure)` Iterates over the elements of an iterable collection of items, starting from a specified startIndex, and returns the index of the last item that matches the condition specified in the closure.
`static Object` | `first(List self)` Returns the first item from the List.
`static Collection` | `flatten(Collection self)` Flatten a collection.
`static Collection` | `flatten(Collection self, Closure flattenUsing)` Flatten a collection.
`static String` | `format(Date self, String format)` Return a String representing this date in the given format.
`static Object` | `get(Map map, Object key, Object defaultValue)` Looks up an item in a Map for the given key and returns the value - unless there is no entry for the given key in which case add the default value to the map and return that.
`static boolean` | `getAt(BitSet self, int index)` Support the subscript operator for a Bitset
`static BitSet` | `getAt(BitSet self, IntRange range)` Support retrieving a subset of a BitSet using a Range
`static Object` | `getAt(boolean[] array, Collection indices)` Support the subscript operator with a collection for a boolean array
`static Object` | `getAt(boolean[] array, int index)` Support the subscript operator for a boolean array
`static Object` | `getAt(boolean[] array, IntRange range)` Support the subscript operator with an IntRange for a boolean array
`static Object` | `getAt(boolean[] array, ObjectRange range)` Support the subscript operator with an ObjectRange for a byte array
`static Object` | `getAt(boolean[] array, Range range)` Support the subscript operator with a range for a boolean array
`static Object` | `getAt(byte[] array, Collection indices)` Support the subscript operator with a collection for a byte array
`static Object` | `getAt(byte[] array, int index)` Support the subscript operator for a byte array
`static Object` | `getAt(byte[] array, IntRange range)` Support the subscript operator with an IntRange for a byte array
`static Object` | `getAt(byte[] array, ObjectRange range)` Support the subscript operator with an ObjectRange for a byte array
`static Object` | `getAt(byte[] array, Range range)` Support the subscript operator with a range for a byte array
`static Object` | `getAt(char[] array, Collection indices)` Support the subscript operator with a collection for a char array
`static Object` | `getAt(char[] array, int index)` Support the subscript operator for a char array
`static Object` | `getAt(char[] array, IntRange range)` Support the subscript operator with an IntRange for a char array
`static Object` | `getAt(char[] array, ObjectRange range)` Support the subscript operator with an ObjectRange for a char array
`static Object` | `getAt(char[] array, Range range)` Support the subscript operator with a range for a char array
`static CharSequence` | `getAt(CharSequence self, Collection indices)` Allows a List to be used as the indices to be used on a CharSequence
`static CharSequence` | `getAt(CharSequence text, EmptyRange range)` Support the range subscript operator for CharSequence or StringBuffer with EmptyRange
`static CharSequence` | `getAt(CharSequence text, int index)` Support the subscript operator for CharSequence.
`static CharSequence` | `getAt(CharSequence text, IntRange range)` Support the range subscript operator for CharSequence or StringBuffer with IntRange
`static CharSequence` | `getAt(CharSequence text, Range range)` Support the range subscript operator for CharSequence
`static List` | `getAt(Collection coll, String property)` Support the subscript operator for List
`static int` | `getAt(Date self, int field)` Support the subscript operator for a Date.
`static Object` | `getAt(double[] array, Collection indices)` Support the subscript operator with a collection for a double array
`static Object` | `getAt(double[] array, int index)` Support the subscript operator for a double array
`static Object` | `getAt(double[] array, IntRange range)` Support the subscript operator with an IntRange for a double array
`static Object` | `getAt(double[] array, ObjectRange range)` Support the subscript operator with an ObjectRange for a double array
`static Object` | `getAt(double[] array, Range range)` Support the subscript operator with a range for a double array
`static Object` | `getAt(float[] array, Collection indices)` Support the subscript operator with a collection for a float array
`static Object` | `getAt(float[] array, int index)` Support the subscript operator for a float array
`static Object` | `getAt(float[] array, IntRange range)` Support the subscript operator with an IntRange for a float array
`static Object` | `getAt(float[] array, ObjectRange range)` Support the subscript operator with an ObjectRange for a float array
`static Object` | `getAt(float[] array, Range range)` Support the subscript operator with a range for a float array
`static Object` | `getAt(int[] array, Collection indices)` Support the subscript operator with a collection for an int array
`static Object` | `getAt(int[] array, int index)` Support the subscript operator for an int array
`static Object` | `getAt(int[] array, IntRange range)` Support the subscript operator with an IntRange for an int array
`static Object` | `getAt(int[] array, ObjectRange range)` Support the subscript operator with an ObjectRange for an int array
`static Object` | `getAt(int[] array, Range range)` Support the subscript operator with a range for an int array
`static List` | `getAt(List self, Collection indices)` Allows a List to be used as the indices to be used on a List
`static Object` | `getAt(List self, int idx)` Support the subscript operator for a List.
`static List` | `getAt(List self, IntRange range)` Support the range subscript operator for a List
`static Object` | `getAt(long[] array, Collection indices)` Support the subscript operator with a collection for a long array
`static Object` | `getAt(long[] array, int index)` Support the subscript operator for a long array
`static Object` | `getAt(long[] array, IntRange range)` Support the subscript operator with an IntRange for a long array
`static Object` | `getAt(long[] array, ObjectRange range)` Support the subscript operator with an ObjectRange for a long array
`static Object` | `getAt(long[] array, Range range)` Support the subscript operator with a range for a long array
`static Object` | `getAt(Map self, Object key)` Support the subscript operator for a Map.
`static String` | `getAt(Matcher self, Collection indices)` Allows a List to be used as the indices to be used on a Matcher
`static Object` | `getAt(Matcher matcher, int idx)` Support the subscript operator, e.g.
`static List` | `getAt(Object[] self, Collection indices)` Allows a List to be used as the indices to be used on a List
`static List` | `getAt(Object[] array, EmptyRange range)`
`static Object` | `getAt(Object[] array, int idx)` Support the subscript operator for an Array.
`static List` | `getAt(Object[] array, IntRange range)`
`static List` | `getAt(Object[] array, ObjectRange range)`
`static List` | `getAt(Object[] array, Range range)` Support the range subscript operator for an Array
`static Object` | `getAt(Object self, String property)` Allows the subscript operator to be used to lookup dynamic property values.
`static Object` | `getAt(short[] array, Collection indices)` Support the subscript operator with a collection for a short array
`static Object` | `getAt(short[] array, int index)` Support the subscript operator for a short array
`static Object` | `getAt(short[] array, IntRange range)` Support the subscript operator with an IntRange for a short array
`static Object` | `getAt(short[] array, ObjectRange range)` Support the subscript operator with an ObjectRange for a short array
`static Object` | `getAt(short[] array, Range range)` Support the subscript operator with a range for a short array
`static String` | `getAt(String self, Collection indices)` Allows a List to be used as the indices to be used on a String
`static String` | `getAt(String text, EmptyRange range)` Support the range subscript operator for String with EmptyRange
`static String` | `getAt(String text, int index)` Support the subscript operator for String.
`static String` | `getAt(String text, IntRange range)` Support the range subscript operator for String with IntRange
`static String` | `getAt(String text, Range range)` Support the range subscript operator for String
`static char[]` | `getChars(String self)` Converts the given String into an array of characters.
`static int` | `getCount(Matcher matcher)` Find the number of Strings matched to the given Matcher.
`static String` | `getDateString(Date self)` Return a string representation of the 'day' portion of this date according to the locale-specific format used by `DateFormat`
`static String` | `getDateTimeString(Date self)` Return a string representation of the date and time time portion of this Date instance, according to the locale-specific format used by `DateFormat`.
`static InputStream` | `getErr(Process self)` An alias method so that a process appears similar to System.out, System.in, System.err; you can use process.in, process.out, process.err in a similar fashion.
`static InputStream` | `getIn(Process self)` An alias method so that a process appears similar to System.out, System.in, System.err; you can use process.in, process.out, process.err in a similar fashion.
`static MetaClass` | `getMetaClass(Class c)` Adds a "metaClass" property to all class objects so you can use the syntax `String.metaClass.myMethod = { println "foo" }`
`static MetaClass` | `getMetaClass(Object obj)` Obtains a MetaClass for an object either from the registry or in the case of a GroovyObject from the object itself.
`static List` | `getMetaPropertyValues(Object self)` Retrieves the list of `MetaProperty` objects for 'self' and wraps it in a list of `PropertyValue` objects that additionally provide the value for each property of 'self'.
`static OutputStream` | `getOut(Process self)` An alias method so that a process appears similar to System.out, System.in, System.err; you can use process.in, process.out, process.err in a similar fashion.
`static Map` | `getProperties(Object self)` Convenience method that calls `getMetaPropertyValues(Object)`(self) and provides the data in form of simple key/value pairs, i.e.
`static ClassLoader` | `getRootLoader(ClassLoader self)` Iterates through the classloader parents until it finds a loader with a class named "org.codehaus.groovy.tools.RootLoader".
`protected static List` | `getSubList(List self, List splice)`
`static String` | `getText(BufferedReader reader)` Read the content of the BufferedReader and return it as a String.
`static String` | `getText(File file)` Read the content of the File and returns it as a String.
`static String` | `getText(File file, String charset)` Read the content of the File using the specified encoding and return it as a String.
`static String` | `getText(InputStream is)` Read the content of this InputStream and return it as a String.
`static String` | `getText(InputStream is, String charset)` Read the content of this InputStream using specified charset and return it as a String.
`static String` | `getText(Process self)` Read the text of the output stream of the Process.
`static String` | `getText(Reader reader)` Read the content of the Reader and return it as a String.
`static String` | `getText(URL url)` Read the content of this URL and returns it as a String.
`static String` | `getText(URL url, String charset)` Read the data from this URL and return it as a String.
`static String` | `getTimeString(Date self)` Return a string representation of the time portion of this date according to the locale-specific format used by `DateFormat`
`static Collection` | `grep(Object self, Object filter)` Iterates over every element of the collection and returns each item that matches the given filter - calling the ``isCase(Object,Object)`` method used by switch statements.
`protected static void` | `groupAnswer(Map answer, Object element, Object value)` Groups the current element according to the value
`static Map` | `groupBy(Collection self, Closure closure)` Sorts all collection members into groups determined by the supplied mapping closure.
`static Map` | `groupBy(Map self, Closure closure)` Groups the members of a map into sub maps determined by the supplied mapping closure.
`static Map` | `groupEntriesBy(Map self, Closure closure)` Groups all map entries into groups determined by the supplied mapping closure.
`static boolean` | `hasGroup(Matcher matcher)` Check whether a Matcher contains a group or not.
`static Object` | `head(List self)` Returns the first item from the List.
`static Object` | `identity(Object self, Closure closure)` Allows the closure to be called for the object reference self synonym for 'with()'.
`static Object` | `inject(Collection self, Object value, Closure closure)` Iterates through the given collection, passing in the initial value to the closure along with the current iterated item then passing into the next iteration the value of the previous closure.
`static Object` | `inject(Iterator self, Object value, Closure closure)` Iterates through the given iterator, passing in the initial value to the closure along with the current iterated item then passing into the next iteration the value of the previous closure.
`static Object` | `inject(Object[] self, Object initialValue, Closure closure)` Iterates through the given array of objects, passing in the initial value to the closure along with the current iterated item then passing into the next iteration the value of the previous closure.
`static Object` | `inject(Object self, Object value, Closure closure)` Iterates through the given object, passing in the initial value to the closure along with the current iterated item then passing into the next iteration the value of the previous closure.
`static String` | `inspect(Object self)` Inspects returns the String that matches what would be typed into a terminal to create this object.
`static Number` | `intdiv(Character left, Character right)` Integer Divide two Characters.
`static Number` | `intdiv(Character left, Number right)` Integer Divide a Character by a Number.
`static Number` | `intdiv(Number left, Character right)` Integer Divide a Number by a Character.
`static Number` | `intdiv(Number left, Number right)` Integer Divide two Numbers.
`static Collection` | `intersect(Collection left, Collection right)` Create a Collection composed of the intersection of both collections.
`static Object` | `invokeMethod(Object object, String method, Object arguments)` Provide a dynamic method invocation method which can be overloaded in classes to implement dynamic proxies easily.
`static boolean` | `is(Object self, Object other)` Identity check.
`static boolean` | `isBigDecimal(String self)` Determine if a String can be parsed into a BigDecimal.
`static boolean` | `isBigInteger(String self)` Determine if a String can be parsed into a BigInteger.
`static boolean` | `isCase(Class caseValue, Object switchValue)` Special 'Case' implementation for Class, which allows testing for a certain class in a switch statement.
`static boolean` | `isCase(Collection caseValue, Object switchValue)` 'Case' implementation for collections which tests if the 'switch' operand is contained in any of the 'case' values.
`static boolean` | `isCase(Number caseValue, Number switchValue)` Special 'case' implementation for all numbers, which delegates to the `compareTo()` method for comparing numbers of different types.
`static boolean` | `isCase(Object caseValue, Object switchValue)` Method for overloading the behavior of the 'case' method in switch statements.
`static boolean` | `isCase(Pattern caseValue, Object switchValue)` 'Case' implementation for the `Pattern` class, which allows testing a String against a number of regular expressions.
`static boolean` | `isCase(String caseValue, Object switchValue)` 'Case' implementation for a String, which uses String#equals(Object) in order to allow Strings to be used in switch statements.
`static boolean` | `isDigit(Character self)` Determines if a character is a digit.
`static boolean` | `isDouble(String self)` Determine if a String can be parsed into a Double.
`static boolean` | `isFloat(String self)` Determine if a String can be parsed into a Float.
`static boolean` | `isInteger(String self)` Determine if a String can be parsed into an Integer.
`static boolean` | `isLetter(Character self)` Determines if a character is a letter.
`static boolean` | `isLetterOrDigit(Character self)` Determines if a character is a letter or digit.
`static boolean` | `isLong(String self)` Determine if a String can be parsed into a Long.
`static boolean` | `isLowerCase(Character self)` Determine if a Character is lowercase.
`static boolean` | `isNumber(String self)` Determine if a String can be parsed into a Number.
`static boolean` | `isUpperCase(Character self)` Determine if a Character is uppercase.
`static boolean` | `isWhitespace(Character self)` Determines if a character is a whitespace character.
`static Iterator` | `iterator(DataInputStream self)` Standard iterator for a data input stream which iterates through the stream content a byte at a time.
`static Iterator` | `iterator(Enumeration enumeration)` Allows an Enumeration to behave like an Iterator.
`static Iterator` | `iterator(File self)` Deprecated. use File#eachLine instead please
`static Iterator` | `iterator(InputStream self)` Standard iterator for a input stream which iterates through the stream content in a byte-based fashion.
`static Iterator` | `iterator(Iterator self)` An identity function for iterators, supporting 'duck-typing' when trying to get an iterator for each object within a collection, some of which may already be iterators.
`static Iterator` | `iterator(Matcher matcher)` Retuns an `Iterator` which traverses each match.
`static Iterator` | `iterator(NodeList nodeList)` Makes NodeList iterable by returning a read-only Iterator which traverses over each Node.
`static Iterator` | `iterator(Object o)` Attempts to create an Iterator for the given object by first converting it to a Collection.
`static Iterator` | `iterator(Reader self)` Creates an iterator which will traverse through the reader a line at a time.
`static String` | `join(Collection self, String separator)` Concatenates the `toString()` representation of each item in this collection, with the given String as a separator between each item.
`static String` | `join(Iterator self, String separator)` Concatenates the `toString()` representation of each item from the iterator, with the given String as a separator between each item.
`static String` | `join(Object[] self, String separator)` Concatenates the `toString()` representation of each items in this array, with the given String as a separator between each item.
`static Object` | `last(List self)` Returns the last item from the List.
`static Collection` | `leftShift(Collection self, Object value)` Overloads the left shift operator to provide an easy way to append objects to a Collection.
`static File` | `leftShift(File file, byte[] bytes)` Write bytes to a File.
`static File` | `leftShift(File file, Object text)` Write the text to the File.
`static Map` | `leftShift(Map self, Map.Entry entry)` Overloads the left shift operator to provide an easy way to append Map.Entry values to a Map.
`static Number` | `leftShift(Number self, Number operand)` Implementation of the left shift operator for integral types.
`static void` | `leftShift(ObjectOutputStream self, Object value)` Overloads the leftShift operator to add objects to an ObjectOutputStream.
`static OutputStream` | `leftShift(OutputStream self, byte[] value)` Overloads the leftShift operator to provide an append mechanism to add bytes to a stream.
`static OutputStream` | `leftShift(OutputStream self, InputStream in)` Pipe an InputStream into an OutputStream for efficient stream copying.
`static Writer` | `leftShift(OutputStream self, Object value)` Overloads the leftShift operator to provide an append mechanism to add values to a stream.
`static OutputStream` | `leftShift(Process self, byte[] value)` Overloads the left shift operator to provide an append mechanism to pipe into a Process
`static Writer` | `leftShift(Process self, Object value)` Overloads the left shift operator (<<) to provide an append mechanism to pipe data to a Process.
`static OutputStream` | `leftShift(Socket self, byte[] value)` Overloads the left shift operator to provide an append mechanism to add bytes to the output stream of a socket
`static Writer` | `leftShift(Socket self, Object value)` Overloads the left shift operator to provide an append mechanism to add things to the output stream of a socket
`static StringBuffer` | `leftShift(StringBuffer self, Object value)` Overloads the left shift operator to provide an easy way to append multiple objects as string representations to a StringBuffer.
`static StringBuffer` | `leftShift(String self, Object value)` Overloads the left shift operator to provide an easy way to append multiple objects as string representations to a String.
`static Writer` | `leftShift(Writer self, Object value)` Overloads the left shift operator to provide a mechanism to append values to a writer.
`static Object` | `max(Collection self)` Adds max() method to Collection objects.
`static Object` | `max(Collection self, Closure closure)` Selects the maximum value found in the collection using the given closure as a comparator.
`static Object` | `max(Collection self, Comparator comparator)` Selects the maximum value found in the collection using the given comparator.
`static Object` | `max(Iterator self)` Adds max() method to Iterator objects.
`static Object` | `max(Iterator self, Closure closure)` Selects the maximum value found from the Iterator using the given closure as a comparator.
`static Object` | `max(Iterator self, Comparator comparator)` Selects the maximum value found from the Iterator using the given comparator.
`static Object` | `max(Object[] self)` Adds max() method to Object arrays.
`static Object` | `max(Object[] self, Closure closure)` Selects the maximum value found from the Object array using the given closure as a comparator.
`static Object` | `max(Object[] self, Comparator comparator)` Selects the maximum value found from the Object array using the given comparator.
`static Object` | `min(Collection self)` Adds min() method to Collection objects.
`static Object` | `min(Collection self, Closure closure)` Selects the minimum value found in the collection using the given closure as a comparator.
`static Object` | `min(Collection self, Comparator comparator)` Selects the minimum value found in the collection using the given comparator.
`static Object` | `min(Iterator self)` Adds min() method to Iterator objects.
`static Object` | `min(Iterator self, Closure closure)` Selects the minimum value found from the Iterator using the given closure as a comparator.
`static Object` | `min(Iterator self, Comparator comparator)` Selects the minimum value found from the Iterator using the given comparator.
`static Object` | `min(Object[] self)` Adds min() method to Object arrays.
`static Object` | `min(Object[] self, Closure closure)` Selects the minimum value found from the Object array using the given closure as a comparator.
`static Object` | `min(Object[] self, Comparator comparator)` Selects the minimum value found from the Object array using the given comparator.
`static Number` | `minus(Character left, Character right)` Subtract one Characters from another by converting them both to their Integer representations.
`static Number` | `minus(Character left, Number right)` Subtract a Number from a Character.
`static Date` | `minus(Date self, int days)` Subtract a number of days from this date and returns the new date.
`static Date` | `minus(Date self, int days)` Subtract a number of days from this date and returns the new date.
`static List` | `minus(List self, Collection removeMe)` Create a List composed of the elements of the first list minus the elements of the given collection.
`static List` | `minus(List self, Object operand)` Create a new List composed of the elements of the first list minus the operand.
`static Number` | `minus(Number left, Character right)` Subtract a Character from a Number.
`static Number` | `minus(Number left, Number right)` Substraction of two Numbers.
`static Object[]` | `minus(Object[] self, Collection removeMe)` Create an array composed of the elements of the first array minus the elements of the given collection.
`static Object[]` | `minus(Object[] self, Object operand)` Create a new object array composed of the elements of the first array minus the operand.
`static Object[]` | `minus(Object[] self, Object[] removeMe)` Create an array composed of the elements of the first array minus the elements of the given array.
`static Set` | `minus(Set self, Collection operands)` Create a Set composed of the elements of the first set minus the elements of the given collection.
`static Set` | `minus(Set self, Object operand)` Create a Set composed of the elements of the first set minus the operand.
`static String` | `minus(String self, Object target)` Remove a part of a String.
`static Number` | `mod(Number left, Number right)` Performs a division modulus operation.
`static Number` | `multiply(BigDecimal left, BigInteger right)` Multiply a BigDecimal and a BigInteger.
`static Number` | `multiply(BigDecimal left, Double right)` Multiply a BigDecimal and a Double.
`static Number` | `multiply(Character left, Character right)` Multiply two Characters.
`static Number` | `multiply(Character left, Number right)` Multiply a Character by a Number.
`static List` | `multiply(Collection self, Number factor)` Create a List composed of the elements of this list, repeated a certain number of times.
`static Number` | `multiply(Number left, Character right)` Multiply a Number by a Character.
`static Number` | `multiply(Number left, Number right)` Multiply two Numbers.
`static String` | `multiply(String self, Number factor)` Repeat a String a certain number of times.
`static DataInputStream` | `newDataInputStream(File file)` Create a data input stream for this file
`static DataOutputStream` | `newDataOutputStream(File file)` Creates a new data output stream for this file.
`static BufferedInputStream` | `newInputStream(File file)` Creates a buffered input stream for this file.
`static BufferedInputStream` | `newInputStream(URL url)` Creates a buffered input stream for this URL.
`static Object` | `newInstance(Class c)` Convenience method to dynamically create a new instance of this class.
`static Object` | `newInstance(Class c, Object[] args)` Helper to construct a new instance from the given arguments.
`static ObjectInputStream` | `newObjectInputStream(File file)` Create an object input stream for this file.
`static ObjectOutputStream` | `newObjectOutputStream(File file)` Create an object output stream for this file.
`static BufferedOutputStream` | `newOutputStream(File file)` Create a buffered output stream for this file.
`static PrintWriter` | `newPrintWriter(File file)` Create a new PrintWriter for this file.
`static PrintWriter` | `newPrintWriter(File file, String charset)` Create a new PrintWriter for this file, using specified charset.
`static BufferedReader` | `newReader(File file)` Create a buffered reader for this file.
`static BufferedReader` | `newReader(File file, String charset)` Create a buffered reader for this file, using the specified charset as the encoding.
`static BufferedReader` | `newReader(InputStream self)` Creates a reader for this input stream.
`static BufferedReader` | `newReader(InputStream self, String charset)` Creates a reader for this input stream, using the specified charset as the encoding.
`static BufferedReader` | `newReader(URL url)` Creates a buffered reader for this URL.
`static BufferedReader` | `newReader(URL url, String charset)` Creates a buffered reader for this URL using the given encoding.
`static BufferedWriter` | `newWriter(File file)` Create a buffered writer for this file.
`static BufferedWriter` | `newWriter(File file, boolean append)` Creates a buffered writer for this file, optionally appending to the existing file content.
`static BufferedWriter` | `newWriter(File file, String charset)` Creates a buffered writer for this file, writing data using the given encoding.
`static BufferedWriter` | `newWriter(File file, String charset, boolean append)` Helper method to create a buffered writer for a file.
`static Character` | `next(Character self)` Increment a Character by one.
`static Date` | `next(Date self)` Increment a Date by one day.
`static Date` | `next(Date self)` Increment a java.sql.Date by one day.
`static Number` | `next(Number self)` Increment a Number by one.
`static String` | `next(String self)` This method is called by the ++ operator for the class String.
`static int` | `numberAwareCompareTo(Comparable self, Comparable other)` Provides a method that compares two comparables using Groovy's default number aware comparator.
`static BitSet` | `or(BitSet left, BitSet right)` Bitwise OR together two BitSets.
`static Boolean` | `or(Boolean left, Boolean right)`
`static Number` | `or(Number left, Number right)` Bitwise OR together two numbers.
`static Process` | `or(Process left, Process right)` Overrides the or operator to allow one Process to asynchronously pipe data to another Process.
`static String` | `padLeft(String self, Number numberOfChars)` Pad a String with the spaces appended to the left
`static String` | `padLeft(String self, Number numberOfChars, String padding)` Pad a String with the characters appended to the left
`static String` | `padRight(String self, Number numberOfChars)` Pad a String with the spaces appended to the right
`static String` | `padRight(String self, Number numberOfChars, String padding)` Pad a String with the characters appended to the right
`static Process` | `pipeTo(Process left, Process right)` Allows one Process to asynchronously pipe data to another Process.
`static Number` | `plus(Character left, Character right)` Add two Characters.
`static Number` | `plus(Character left, Number right)` Add a Character and a Number.
`static Collection` | `plus(Collection left, Collection right)` Create a Collection as a union of two collections.
`static Collection` | `plus(Collection left, Object right)` Create a collection as a union of a Collection and an Object.
`static Date` | `plus(Date self, int days)` Add a number of days to this date and returns the new date.
`static Date` | `plus(Date self, int days)` Add a number of days to this date and returns the new date.
`static Map` | `plus(Map left, Map right)` Returns a new Map containing all entries from `left` and `right`, giving precedence to `right`.
`static Number` | `plus(Number left, Character right)` Add a Number and a Character.
`static Number` | `plus(Number left, Number right)` Add two numbers and return the result.
`static String` | `plus(Number value, String right)` Appends a String to the string representation of this number.
`static String` | `plus(StringBuffer left, String value)` Appends a String to this StringBuffer.
`static String` | `plus(String left, Object value)` Appends the String representation of the given operand to this string.
`static Object` | `pop(List self)` Removes the last item from the List.
`static Number` | `power(Number self, Number exponent)` Power of a Number to a certain exponent.
`static Character` | `previous(Character self)` Decrement a Character by one.
`static Date` | `previous(Date self)` Decrement a Date by one day.
`static Date` | `previous(Date self)` Decrement a java.sql.Date by one day.
`static Number` | `previous(Number self)` Decrement a Number by one.
`static String` | `previous(String self)` This method is called by the -- operator for the class String.
`protected static List` | `primitiveArrayGet(Object self, Collection indices)` Implements the getAt(Collection) method for primitve type arrays.
`protected static Object` | `primitiveArrayGet(Object self, int idx)` Implements the getAt(int) method for primitve type arrays.
`protected static List` | `primitiveArrayGet(Object self, Range range)` Implements the getAt(Range) method for primitve type arrays.
`protected static Object` | `primitiveArrayPut(Object self, int idx, Object newValue)` Implements the setAt(int idx) method for primitve type arrays.
`static void` | `print(Closure self, Object value)` Print a value to the standard output stream.
`static void` | `print(Object self, Object value)` Print a value to the standard output stream.
`static void` | `print(Object self, PrintWriter out)` Print to a console in interactive format.
`static void` | `printf(Object self, String format, Object arg)` Prints a formatted string using the specified format string and arguments (Only works with JDK1.5 or later).
`static void` | `printf(Object self, String format, Object[] values)` Printf to a console (Only works with JDK1.5 or later).
`static void` | `println(Closure self)` Print a linebreak to the standard output stream.
`static void` | `println(Closure self, Object value)` Print a value (followed by a newline) to the standard output stream.
`static void` | `println(Object self)` Print a linebreak to the standard output stream.
`static void` | `println(Object self, Object value)` Print a value (followed by a newline) to the standard output stream.
`static void` | `println(Object self, PrintWriter out)` Print to a console in interactive format.
`static boolean` | `push(List self, Object value)` Appends an item to the List.
`static void` | `putAt(BitSet self, int index, boolean value)` Support subscript-style assignment for a BitSet.
`static void` | `putAt(BitSet self, IntRange range, boolean value)` Support assigning a range of values with a single assignment statement.
`static Boolean` | `putAt(boolean[] array, int idx, Boolean newValue)`
`static Byte` | `putAt(byte[] array, int idx, Object newValue)`
`static Character` | `putAt(char[] array, int idx, Object newValue)`
`static Double` | `putAt(double[] array, int idx, Object newValue)`
`static Float` | `putAt(float[] array, int idx, Object newValue)`
`static Integer` | `putAt(int[] array, int idx, Object newValue)`
`static void` | `putAt(List self, EmptyRange range, Object value)` A helper method to allow lists to work with subscript operators.
`static void` | `putAt(List self, int idx, Object value)` A helper method to allow lists to work with subscript operators.
`static void` | `putAt(List self, IntRange range, Collection col)` List subscript assignment operator when given a range as the index and the assignment operand is a collection.
`static void` | `putAt(List self, IntRange range, Object value)` List subscript assignment operator when given a range as the index.
`static void` | `putAt(List self, List splice, List values)` Deprecated. replace with putAt(List self, Range range, List value)
`static void` | `putAt(List self, List splice, Object value)` Deprecated. replace with putAt(List self, Range range, Object value)
`static Long` | `putAt(long[] array, int idx, Object newValue)`
`static Object` | `putAt(Map self, Object key, Object value)` A helper method to allow lists to work with subscript operators
`static void` | `putAt(Object[] array, int idx, Object value)` Support the subscript operator for an Array.
`static void` | `putAt(Object self, String property, Object newValue)` Allows the subscript operator to be used to set dynamically named property values.
`static Short` | `putAt(short[] array, int idx, Object newValue)`
`static void` | `putAt(StringBuffer self, EmptyRange range, Object value)` Support the range subscript operator for StringBuffer.
`static void` | `putAt(StringBuffer self, IntRange range, Object value)` Support the range subscript operator for StringBuffer.
`static byte[]` | `readBytes(File file)` Reads the content of the file into a byte array.
`static String` | `readLine(InputStream stream)` Deprecated. use Reader#readLine instead please
`static String` | `readLine(Reader self)` Read a single, whole line from the given Reader.
`static List` | `readLines(File file)` Reads the file into a list of Strings, with one item for each line.
`static List` | `readLines(InputStream stream)` Reads the stream into a list, with one element for each line.
`static List` | `readLines(Reader reader)` Reads the reader into a list of Strings, with one entry for each line.
`static List` | `readLines(String self)` Return the lines of a String as a List of Strings.
`static String` | `replaceAll(String self, String regex, Closure closure)` Replaces all occurrencies of a captured group by the result of a closure on that text.
`static Iterator` | `reverse(Iterator self)` Reverses the iterator.
`static List` | `reverse(List self)` Reverses the list.
`static Object[]` | `reverse(Object[] self)` Reverse the items in an Object array.
`static String` | `reverse(String self)` Creates a new string which is the reverse (backwards) of this string
`static List` | `reverseEach(List self, Closure closure)` Iterate over each element of the list in the reverse order.
`static Object[]` | `reverseEach(Object[] self, Closure closure)` Iterate over each element of the array in the reverse order.
`static Number` | `rightShift(Number self, Number operand)` Implementation of the right shift operator for integral types.
`static Number` | `rightShiftUnsigned(Number self, Number operand)` Implementation of the right shift (unsigned) operator for integral types.
`static long` | `round(Double number)` Round the value
`static int` | `round(Float number)` Get the absolute value
`static TimerTask` | `runAfter(Timer timer, int delay, Closure closure)` Allows a simple syntax for using timers.
`static void` | `setIndex(Matcher matcher, int idx)` Set the position of the given Matcher to the given index.
`static void` | `setText(File file, String text)` Synonym for write(text) allowing file.text = 'foo'.
`static int` | `size(boolean[] array)` Allows arrays to behave similar to collections.
`static int` | `size(byte[] array)` Allows arrays to behave similar to collections.
`static int` | `size(char[] array)` Allows arrays to behave similar to collections.
`static int` | `size(double[] array)` Allows arrays to behave similar to collections.
`static long` | `size(File self)` Provide the standard Groovy `size()` method for `File`.
`static int` | `size(float[] array)` Allows arrays to behave similar to collections.
`static int` | `size(int[] array)` Allows arrays to behave similar to collections.
`static int` | `size(Iterator self)` Provide the standard Groovy `size()` method for `Iterator`.
`static int` | `size(long[] array)` Allows arrays to behave similar to collections.
`static long` | `size(Matcher self)` Provide the standard Groovy `size()` method for `Matcher`.
`static int` | `size(Object[] self)` Provide the standard Groovy `size()` method for an array.
`static int` | `size(short[] array)` Allows arrays to behave similar to collections.
`static int` | `size(String text)` Provide the standard Groovy `size()` method for `String`.
`static int` | `size(StringBuffer buffer)` Provide the standard Groovy `size()` method for `StringBuffer`.
`static List` | `sort(Collection self)` Sorts the given collection into a sorted list.
`static List` | `sort(Collection self, Closure closure)` Sorts this Collection using the given closure as a comparator.
`static List` | `sort(Collection self, Comparator comparator)` Sorts the Collection using the given comparator.
`static Iterator` | `sort(Iterator self)` Sorts the given iterator items into a sorted iterator.
`static Iterator` | `sort(Iterator self, Closure closure)` Sorts the given iterator items into a sorted iterator using the closure as a comparator.
`static Iterator` | `sort(Iterator self, Comparator comparator)` Sorts the given iterator items into a sorted iterator using the comparator.
`static Map` | `sort(Map self, Closure closure)` Sorts the given map into a sorted map using the closure as a comparator.
`static Object[]` | `sort(Object[] self)` Sorts the given Object array into sorted order.
`static Object[]` | `sort(Object[] self, Closure closure)` Sorts the given Object array into a newly created array using the given comparator.
`static Object[]` | `sort(Object[] self, Comparator comparator)` Sorts the given Object array into sorted order using the given comparator.
`static SortedSet` | `sort(SortedSet self)` Avoids doing unnecessary work when sorting an already sorted set.
`static String[]` | `split(String self)` Convenience method to split a string (with whitespace as delimiter) Like tokenize, but returns an Array of Strings instead of a List
`static Object` | `splitEachLine(File self, String sep, Closure closure)` Iterates through this file line by line, splitting on the seperator.
`static Object` | `splitEachLine(InputStream stream, String sep, Closure closure)` Iterates through the given InputStream line by line, splitting each line using the given separator.
`static Object` | `splitEachLine(InputStream stream, String sep, String charset, Closure closure)` Iterates through the given InputStream line by line using the specified encoding, splitting each line using the given separator.
`static Object` | `splitEachLine(Reader self, String sep, Closure closure)` Iterates through the given reader line by line, splitting each line using the given separator.
`static Object` | `splitEachLine(String self, String sep, Closure closure)` Iterates through the given String line by line, splitting each line using the given separator.
`static SpreadMap` | `spread(Map self)` Synonym for `toSpreadMap(Map)`.
`static String` | `sprintf(Object self, String format, Object arg)` Returns a formatted string using the specified format string and arguments.
`static String` | `sprintf(Object self, String format, Object[] values)` Sprintf to a string (Only works with JDK1.5 or later).
`static void` | `step(Number self, Number to, Number stepNumber, Closure closure)` Iterates from this number up to the given number using a step increment.
`static Map` | `subMap(Map map, Collection keys)` Creates a sub-Map containing the given keys.
`static Object` | `sum(Collection self)` Sums the items in a collection.
`static Object` | `sum(Collection self, Closure closure)` Sums the result of apply a closure to each item of a collection.
`static Object` | `sum(Collection self, Object initialValue)` Sums the items in a collection, adding the result to some initial value.
`static Object` | `sum(Collection self, Object initialValue, Closure closure)` Sums the result of apply a closure to each item of a collection to sum intial value.
`static Object` | `sum(Iterator self)` Sums the items from an Iterator.
`static Object` | `sum(Iterator self, Object initialValue)` Sums the items from an Iterator.
`static List` | `tail(List self)` Returns the items from the List excluding the first item.
`static void` | `times(Number self, Closure closure)` Executes the closure this many times, starting from zero.
`static String` | `toArrayString(Object[] self)` Returns the string representation of the given array.
`static BigDecimal` | `toBigDecimal(Number self)` Transform a Number into a BigDecimal
`static BigDecimal` | `toBigDecimal(String self)` Parse a String into a BigDecimal
`static BigInteger` | `toBigInteger(Number self)` Transform this Number into a BigInteger.
`static BigInteger` | `toBigInteger(String self)` Parse a String into a BigInteger
`static Boolean` | `toBoolean(String self)` Converts the given string into a Boolean object.
`static Character` | `toCharacter(String self)` Converts the given string into a Character object using the first character in the string.
`static Double` | `toDouble(Number self)` Transform a Number into a Double
`static Double` | `toDouble(String self)` Parse a String into a Double
`static Float` | `toFloat(Number self)` Transform a Number into a Float
`static Float` | `toFloat(String self)` Parse a String into a Float
`static Integer` | `toInteger(Number self)` Transform a Number into an Integer
`static Integer` | `toInteger(String self)` Parse a String into an Integer
`static List` | `tokenize(String self)` Tokenize a String (with a whitespace as the delimiter).
`static List` | `tokenize(String self, String token)` Tokenize a String based on the given string delimiter.
`static List` | `toList(byte[] array)` Converts this array to a List of the same size, with each element added to the list.
`static List` | `toList(char[] array)` Converts this array to a List of the same size, with each element added to the list.
`static List` | `toList(Collection self)` Convert a collection to a List.
`static List` | `toList(double[] array)` Converts this array to a List of the same size, with each element added to the list.
`static List` | `toList(Enumeration self)` Convert an enumeration to a List.
`static List` | `toList(float[] array)` Converts this array to a List of the same size, with each element added to the list.
`static List` | `toList(int[] array)` Converts this array to a List of the same size, with each element added to the list.
`static List` | `toList(Iterator self)` Convert an iterator to a List.
`static List` | `toList(long[] array)` Converts this array to a List of the same size, with each element added to the list.
`static List` | `toList(Object[] array)` Allows conversion of arrays into a mutable List.
`static List` | `toList(short[] array)` Converts this array to a List of the same size, with each element added to the list.
`static List` | `toList(String self)` Converts the given String into a List of strings of one character.
`static String` | `toListString(Collection self)` Returns the string representation of the given list.
`static Long` | `toLong(Number self)` Transform a Number into a Long
`static Long` | `toLong(String self)` Parse a String into a Long
`static char` | `toLowerCase(Character self)` Converts the character to lowercase.
`static String` | `toMapString(Map self)` Returns the string representation of this map.
`static GroovyRowResult` | `toRowResult(ResultSet rs)` Returns a GroovyRowResult given a ResultSet.
`static Short` | `toShort(String self)` Parse a String into a Short
`static SpreadMap` | `toSpreadMap(Map self)` Returns a new `SpreadMap` from this map.
`static SpreadMap` | `toSpreadMap(Object[] self)` Creates a spreadable map from this array.
`static String` | `toString(Collection self)` Returns the string representation of the given collection.
`static String` | `toString(Map self)` Returns the string representation of the given map.
`protected static String` | `toString(Object value)` Create a String representation of this object.
`static String` | `toString(Object[] self)` Returns the string representation of this array's contents.
`static char` | `toUpperCase(Character self)` Converts the character to uppercase.
`static URI` | `toURI(String self)` Transforms a String representing a URI into a URI object.
`static URL` | `toURL(String self)` Transforms a String representing a URL into a URL object.
`static void` | `transformChar(Reader self, Writer writer, Closure closure)` Transforms each character from this reader by passing it to the given closure.
`static void` | `transformLine(Reader reader, Writer writer, Closure closure)` Transforms the lines from a reader with a Closure and write them to a writer.
`static List` | `transpose(Collection self)` Adds GroovyCollections#transpose(Collection) as a method on collections.
`static Number` | `unaryMinus(Number left)` Negates the number.
`static Collection` | `unique(Collection self)` Modifies this collection to remove all duplicated items, using the default comparator.
`static Collection` | `unique(Collection self, Closure closure)` A convenience method for making a collection unique using a closure as a comparator.
`static Collection` | `unique(Collection self, Comparator comparator)` Remove all duplicates from a given Collection.
`static Iterator` | `unique(Iterator self)` Returns an iterator equivalent to this iterator all duplicated items removed by using the default comparator.
`static Iterator` | `unique(Iterator self, Closure closure)` Returns an iterator equivalent to this iterator all duplicated items removed by using a closure as a comparator.
`static Iterator` | `unique(Iterator self, Comparator comparator)` Returns an iterator equivalent to this iterator with all duplicated items removed by using the supplied comparator.
`static void` | `upto(BigDecimal self, Number to, Closure closure)` Iterates from this number up to the given number, inclusive, incrementing by one each time.
`static void` | `upto(BigInteger self, Number to, Closure closure)` Iterates from this number up to the given number, inclusive, incrementing by one each time.
`static void` | `upto(double self, Number to, Closure closure)` Iterates from this number up to the given number, inclusive, incrementing by one each time.
`static void` | `upto(Double self, Number to, Closure closure)` Iterates from this number up to the given number, inclusive, incrementing by one each time.
`static void` | `upto(float self, Number to, Closure closure)` Iterates from this number up to the given number, inclusive, incrementing by one each time.
`static void` | `upto(Float self, Number to, Closure closure)` Iterates from this number up to the given number, inclusive, incrementing by one each time.
`static void` | `upto(long self, Number to, Closure closure)` Iterates from this number up to the given number, inclusive, incrementing by one each time.
`static void` | `upto(Long self, Number to, Closure closure)` Iterates from this number up to the given number, inclusive, incrementing by one each time.
`static void` | `upto(Number self, Number to, Closure closure)` Iterates from this number up to the given number, inclusive, incrementing by one each time.
`static Object` | `use(Object self, Class categoryClass, Closure closure)` Scoped use method
`static Object` | `use(Object self, List categoryClassList, Closure closure)` Scoped use method with list of categories.
`static Object` | `use(Object self, Object[] array)` Allows you to use a list of categories, specifying the list as varargs.
`static void` | `waitForOrKill(Process self, long numberOfMillis)` Wait for the process to finish during a certain amount of time, otherwise stops the process.
`static Object` | `with(Object self, Closure closure)` Allows the closure to be called for the object reference self
`static Object` | `withDataInputStream(File file, Closure closure)` Create a new DataInputStream for this file and passes it into the closure.
`static Object` | `withDataOutputStream(File file, Closure closure)` Create a new DataOutputStream for this file and passes it into the closure.
`static Object` | `withInputStream(File file, Closure closure)` Create a new InputStream for this file and passes it into the closure.
`static Object` | `withInputStream(URL url, Closure closure)` Creates a new InputStream for this URL and passes it into the closure.
`static Object` | `withObjectInputStream(File file, Closure closure)` Create a new ObjectInputStream for this file and pass it to the closure.
`static Object` | `withObjectOutputStream(File file, Closure closure)` Create a new ObjectOutputStream for this file and then pass it to the closure.
`static Object` | `withObjectStreams(Socket socket, Closure closure)` Creates an InputObjectStream and an OutputObjectStream from a Socket, and passes them to the closure.
`static Object` | `withOutputStream(File file, Closure closure)` Creates a new OutputStream for this file and passes it into the closure.
`static void` | `withOutputStream(Process self, Closure closure)` Creates a new buffered OutputStream as stdin for this process, passes it to the closure, and ensures the stream is flushed and closed after the closure returns.
`static Object` | `withPrintWriter(File file, Closure closure)` Create a new PrintWriter for this file which is then passed it into the given closure.
`static Object` | `withPrintWriter(File file, String charset, Closure closure)` Create a new PrintWriter with a specified charset for this file.
`static Object` | `withReader(File file, Closure closure)` Create a new BufferedReader for this file and then passes it into the closure, ensuring the reader is closed after the closure returns.
`static Object` | `withReader(File file, String charset, Closure closure)` Create a new BufferedReader for this file using the specified charset and then passes it into the closure, ensuring the reader is closed after the closure returns.
`static Object` | `withReader(InputStream in, Closure closure)` Helper method to create a new Reader for a stream and then passes it into the closure.
`static Object` | `withReader(InputStream in, String charset, Closure closure)` Helper method to create a new Reader for a stream and then passes it into the closure.
`static Object` | `withReader(Reader reader, Closure closure)` Allows this reader to be used within the closure, ensuring that it is closed before this method returns.
`static Object` | `withReader(URL url, Closure closure)` Helper method to create a new BufferedReader for a URL and then passes it to the closure.
`static Object` | `withReader(URL url, String charset, Closure closure)` Helper method to create a new Reader for a URL and then passes it to the closure.
`static Object` | `withStream(InputStream stream, Closure closure)` Allows this input stream to be used within the closure, ensuring that it is flushed and closed before this method returns.
`static Object` | `withStream(OutputStream os, Closure closure)` Passes this OutputStream to the closure, ensuring that the stream is closed after the closure returns, regardless of errors.
`static Object` | `withStreams(Socket socket, Closure closure)` Passes the Socket's InputStream and OutputStream to the closure.
`static Object` | `withWriter(File file, Closure closure)` Creates a new BufferedWriter for this file, passes it to the closure, and ensures the stream is flushed and closed after the closure returns.
`static Object` | `withWriter(File file, String charset, Closure closure)` Creates a new BufferedWriter for this file, passes it to the closure, and ensures the stream is flushed and closed after the closure returns.
`static Object` | `withWriter(OutputStream stream, Closure closure)` Creates a writer from this stream, passing it to the given closure.
`static Object` | `withWriter(OutputStream stream, String charset, Closure closure)` Creates a writer from this stream, passing it to the given closure.
`static void` | `withWriter(Process self, Closure closure)` Creates a new BufferedWriter as stdin for this process, passes it to the closure, and ensures the stream is flushed and closed after the closure returns.
`static Object` | `withWriter(Writer writer, Closure closure)` Allows this writer to be used within the closure, ensuring that it is flushed and closed before this method returns.
`static Object` | `withWriterAppend(File file, Closure closure)` Create a new BufferedWriter for this file in append mode.
`static Object` | `withWriterAppend(File file, String charset, Closure closure)` Create a new BufferedWriter which will append to this file.
`static void` | `write(File file, String text)` Write the text to the File.
`static void` | `write(File file, String text, String charset)` Write the text to the File, using the specified encoding.
`static void` | `write(Writer self, Writable writable)` A helper method so that dynamic dispatch of the writer.write(object) method will always use the more efficient Writable.writeTo(writer) mechanism if the object implements the Writable interface.
`static void` | `writeLine(BufferedWriter writer, String line)` Write the text and append a newline (using the platform's line-ending).
`static BitSet` | `xor(BitSet left, BitSet right)` Bitwise XOR together two BitSets.
`static Boolean` | `xor(Boolean left, Boolean right)`
`static Number` | `xor(Number left, Number right)` Bitwise XOR together two Numbers.

Methods inherited from class org.codehaus.groovy.runtime.DefaultGroovyMethodsSupport
`cloneSimilarCollection, cloneSimilarMap, createSimilarCollection, createSimilarCollection, createSimilarList, createSimilarOrDefaultCollection, createSimilarSet, normaliseIndex, sameType, subListBorders, subListBorders`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DefaultGroovyMethods

    public DefaultGroovyMethods()

Method Detail

### is

    public static boolean is(Object self,
                             Object other)

  Identity check. Since == is overridden in Groovy with the meaning of equality we need some fallback to check for object identity. Invoke using the 'is' operator, like so: `def same = (this is that)`

  Parameters:
    `self` - an object
    `other` - an object to compare identity with
  Returns:
    true if self and other are both references to the same instance, false otherwise

### identity

    public static Object identity(Object self,
                                  Closure closure)

  Allows the closure to be called for the object reference self synonym for 'with()'.

  Parameters:
    `self` - the object to have a closure act upon
    `closure` - the closure to call on the object
  Returns:
    result of calling the closure

### with

    public static Object with(Object self,
                              Closure closure)

  Allows the closure to be called for the object reference self

  Parameters:
    `self` - the object to have a closure act upon
    `closure` - the closure to call on the object
  Returns:
    result of calling the closure

### getAt

    public static Object getAt(Object self,
                               String property)

  Allows the subscript operator to be used to lookup dynamic property values. `bean[somePropertyNameExpression]`. The normal property notation of groovy is neater and more concise but only works with compile-time known property names.

  Parameters:
    `self` - the object to act upon
    `property` - the property name of interest
  Returns:
    the property value

### putAt

    public static void putAt(Object self,
                             String property,
                             Object newValue)

  Allows the subscript operator to be used to set dynamically named property values. `bean[somePropertyNameExpression] = foo`. The normal property notation of groovy is neater and more concise but only works with property names which are known at compile time.

  Parameters:
    `self` - the object to act upon
    `property` - the name of the property to set
    `newValue` - the value to set

### dump

    public static String dump(Object self)

  Generates a detailed dump string of an object showing its class, hashCode and fields.

  Parameters:
    `self` - an object
  Returns:
    the dump representation

### getMetaPropertyValues

    public static List getMetaPropertyValues(Object self)

  Retrieves the list of `MetaProperty` objects for 'self' and wraps it in a list of `PropertyValue` objects that additionally provide the value for each property of 'self'.

  Parameters:
    `self` - the receiver object
  Returns:
    list of `PropertyValue` objects
  See Also:
    `Expando.getMetaPropertyValues()`

### getProperties

    public static Map getProperties(Object self)

  Convenience method that calls `getMetaPropertyValues(Object)`(self) and provides the data in form of simple key/value pairs, i.e.&nsbp;without type() information.

  Parameters:
    `self` - the receiver object
  Returns:
    meta properties as Map of key/value pairs

### use

    public static Object use(Object self,
                             Class categoryClass,
                             Closure closure)

  Scoped use method

  Parameters:
    `self` - any Object
    `categoryClass` - a category class to use
    `closure` - the closure to invoke with the category in place
  Returns:
    the value returned from the closure

### use

    public static Object use(Object self,
                             List categoryClassList,
                             Closure closure)

  Scoped use method with list of categories.

  Parameters:
    `self` - any Object
    `categoryClassList` - a list of category classes
    `closure` - the closure to invoke with the categories in place
  Returns:
    the value returned from the closure

### addShutdownHook

    public static void addShutdownHook(Object self,
                                       Closure closure)

  Allows the usage of addShutdownHook without getting the runtime first.

  Parameters:
    `self` - the object the method is called on (ignored)
    `closure` - the shutdown hook action

### use

    public static Object use(Object self,
                             Object[] array)

  Allows you to use a list of categories, specifying the list as varargs. `use(CategoryClass1, CategoryClass2) { ... }` This method saves having to wrap the the category classes in a list.

  Parameters:
    `self` - any Object
    `array` - a list of category classes and a Closure
  Returns:
    the value returned from the closure

### print

    public static void print(Object self,
                             Object value)

  Print a value to the standard output stream.

  Parameters:
    `self` - any Object
    `value` - the value to print

### print

    public static void print(Closure self,
                             Object value)

  Print a value to the standard output stream. This method delegates to the owner to execute the method.

  Parameters:
    `self` - a generated closure
    `value` - the value to print

### println

    public static void println(Object self)

  Print a linebreak to the standard output stream.

  Parameters:
    `self` - any Object

### println

    public static void println(Closure self)

  Print a linebreak to the standard output stream. This method delegates to the owner to execute the method.

  Parameters:
    `self` - a closure

### println

    public static void println(Object self,
                               Object value)

  Print a value (followed by a newline) to the standard output stream.

  Parameters:
    `self` - any Object
    `value` - the value to print

### println

    public static void println(Closure self,
                               Object value)

  Print a value (followed by a newline) to the standard output stream. This method delegates to the owner to execute the method.

  Parameters:
    `self` - a closure
    `value` - the value to print

### printf

    public static void printf(Object self,
                              String format,
                              Object[] values)

  Printf to a console (Only works with JDK1.5 or later).

  Parameters:
    `self` - any Object
    `format` - a format string
    `values` - values referenced by the format specifiers in the format string.

### sprintf

    public static String sprintf(Object self,
                                 String format,
                                 Object[] values)

  Sprintf to a string (Only works with JDK1.5 or later).

  Parameters:
    `self` - any Object
    `format` - a format string
    `values` - values referenced by the format specifiers in the format string.
  Returns:
    the resulting formatted string

### printf

    public static void printf(Object self,
                              String format,
                              Object arg)

  Prints a formatted string using the specified format string and arguments (Only works with JDK1.5 or later).

  For examples,

           printf ( "Hello, %s!\n" , [ "world" ] as String[] )
           printf ( "Hello, %s!\n" , [ "Groovy" ])
           printf ( "%d + %d = %d\n" , [ 1 , 2 , 1+2 ] as Integer[] )
           printf ( "%d + %d = %d\n" , [ 3 , 3 , 3+3 ])

           ( 1..5 ).each { printf ( "-- %d\n" , [ it ] as Integer[] ) }
           ( 1..5 ).each { printf ( "-- %d\n" , [ it ] as int[] ) }
           ( 0x41..0x45 ).each { printf ( "-- %c\n" , [ it ] as char[] ) }
           ( 07..011 ).each { printf ( "-- %d\n" , [ it ] as byte[] ) }
           ( 7..11 ).each { printf ( "-- %d\n" , [ it ] as short[] ) }
           ( 7..11 ).each { printf ( "-- %d\n" , [ it ] as long[] ) }
           ( 7..11 ).each { printf ( "-- %5.2f\n" , [ it ] as float[] ) }
           ( 7..11 ).each { printf ( "-- %5.2g\n" , [ it ] as double[] ) }

  Parameters:
    `self` - any Object
    `format` - A format string
    `arg` - Argument which is referenced by the format specifiers in the format string. The type of `arg` should be one of Object[], List, int[], short[], byte[], char[], boolean[], long[], float[], or double[].

### sprintf

    public static String sprintf(Object self,
                                 String format,
                                 Object arg)

  Returns a formatted string using the specified format string and arguments.

  TODO: remove duplication with printf

  Parameters:
    `self` - any Object
    `format` - A format string
    `arg` - Argument which is referenced by the format specifiers in the format string. The type of `arg` should be one of Object[], List, int[], short[], byte[], char[], boolean[], long[], float[], or double[].
  Returns:
    the resulting printf'd string

### inspect

    public static String inspect(Object self)

  Inspects returns the String that matches what would be typed into a terminal to create this object.

  Parameters:
    `self` - any Object
  Returns:
    a String that matches what would be typed into a terminal to create this object. e.g. [1, 'hello'].inspect() -> [1, "hello"]

### print

    public static void print(Object self,
                             PrintWriter out)

  Print to a console in interactive format.

  Parameters:
    `self` - any Object
    `out` - the PrintWriter used for printing

### println

    public static void println(Object self,
                               PrintWriter out)

  Print to a console in interactive format.

  Parameters:
    `self` - any Object
    `out` - the PrintWriter used for printing

### invokeMethod

    public static Object invokeMethod(Object object,
                                      String method,
                                      Object arguments)

  Provide a dynamic method invocation method which can be overloaded in classes to implement dynamic proxies easily.

  Parameters:
    `object` - any Object
    `method` - the name of the method to call
    `arguments` - the arguments to use
  Returns:
    the result of the method call

### isCase

    public static boolean isCase(Object caseValue,
                                 Object switchValue)

  Method for overloading the behavior of the 'case' method in switch statements. The default implementation handles arrays types but otherwise simply delegates to Object#equals, but this may be overridden for other types. In this example:

       switch( a ) {
         case b: //some code
       }

  "some code" is called when `b.isCase( a )` returns `true`.

  Parameters:
    `caseValue` - the case value
    `switchValue` - the switch value
  Returns:
    true if the switchValue is deemed to be equal to the caseValue

### isCase

    public static boolean isCase(String caseValue,
                                 Object switchValue)

  'Case' implementation for a String, which uses String#equals(Object) in order to allow Strings to be used in switch statements. For example:

      switch( str ) {
         case 'one' :
         // etc...
       }

  Note that this returns `true` for the case where both the 'switch' and 'case' operand is `null`.

  Parameters:
    `caseValue` - the case value
    `switchValue` - the switch value
  Returns:
    true if the switchValue's toString() equals the caseValue

### isCase

    public static boolean isCase(Class caseValue,
                                 Object switchValue)

  Special 'Case' implementation for Class, which allows testing for a certain class in a switch statement. For example:

      switch( obj ) {
         case List :
           // obj is a list
           break;
         case Set :
           // etc
       }

  Parameters:
    `caseValue` - the case value
    `switchValue` - the switch value
  Returns:
    true if the switchValue is deemed to be assignable from the given class

### isCase

    public static boolean isCase(Collection caseValue,
                                 Object switchValue)

  'Case' implementation for collections which tests if the 'switch' operand is contained in any of the 'case' values. For example:

      switch( item ) {
         case firstList :
           // item is contained in this list
           // etc
       }

  Parameters:
    `caseValue` - the case value
    `switchValue` - the switch value
  Returns:
    true if the caseValue is deemed to contain the switchValue
  See Also:
    `Collection.contains(Object)`

### isCase

    public static boolean isCase(Pattern caseValue,
                                 Object switchValue)

  'Case' implementation for the `Pattern` class, which allows testing a String against a number of regular expressions. For example:

      switch( str ) {
         case ~/one/ :
           // the regex 'one' matches the value of str
       }

  Note that this returns true for the case where both the pattern and the 'switch' values are `null`.

  Parameters:
    `caseValue` - the case value
    `switchValue` - the switch value
  Returns:
    true if the switchValue is deemed to match the caseValue

### isCase

    public static boolean isCase(Number caseValue,
                                 Number switchValue)

  Special 'case' implementation for all numbers, which delegates to the `compareTo()` method for comparing numbers of different types.

  Parameters:
    `caseValue` - the case value
    `switchValue` - the switch value
  Returns:
    true if the numbers are deemed equal

### unique

    public static Iterator unique(Iterator self)

  Returns an iterator equivalent to this iterator all duplicated items removed by using the default comparator. The original iterator will become exhausted of elements after determining the unique values. A new iterator for the unique values will be returned.

  Parameters:
    `self` - an Iterator
  Returns:
    the modified Iterator

### unique

    public static Collection unique(Collection self)

  Modifies this collection to remove all duplicated items, using the default comparator.

  Parameters:
    `self` - a collection
  Returns:
    the now modified collection

### numberAwareCompareTo

    public static int numberAwareCompareTo(Comparable self,
                                           Comparable other)

  Provides a method that compares two comparables using Groovy's default number aware comparator.

  Parameters:
    `self` - a Comparable
    `other` - another Comparable
  Returns:
    a -ve number, 0 or a +ve number according to Groovy's compareTo contract

### unique

    public static Iterator unique(Iterator self,
                                  Closure closure)

  Returns an iterator equivalent to this iterator all duplicated items removed by using a closure as a comparator. If the closure takes a single parameter, the argument passed will be each element, and the closure should return a value used for comparison (either using `Comparable.compareTo(Object)` or Object#equals() ).

  Parameters:
    `self` - an Iterator
    `closure` - a Closure used as a comparator
  Returns:
    the modified Iterator

### unique

    public static Collection unique(Collection self,
                                    Closure closure)

  A convenience method for making a collection unique using a closure as a comparator. If the closure takes a single parameter, the argument passed will be each element, and the closure should return a value used for comparison (either using `Comparable.compareTo(Object)` or Object#equals() ). If the closure takes two parameters, two items from the collection will be passed as arguments, and the closure should return an int value (with 0 indicating the items are not unique).

  Parameters:
    `self` - a Collection
    `closure` - a Closure used as a comparator
  Returns:
    self without any duplicates

### unique

    public static Iterator unique(Iterator self,
                                  Comparator comparator)

  Returns an iterator equivalent to this iterator with all duplicated items removed by using the supplied comparator.

  Parameters:
    `self` - an Iterator
    `comparator` - a Comparator
  Returns:
    the modified Iterator

### unique

    public static Collection unique(Collection self,
                                    Comparator comparator)

  Remove all duplicates from a given Collection. Works on the receiver object and returns it. The order of members in the Collection are compared by the given Comparator. For each duplicate, the first member which is returned by the given Collection's iterator is retained, but all other ones are removed. The given Collection's original order is preserved.

  `

           class Person {
               def fname, lname
               public String toString() {
                   return fname + " " + lname
               }
           }

           class PersonComparator implements Comparator {
               public int compare(Object o1, Object o2) {
                   Person p1 = (Person) o1
                   Person p2 = (Person) o2
                   if (p1.lname != p2.lname)
                       return p1.lname.compareTo(p2.lname)
                   else
                       return p1.fname.compareTo(p2.fname)
               }

               public boolean equals(Object obj) {
                   return this.equals(obj)
               }
           }

           Person a = new Person(fname:"John", lname:"Taylor")
           Person b = new Person(fname:"Clark", lname:"Taylor")
           Person c = new Person(fname:"Tom", lname:"Cruz")
           Person d = new Person(fname:"Clark", lname:"Taylor")

           def list = [a, b, c, d]
           List list2 = list.unique(new PersonComparator())
           assert( list2 == list && list == [a, b, c] )

  `

  Parameters:
    `self` - a Collection
    `comparator` - a Comparator
  Returns:
    self the now modified collection without duplicates

### each

    public static Object each(Object self,
                              Closure closure)

  Iterates through an aggregate type or data structure, passing each item to the given closure. Custom types may utilize this method by simply providing an "iterator()" method. The items returned from the resulting iterator will be passed to the closure.

  Parameters:
    `self` - the object over which we iterate
    `closure` - the closure applied on each element found
  Returns:
    the self Object

### eachWithIndex

    public static Object eachWithIndex(Object self,
                                       Closure closure)

  Iterates through an aggregate type or data structure, passing each item and the item's index (a counter starting at zero) to the given closure.

  Parameters:
    `self` - an Object
    `closure` - a Closure to operate on each item
  Returns:
    the self Object

### each

    public static Map each(Map self,
                           Closure closure)

  Allows a Map to be iterated through using a closure. If the closure takes one parameter then it will be passed the Map.Entry otherwise if the closure takes two parameters then it will be passed the key and the value.

  Parameters:
    `self` - the map over which we iterate
    `closure` - the closure applied on each entry of the map
  Returns:
    returns the self parameter

### eachWithIndex

    public static Object eachWithIndex(Map self,
                                       Closure closure)

  Allows a Map to be iterated through using a closure. If the closure takes two parameters then it will be passed the Map.Entry and the item's index (a counter starting at zero) otherwise if the closure takes three parameters then it will be passed the key, the value, and the index.

  Parameters:
    `self` - the map over which we iterate
    `closure` - a Closure to operate on each item
  Returns:
    the self Object

### reverseEach

    public static List reverseEach(List self,
                                   Closure closure)

  Iterate over each element of the list in the reverse order.

  Parameters:
    `self` - a List
    `closure` - a closure to which each item is passed.
  Returns:
    the original list

### reverseEach

    public static Object[] reverseEach(Object[] self,
                                       Closure closure)

  Iterate over each element of the array in the reverse order.

  Parameters:
    `self` - an Object array
    `closure` - a closure to which each item is passed
  Returns:
    the original array

### reverse

    public static Object[] reverse(Object[] self)

  Reverse the items in an Object array.

  Parameters:
    `self` - an Object array
  Returns:
    an array containing the reversed items

### every

    public static boolean every(Object self,
                                Closure closure)

  Used to determine if the given predicate closure is valid (i.e.&nsbp;returns `true` for all items in this data structure). A simple example for a list:

      def list = [3,4,5]
       def greaterThanTwo = list.every { it > 2 }

  Parameters:
    `self` - the object over which we iterate
    `closure` - the closure predicate used for matching
  Returns:
    true if every iteration of the object matches the closure predicate

### every

    public static boolean every(Map self,
                                Closure closure)

  Iterates over the entries of a map, and checks whether a predicate is valid for all entries.

  Parameters:
    `self` - the map over which we iterate
    `closure` - the closure predicate used for matching
  Returns:
    true if every entry of the map matches the closure predicate

### every

    public static boolean every(Object self)

  Iterates over every element of a collection, and checks whether all elements are `true` according to the Groovy Truth. Equivalent to `self.every({element -> element})`

  Parameters:
    `self` - the object over which we iterate
  Returns:
    true if every item in the collection matches the closure predicate

### any

    public static boolean any(Object self,
                              Closure closure)

  Iterates over the contents of an object or collection, and checks whether a predicate is valid for at least one element.

  Parameters:
    `self` - the object over which we iterate
    `closure` - the closure predicate used for matching
  Returns:
    true if any iteration for the object matches the closure predicate

### any

    public static boolean any(Map self,
                              Closure closure)

  Iterates over the entries of a map, and checks whether a predicate is valid for at least one entry

  Parameters:
    `self` - the map over which we iterate
    `closure` - the closure predicate used for matching
  Returns:
    true if any entry in the map matches the closure predicate

### any

    public static boolean any(Object self)

  Iterates over the elements of a collection, and checks whether at least one element is true according to the Groovy Truth. Equivalent to self.any({element -> element})

  Parameters:
    `self` - the object over which we iterate
  Returns:
    true if any item in the collection matches the closure predicate

### grep

    public static Collection grep(Object self,
                                  Object filter)

  Iterates over every element of the collection and returns each item that matches the given filter - calling the ``isCase(Object,Object)`` method used by switch statements. This method can be used with different kinds of filters like regular expressions, classes, ranges etc. Example:

      def list = ['a', 'b', 'aa', 'bc' ]
       def filtered = list.grep( ~/a+/ ) //contains 'a' and 'aa'

  Parameters:
    `self` - the object over which we iterate
    `filter` - the filter to perform on the collection (using the isCase(object) method)
  Returns:
    a collection of objects which match the filter

### count

    public static int count(Iterator self,
                            Object value)

  Counts the number of occurrences of the given value from the items within this Iterator. Comparison is done using Groovy's == operator (using `compareTo(value) == 0` or `equals(value)` ). The iterator will become exhausted of elements after determining the count value.

  Parameters:
    `self` - the Iterator from which we count the number of matching occurrences
    `value` - the value being searched for
  Returns:
    the number of occurrences

### count

    public static int count(Collection self,
                            Object value)

  Counts the number of occurrences of the given value inside this collection. Comparison is done using Groovy's == operator (using `compareTo(value) == 0` or `equals(value)` ).

  Parameters:
    `self` - the collection within which we count the number of occurrences
    `value` - the value being searched for
  Returns:
    the number of occurrences

### toList

    public static List toList(Collection self)

  Convert a collection to a List.

  Parameters:
    `self` - a collection
  Returns:
    a List

### toList

    public static List toList(Iterator self)

  Convert an iterator to a List. The iterator will become exhausted of elements after making this conversion.

  Parameters:
    `self` - an iterator
  Returns:
    a List

### toList

    public static List toList(Enumeration self)

  Convert an enumeration to a List.

  Parameters:
    `self` - an enumeration
  Returns:
    a List

### collect

    public static List collect(Object self,
                               Closure closure)

  Iterates through this object transforming each value into a new value using the closure as a transformer, returning a list of transformed values. Example:

      def list = [1, 'a', 1.23, true ]
       def types = list.collect { it.class }

  Parameters:
    `self` - the values of the object to transform
    `closure` - the closure used to transform each element of the collection
  Returns:
    a List of the transformed values

### collect

    public static Collection collect(Object self,
                                     Collection collection,
                                     Closure closure)

  Iterates through this object transforming each object into a new value using the closure as a transformer and adding it to the collection, returning the resulting collection.

  Parameters:
    `self` - the values of the object to transform
    `collection` - the Collection to which the transformed values are added
    `closure` - the closure used to map each element of the collection
  Returns:
    the given collection after the transformed values are added

### collect

    public static List collect(Collection self,
                               Closure closure)

  Iterates through this collection transforming each entry into a new value using the closure as a transformer, returning a list of transformed values.

  Parameters:
    `self` - a collection
    `closure` - the closure used for mapping
  Returns:
    a List of the transformed values

### collect

    public static Collection collect(Collection self,
                                     Collection collection,
                                     Closure closure)

  Iterates through this collection transforming each value into a new value using the closure as a transformer, returning an initial collection plus the transformed values.

  Parameters:
    `self` - a collection
    `collection` - an initial Collection to which the transformed values are added
    `closure` - the closure used to transform each element of the collection
  Returns:
    the resulting collection of transformed values

### collectAll

    public static List collectAll(Collection self,
                                  Closure closure)

  Recursively iterates through this collection transforming each non-Collection value into a new value using the closure as a transformer. Returns a potentially nested list of transformed values.

  Parameters:
    `self` - a collection
    `closure` - the closure used to transform each element of the collection
  Returns:
    the resultant collection

### collectAll

    public static Collection collectAll(Collection self,
                                        Collection collection,
                                        Closure closure)

  Recursively iterates through this collection transforming each non-Collection value into a new value using the closure as a transformer. Returns a potentially nested collection of transformed values.

  Parameters:
    `self` - a collection
    `collection` - an initial Collection to which the transformed values are added
    `closure` - the closure used to transform each element of the collection
  Returns:
    the resultant collection

### collect

    public static Collection collect(Map self,
                                     Collection collection,
                                     Closure closure)

  Iterates through this Map transforming each entry into a new value using the closure as a transformer, returning a list of transformed values.

  Parameters:
    `self` - a Map
    `collection` - the Collection to which the mapped values are added
    `closure` - the closure used for mapping, which can take one (Map.Entry) or two (key, value) parameters
  Returns:
    a List of the mapped values

### collect

    public static List collect(Map self,
                               Closure closure)

  Iterates through this Map transforming each entry into a new value using the closure as a transformer, returning a list of transformed values.

  Parameters:
    `self` - a Map
    `closure` - the closure used to map each element of the collection
  Returns:
    the resultant collection

### find

    public static Object find(Object self,
                              Closure closure)

  Finds the first value matching the closure condition

  Parameters:
    `self` - an Object with an iterator returning its values
    `closure` - a closure condition
  Returns:
    the first Object found

### find

    public static Object find(Collection self,
                              Closure closure)

  Finds the first value matching the closure condition. Example:

      def list = [1,2,3]
       list.find { it > 1 } // returns 2

  Parameters:
    `self` - a Collection
    `closure` - a closure condition
  Returns:
    the first Object found

### find

    public static Object find(Map self,
                              Closure closure)

  Finds the first entry matching the closure condition. If the closure takes two parameters, the entry key and value are passed. If the closure takes one parameter, the Map.Entry object is passed.

  Parameters:
    `self` - a Map
    `closure` - a closure condition
  Returns:
    the first Object found

### findAll

    public static List findAll(Object self,
                               Closure closure)

  Finds all items matching the closure condition.

  Parameters:
    `self` - an Object with an Iterator returning its values
    `closure` - a closure condition
  Returns:
    a List of the values found

### findAll

    public static Collection findAll(Collection self,
                                     Closure closure)

  Finds all values matching the closure condition.

  Parameters:
    `self` - a Collection
    `closure` - a closure condition
  Returns:
    a Collection of matching values

### combinations

    public static List combinations(Collection self)

  Adds GroovyCollections#combinations(Collection) as a method on collections.

  Parameters:
    `self` - a Collection of lists
  Returns:
    a List of the combinations found
  See Also:
    `GroovyCollections.combinations(java.util.Collection)`

### transpose

    public static List transpose(Collection self)

  Adds GroovyCollections#transpose(Collection) as a method on collections.

  Parameters:
    `self` - a Collection of lists
  Returns:
    a List of the transposed lists
  See Also:
    `GroovyCollections.transpose(java.util.Collection)`

### findAll

    public static Map findAll(Map self,
                              Closure closure)

  Finds all entries matching the closure condition. If the closure takes one parameter then it will be passed the Map.Entry. Otherwise if the closure should take two parameters, which will be the key and the value.

  Parameters:
    `self` - a Map
    `closure` - a closure condition applying on the entries
  Returns:
    a new subMap

### groupBy

    public static Map groupBy(Collection self,
                              Closure closure)

  Sorts all collection members into groups determined by the supplied mapping closure. The closure should return the key that this item should be grouped by. The returned Map will have an entry for each distinct key returned from the closure, with each value being a list of items for that group.

  Parameters:
    `self` - a collection to group (no map)
    `closure` - a closure mapping entries on keys
  Returns:
    a new Map grouped by keys

### groupEntriesBy

    public static Map groupEntriesBy(Map self,
                                     Closure closure)

  Groups all map entries into groups determined by the supplied mapping closure. The closure will be passed a Map.Entry or key and value (depending on the number of parameters the closure accepts) and should return the key that each item should be grouped under. The resulting map will have an entry for each 'group' key returned by the closure, with values being the list of map entries that belong to each group.

  Parameters:
    `self` - a map to group
    `closure` - a closure mapping entries on keys
  Returns:
    a new Map grouped by keys

### groupBy

    public static Map groupBy(Map self,
                              Closure closure)

  Groups the members of a map into sub maps determined by the supplied mapping closure. The closure will be passed a Map.Entry or key and value (depending on the number of parameters the closure accepts) and should return the key that each item should be grouped under. The resulting map will have an entry for each 'group' key returned by the closure, with values being the map members from the original map that belong to each group.

  Parameters:
    `self` - a map to group
    `closure` - a closure mapping entries on keys
  Returns:
    a new Map grouped by keys

### groupAnswer

    protected static void groupAnswer(Map answer,
                                      Object element,
                                      Object value)

  Groups the current element according to the value

  Parameters:
    `answer` - the map containing the results
    `element` - the element to be placed
    `value` - the value according to which the element will be placed

### callClosureForMapEntry

    protected static Object callClosureForMapEntry(Closure closure,
                                                   Map.Entry entry)

### callClosureForLine

    protected static Object callClosureForLine(Closure closure,
                                               String line,
                                               int counter)

### callClosureForMapEntryAndCounter

    protected static Object callClosureForMapEntryAndCounter(Closure closure,
                                                             Map.Entry entry,
                                                             int counter)

### inject

    public static Object inject(Collection self,
                                Object value,
                                Closure closure)

  Iterates through the given collection, passing in the initial value to the closure along with the current iterated item then passing into the next iteration the value of the previous closure.

  Parameters:
    `self` - a Collection
    `value` - a value
    `closure` - a closure
  Returns:
    the last value of the last iteration

### inject

    public static Object inject(Iterator self,
                                Object value,
                                Closure closure)

  Iterates through the given iterator, passing in the initial value to the closure along with the current iterated item then passing into the next iteration the value of the previous closure.

  Parameters:
    `self` - a Collection
    `value` - a value
    `closure` - a closure
  Returns:
    the last value of the last iteration

### inject

    public static Object inject(Object self,
                                Object value,
                                Closure closure)

  Iterates through the given object, passing in the initial value to the closure along with the current iterated item then passing into the next iteration the value of the previous closure.

  Parameters:
    `self` - a Collection
    `value` - a value
    `closure` - a closure
  Returns:
    the last value of the last iteration

### inject

    public static Object inject(Object[] self,
                                Object initialValue,
                                Closure closure)

  Iterates through the given array of objects, passing in the initial value to the closure along with the current iterated item then passing into the next iteration the value of the previous closure.

  Parameters:
    `self` - an Object[]
    `initialValue` - an initialValue
    `closure` - a closure
  Returns:
    the last value of the last iteration

### sum

    public static Object sum(Collection self)

  Sums the items in a collection. This is equivalent to invoking the "plus" method on all items in the collection.

  Parameters:
    `self` - Collection of values to add together
  Returns:
    The sum of all of the items

### sum

    public static Object sum(Iterator self)

  Sums the items from an Iterator. This is equivalent to invoking the "plus" method on all items from the Iterator. The iterator will become exhausted of elements after determining the sum value.

  Parameters:
    `self` - an Iterator for the values to add together
  Returns:
    The sum of all of the items

### sum

    public static Object sum(Collection self,
                             Object initialValue)

  Sums the items in a collection, adding the result to some initial value.

  Parameters:
    `self` - a collection of values to sum
    `initialValue` - the items in the collection will be summed to this initial value
  Returns:
    The sum of all of the collection items.

### sum

    public static Object sum(Iterator self,
                             Object initialValue)

  Sums the items from an Iterator. This is equivalent to invoking the "plus" method on all items from the Iterator.

  Parameters:
    `self` - an Iterator for the values to add together
    `initialValue` - the items in the collection will be summed to this initial value
  Returns:
    The sum of all of the items

### sum

    public static Object sum(Collection self,
                             Closure closure)

  Sums the result of apply a closure to each item of a collection. `coll.sum(closure)` is equivalent to: `coll.collect(closure).sum()`.

  Parameters:
    `self` - a Collection
    `closure` - a single parameter closure that returns a numeric value.
  Returns:
    The sum of the values returned by applying the closure to each item of the list.

### sum

    public static Object sum(Collection self,
                             Object initialValue,
                             Closure closure)

  Sums the result of apply a closure to each item of a collection to sum intial value. `coll.sum(closure)` is equivalent to: `coll.collect(closure).sum()`.

  Parameters:
    `self` - a Collection
    `closure` - a single parameter closure that returns a numeric value.
    `initialValue` - the closure results will be summed to this initial value
  Returns:
    The sum of the values returned by applying the closure to each item of the list.

### join

    public static String join(Iterator self,
                              String separator)

  Concatenates the `toString()` representation of each item from the iterator, with the given String as a separator between each item. The iterator will become exhausted of elements after determining the resulting conjoined value.

  Parameters:
    `self` - an Iterator of items
    `separator` - a String separator
  Returns:
    the joined String

### join

    public static String join(Collection self,
                              String separator)

  Concatenates the `toString()` representation of each item in this collection, with the given String as a separator between each item.

  Parameters:
    `self` - a Collection of objects
    `separator` - a String separator
  Returns:
    the joined String

### join

    public static String join(Object[] self,
                              String separator)

  Concatenates the `toString()` representation of each items in this array, with the given String as a separator between each item.

  Parameters:
    `self` - an array of Object
    `separator` - a String separator
  Returns:
    the joined String

### min

    public static Object min(Collection self)

  Adds min() method to Collection objects.

  Parameters:
    `self` - a Collection
  Returns:
    the minimum value
  See Also:
    `GroovyCollections.min(java.util.Collection)`

### min

    public static Object min(Iterator self)

  Adds min() method to Iterator objects. The iterator will become exhausted of elements after determining the minimum value.

  Parameters:
    `self` - an Iterator
  Returns:
    the minimum value
  See Also:
    `min(java.util.Collection)`

### min

    public static Object min(Object[] self)

  Adds min() method to Object arrays.

  Parameters:
    `self` - an Object array
  Returns:
    the minimum value
  See Also:
    `min(java.util.Collection)`

### min

    public static Object min(Collection self,
                             Comparator comparator)

  Selects the minimum value found in the collection using the given comparator.

  Parameters:
    `self` - a Collection
    `comparator` - a Comparator
  Returns:
    the minimum value

### min

    public static Object min(Iterator self,
                             Comparator comparator)

  Selects the minimum value found from the Iterator using the given comparator.

  Parameters:
    `self` - an Iterator
    `comparator` - a Comparator
  Returns:
    the minimum value
  See Also:
    `min(java.util.Collection, java.util.Comparator)`

### min

    public static Object min(Object[] self,
                             Comparator comparator)

  Selects the minimum value found from the Object array using the given comparator.

  Parameters:
    `self` - an Object array
    `comparator` - a Comparator
  Returns:
    the minimum value
  See Also:
    `min(java.util.Collection, java.util.Comparator)`

### min

    public static Object min(Collection self,
                             Closure closure)

  Selects the minimum value found in the collection using the given closure as a comparator. The closure should return a comparable value (i.e. a number) for each item passed. The collection item for which the closure returns the smallest comparable value will be returned from this method as the minimum.

  Parameters:
    `self` - a Collection
    `closure` - a closure used as a comparator
  Returns:
    the minimum value

### min

    public static Object min(Iterator self,
                             Closure closure)

  Selects the minimum value found from the Iterator using the given closure as a comparator. The closure should return a comparable value (i.e. a number) for each item passed. The iterator will become exhausted of elements after this operation.

  Parameters:
    `self` - an Iterator
    `closure` - a closure used as a comparator
  Returns:
    the minimum value
  See Also:
    `min(java.util.Collection, groovy.lang.Closure)`

### min

    public static Object min(Object[] self,
                             Closure closure)

  Selects the minimum value found from the Object array using the given closure as a comparator. The closure should return a comparable value (i.e. a number) for each item passed.

  Parameters:
    `self` - an Object array
    `closure` - a closure used as a comparator
  Returns:
    the minimum value
  See Also:
    `min(java.util.Collection, groovy.lang.Closure)`

### max

    public static Object max(Collection self)

  Adds max() method to Collection objects.

  Parameters:
    `self` - a Collection
  Returns:
    the maximum value
  See Also:
    `GroovyCollections.max(java.util.Collection)`

### max

    public static Object max(Iterator self)

  Adds max() method to Iterator objects. The iterator will become exhausted of elements after determining the maximum value.

  Parameters:
    `self` - an Iterator
  Returns:
    the maximum value
  See Also:
    `GroovyCollections.max(java.util.Collection)`

### max

    public static Object max(Object[] self)

  Adds max() method to Object arrays.

  Parameters:
    `self` - an Object array
  Returns:
    the maximum value
  See Also:
    `max(java.util.Collection)`

### max

    public static Object max(Collection self,
                             Closure closure)

  Selects the maximum value found in the collection using the given closure as a comparator. The closure should return a comparable value (i.e. a number) for each item passed. The collection item for which the closure returns the largest comparable value will be returned from this method as the maximum.

  Parameters:
    `self` - a Collection
    `closure` - a closure used as a comparator
  Returns:
    the maximum value

### max

    public static Object max(Iterator self,
                             Closure closure)

  Selects the maximum value found from the Iterator using the given closure as a comparator. The closure should return a comparable value (i.e. a number) for each item passed. The iterator will become exhausted of elements after this operation.

  Parameters:
    `self` - an Iterator
    `closure` - a closure used as a comparator
  Returns:
    the maximum value
  See Also:
    `max(java.util.Collection, groovy.lang.Closure)`

### max

    public static Object max(Object[] self,
                             Closure closure)

  Selects the maximum value found from the Object array using the given closure as a comparator. The closure should return a comparable value (i.e. a number) for each item passed.

  Parameters:
    `self` - an Object array
    `closure` - a closure used as a comparator
  Returns:
    the maximum value
  See Also:
    `max(java.util.Collection, groovy.lang.Closure)`

### max

    public static Object max(Collection self,
                             Comparator comparator)

  Selects the maximum value found in the collection using the given comparator.

  Parameters:
    `self` - a Collection
    `comparator` - a Comparator
  Returns:
    the maximum value

### max

    public static Object max(Iterator self,
                             Comparator comparator)

  Selects the maximum value found from the Iterator using the given comparator.

  Parameters:
    `self` - an Iterator
    `comparator` - a Comparator
  Returns:
    the maximum value

### max

    public static Object max(Object[] self,
                             Comparator comparator)

  Selects the maximum value found from the Object array using the given comparator.

  Parameters:
    `self` - an Object array
    `comparator` - a Comparator
  Returns:
    the maximum value

### size

    public static int size(Iterator self)

  Provide the standard Groovy `size()` method for `Iterator`. The iterator will become exhausted of elements after determining the size value.

  Parameters:
    `self` - an Iterator
  Returns:
    the length of the Iterator

### size

    public static int size(String text)

  Provide the standard Groovy `size()` method for `String`.

  Parameters:
    `text` - a String
  Returns:
    the length of the String

### size

    public static int size(StringBuffer buffer)

  Provide the standard Groovy `size()` method for `StringBuffer`.

  Parameters:
    `buffer` - a StringBuffer
  Returns:
    the length of the StringBuffer

### size

    public static long size(File self)

  Provide the standard Groovy `size()` method for `File`.

  Parameters:
    `self` - a file object
  Returns:
    the file's size (length)

### size

    public static long size(Matcher self)

  Provide the standard Groovy `size()` method for `Matcher`.

  Parameters:
    `self` - a matcher object
  Returns:
    the matcher's size (count)

### size

    public static int size(Object[] self)

  Provide the standard Groovy `size()` method for an array.

  Parameters:
    `self` - an Array of objects
  Returns:
    the size (length) of the Array

### getAt

    public static CharSequence getAt(CharSequence text,
                                     int index)

  Support the subscript operator for CharSequence.

  Parameters:
    `text` - a CharSequence
    `index` - the index of the Character to get
  Returns:
    the Character at the given index

### getAt

    public static String getAt(String text,
                               int index)

  Support the subscript operator for String.

  Parameters:
    `text` - a String
    `index` - the index of the Character to get
  Returns:
    the Character at the given index

### getAt

    public static CharSequence getAt(CharSequence text,
                                     Range range)

  Support the range subscript operator for CharSequence

  Parameters:
    `text` - a CharSequence
    `range` - a Range
  Returns:
    the subsequence CharSequence

### getAt

    public static CharSequence getAt(CharSequence text,
                                     IntRange range)

  Support the range subscript operator for CharSequence or StringBuffer with IntRange

  Parameters:
    `text` - a CharSequence
    `range` - an IntRange
  Returns:
    the subsequence CharSequence

### getAt

    public static CharSequence getAt(CharSequence text,
                                     EmptyRange range)

  Support the range subscript operator for CharSequence or StringBuffer with EmptyRange

  Parameters:
    `text` - a CharSequence
    `range` - an EmptyRange
  Returns:
    the subsequence CharSequence

### getAt

    public static String getAt(String text,
                               IntRange range)

  Support the range subscript operator for String with IntRange

  Parameters:
    `text` - a String
    `range` - an IntRange
  Returns:
    the resulting String

### getAt

    public static String getAt(String text,
                               EmptyRange range)

  Support the range subscript operator for String with EmptyRange

  Parameters:
    `text` - a String
    `range` - an EmptyRange
  Returns:
    the resulting String

### getAt

    public static String getAt(String text,
                               Range range)

  Support the range subscript operator for String

  Parameters:
    `text` - a String
    `range` - a Range
  Returns:
    a substring corresponding to the Range

### reverse

    public static String reverse(String self)

  Creates a new string which is the reverse (backwards) of this string

  Parameters:
    `self` - a String
  Returns:
    a new string with all the characters reversed.

### toURL

    public static URL toURL(String self)
                     throws MalformedURLException

  Transforms a String representing a URL into a URL object.

  Parameters:
    `self` - the String representing a URL
  Returns:
    a URL
  Throws:
    `MalformedURLException` - is thrown if the URL is not well formed.

### toURI

    public static URI toURI(String self)
                     throws URISyntaxException

  Transforms a String representing a URI into a URI object.

  Parameters:
    `self` - the String representing a URI
  Returns:
    a URI
  Throws:
    `URISyntaxException` - is thrown if the URI is not well formed.

### bitwiseNegate

    public static Pattern bitwiseNegate(String self)

  Turns a String into a regular expression pattern

  Parameters:
    `self` - a String to convert into a regular expression
  Returns:
    the regular expression pattern

### replaceAll

    public static String replaceAll(String self,
                                    String regex,
                                    Closure closure)

  Replaces all occurrencies of a captured group by the result of a closure on that text.

  For examples,

           assert "FOOBAR-FOOBAR-" == "foobar-FooBar-".replaceAll("(([fF][oO]{2})[bB]ar)", { Object[] it -> it[0].toUpperCase() })

           Here,
                it[0] is the global string of the matched group
                it[1] is the first string in the matched group
                it[2] is the second string in the matched group

           assert "FOO-FOO-" == "foobar-FooBar-".replaceAll("(([fF][oO]{2})[bB]ar)", { x, y, z -> z.toUpperCase() })

           Here,
                x is the global string of the matched group
                y is the first string in the matched group
                z is the second string in the matched group

  Parameters:
    `self` - a String
    `regex` - the capturing regex
    `closure` - the closure to apply on each captured group
  Returns:
    a String with replaced content

### padLeft

    public static String padLeft(String self,
                                 Number numberOfChars,
                                 String padding)

  Pad a String with the characters appended to the left

  Parameters:
    `self` - a String object
    `numberOfChars` - the total number of characters
    `padding` - the charaters used for padding
  Returns:
    the String padded to the left

### padLeft

    public static String padLeft(String self,
                                 Number numberOfChars)

  Pad a String with the spaces appended to the left

  Parameters:
    `self` - a String object
    `numberOfChars` - the total number of characters
  Returns:
    the String padded to the left

### padRight

    public static String padRight(String self,
                                  Number numberOfChars,
                                  String padding)

  Pad a String with the characters appended to the right

  Parameters:
    `self` - a String object
    `numberOfChars` - the total number of characters
    `padding` - the charaters used for padding
  Returns:
    the String padded to the right

### padRight

    public static String padRight(String self,
                                  Number numberOfChars)

  Pad a String with the spaces appended to the right

  Parameters:
    `self` - a String object
    `numberOfChars` - the total number of characters
  Returns:
    the String padded to the right

### center

    public static String center(String self,
                                Number numberOfChars,
                                String padding)

  Center a String and padd it with the characters appended around it

  Parameters:
    `self` - a String object
    `numberOfChars` - the total number of characters
    `padding` - the charaters used for padding
  Returns:
    the String centered with padded character around

### center

    public static String center(String self,
                                Number numberOfChars)

  Center a String and padd it with spaces appended around it

  Parameters:
    `self` - a String object
    `numberOfChars` - the total number of characters
  Returns:
    the String centered with padded character around

### getAt

    public static Object getAt(Matcher matcher,
                               int idx)

  Support the subscript operator, e.g. matcher[index], for a regex Matcher.

  For an example using no group match, `

          def p = /ab[d|f]/
          def m = "abcabdabeabf" =~ p
          for (i in 0..<m.count) {
              println( "m.groupCount() = " + m.groupCount())
              println( "  " + i + ": " + m[i] )   // m[i] is a String
          }

  `

  For an example using group matches, `

          def p = /(?:ab([c|d|e|f]))/
          def m = "abcabdabeabf" =~ p
          for (i in 0..<m.count) {
              println( "m.groupCount() = " + m.groupCount())
              println( "  " + i + ": " + m[i] )   // m[i] is a List
          }

  `

  For another example using group matches, `

          def m = "abcabdabeabfabxyzabx" =~ /(?:ab([d|x-z]+))/
          m.count.times {
              println( "m.groupCount() = " + m.groupCount())
              println( "  " + it + ": " + m[it] )   // m[it] is a List
          }

  `

  Parameters:
    `matcher` - a Matcher
    `idx` - an index
  Returns:
    object a matched String if no groups matched, list of matched groups otherwise.

### setIndex

    public static void setIndex(Matcher matcher,
                                int idx)

  Set the position of the given Matcher to the given index.

  Parameters:
    `matcher` - a Matcher
    `idx` - the index number

### getCount

    public static int getCount(Matcher matcher)

  Find the number of Strings matched to the given Matcher.

  Parameters:
    `matcher` - a Matcher
  Returns:
    int the number of Strings matched to the given matcher.

### hasGroup

    public static boolean hasGroup(Matcher matcher)

  Check whether a Matcher contains a group or not.

  Parameters:
    `matcher` - a Matcher
  Returns:
    boolean `true` if matcher contains at least one group.

### getAt

    public static List getAt(List self,
                             IntRange range)

  Support the range subscript operator for a List

  Parameters:
    `self` - a List
    `range` - a Range indicating the items to get
  Returns:
    a sublist based on range borders or a new list if range is reversed
  See Also:
    `List.subList(int,int)`

### getAt

    public static List getAt(List self,
                             Collection indices)

  Allows a List to be used as the indices to be used on a List

  Parameters:
    `self` - a List
    `indices` - a Collection of indices
  Returns:
    a new list of the values at the given indices

### getAt

    public static List getAt(Object[] self,
                             Collection indices)

  Allows a List to be used as the indices to be used on a List

  Parameters:
    `self` - an Array of Objects
    `indices` - a Collection of indices
  Returns:
    a new list of the values at the given indices

### getAt

    public static CharSequence getAt(CharSequence self,
                                     Collection indices)

  Allows a List to be used as the indices to be used on a CharSequence

  Parameters:
    `self` - a CharSequence
    `indices` - a Collection of indices
  Returns:
    a String of the values at the given indices

### getAt

    public static String getAt(String self,
                               Collection indices)

  Allows a List to be used as the indices to be used on a String

  Parameters:
    `self` - a String
    `indices` - a Collection of indices
  Returns:
    a String of the values at the given indices

### getAt

    public static String getAt(Matcher self,
                               Collection indices)

  Allows a List to be used as the indices to be used on a Matcher

  Parameters:
    `self` - a Matcher
    `indices` - a Collection of indices
  Returns:
    a String of the values at the given indices

### subMap

    public static Map subMap(Map map,
                             Collection keys)

  Creates a sub-Map containing the given keys. This method is similar to List.subList() but uses keys rather than index ranges.

  Parameters:
    `map` - a Map
    `keys` - a Collection of keys
  Returns:
    a new Map containing the given keys

### get

    public static Object get(Map map,
                             Object key,
                             Object defaultValue)

  Looks up an item in a Map for the given key and returns the value - unless there is no entry for the given key in which case add the default value to the map and return that.

  Parameters:
    `map` - a Map
    `key` - the key to lookup the value of
    `defaultValue` - the value to return and add to the map for this key if there is no entry for the given key
  Returns:
    the value of the given key or the default value, added to the map if the key did not exist

### getAt

    public static List getAt(Object[] array,
                             Range range)

  Support the range subscript operator for an Array

  Parameters:
    `array` - an Array of Objects
    `range` - a Range
  Returns:
    a range of a list from the range's from index up to but not including the ranges's to value

### getAt

    public static List getAt(Object[] array,
                             IntRange range)

### getAt

    public static List getAt(Object[] array,
                             EmptyRange range)

### getAt

    public static List getAt(Object[] array,
                             ObjectRange range)

### getAt

    public static Object getAt(Object[] array,
                               int idx)

  Support the subscript operator for an Array.

  Parameters:
    `array` - an Array of Objects
    `idx` - an index
  Returns:
    the value at the given index

### putAt

    public static void putAt(Object[] array,
                             int idx,
                             Object value)

  Support the subscript operator for an Array.

  Parameters:
    `array` - an Array of Objects
    `idx` - an index
    `value` - an Object to put at the given index

### toList

    public static List toList(Object[] array)

  Allows conversion of arrays into a mutable List.

  Parameters:
    `array` - an Array of Objects
  Returns:
    the array as a List

### getAt

    public static Object getAt(List self,
                               int idx)

  Support the subscript operator for a List.

  Parameters:
    `self` - a List
    `idx` - an index
  Returns:
    the value at the given index

### getAt

    public static int getAt(Date self,
                            int field)

  Support the subscript operator for a Date.

  Parameters:
    `self` - a Date
    `field` - a Calendar field, e.g. MONTH
  Returns:
    the value for the given field, e.g. FEBRUARY
  See Also:
    `Calendar`

### putAt

    public static void putAt(List self,
                             int idx,
                             Object value)

  A helper method to allow lists to work with subscript operators.

  Parameters:
    `self` - a List
    `idx` - an index
    `value` - the value to put at the given index

### putAt

    public static void putAt(StringBuffer self,
                             IntRange range,
                             Object value)

  Support the range subscript operator for StringBuffer. Index values are treated as characters within the buffer.

  Parameters:
    `self` - a StringBuffer
    `range` - a Range
    `value` - the object that's toString() will be inserted

### putAt

    public static void putAt(StringBuffer self,
                             EmptyRange range,
                             Object value)

  Support the range subscript operator for StringBuffer.

  Parameters:
    `self` - a StringBuffer
    `range` - a Range
    `value` - the object that's toString() will be inserted

### putAt

    public static void putAt(List self,
                             EmptyRange range,
                             Object value)

  A helper method to allow lists to work with subscript operators.

  Parameters:
    `self` - a List
    `range` - the subset of the list to set
    `value` - the values to put at the given sublist or a Collection of values

### putAt

    public static void putAt(List self,
                             IntRange range,
                             Collection col)

  List subscript assignment operator when given a range as the index and the assignment operand is a collection. Example: `myList[3..5] = anotherList`. Items in the given range are relaced with items from the collection.

  Parameters:
    `self` - a List
    `range` - the subset of the list to set
    `col` - the collection of values to put at the given sublist

### putAt

    public static void putAt(List self,
                             IntRange range,
                             Object value)

  List subscript assignment operator when given a range as the index. Example: `myList[3..5] = newItem`. Items in the given range are relaced with the operand. The `value` operand is always treated as a single value.

  Parameters:
    `self` - a List
    `range` - the subset of the list to set
    `value` - the value to put at the given sublist

### putAt

    public static void putAt(List self,
                             List splice,
                             List values)

  Deprecated. replace with putAt(List self, Range range, List value)

  A helper method to allow lists to work with subscript operators.

  Parameters:
    `self` - a List
    `splice` - the subset of the list to set
    `values` - the value to put at the given sublist

### putAt

    public static void putAt(List self,
                             List splice,
                             Object value)

  Deprecated. replace with putAt(List self, Range range, Object value)

  A helper method to allow lists to work with subscript operators.

  Parameters:
    `self` - a List
    `splice` - the subset of the list to set
    `value` - the value to put at the given sublist

### getSubList

    protected static List getSubList(List self,
                                     List splice)

### getAt

    public static Object getAt(Map self,
                               Object key)

  Support the subscript operator for a Map.

  Parameters:
    `self` - a Map
    `key` - an Object as a key for the map
  Returns:
    the value corresponding to the given key

### plus

    public static Map plus(Map left,
                           Map right)

  Returns a new Map containing all entries from `left` and `right`, giving precedence to `right`. Any keys appearing in both Maps will appear in the resultant map with values from the `right` operand. If the `left` map is one of TreeMap, LinkedHashMap, Hashtable or Properties, the returned Map will preserve that type, otherwise a HashMap will be returned.

  Roughly equivalent to `Map m = new HashMap(); m.putAll(left); m.putAll(right); return m;` but with some additional logic to preserve the `left` Map type for common cases as described above.

  Parameters:
    `left` - a Map
    `right` - a Map
  Returns:
    a new Map containing all entries from left and right

### putAt

    public static Object putAt(Map self,
                               Object key,
                               Object value)

  A helper method to allow lists to work with subscript operators

  Parameters:
    `self` - a Map
    `key` - an Object as a key for the map
    `value` - the value to put into the map
  Returns:
    the value corresponding to the given key

### getAt

    public static List getAt(Collection coll,
                             String property)

  Support the subscript operator for List

  Parameters:
    `coll` - a Collection
    `property` - a String
  Returns:
    a List

### asImmutable

    public static Map asImmutable(Map self)

  A convenience method for creating an immutable map.

  Parameters:
    `self` - a Map
  Returns:
    an immutable Map
  See Also:
    `Collections.unmodifiableMap(java.util.Map)`

### asImmutable

    public static SortedMap asImmutable(SortedMap self)

  A convenience method for creating an immutable sorted map.

  Parameters:
    `self` - a SortedMap
  Returns:
    an immutable SortedMap
  See Also:
    `Collections.unmodifiableSortedMap(java.util.SortedMap)`

### asImmutable

    public static List asImmutable(List self)

  A convenience method for creating an immutable list

  Parameters:
    `self` - a List
  Returns:
    an immutable List
  See Also:
    `Collections.unmodifiableList(java.util.List)`

### asImmutable

    public static Set asImmutable(Set self)

  A convenience method for creating an immutable list.

  Parameters:
    `self` - a Set
  Returns:
    an immutable Set
  See Also:
    `Collections.unmodifiableSet(java.util.Set)`

### asImmutable

    public static SortedSet asImmutable(SortedSet self)

  A convenience method for creating an immutable sorted set.

  Parameters:
    `self` - a SortedSet
  Returns:
    an immutable SortedSet
  See Also:
    `Collections.unmodifiableSortedSet(java.util.SortedSet)`

### asImmutable

    public static Collection asImmutable(Collection self)

  A convenience method for creating an immutable Collection.

  Parameters:
    `self` - a Collection
  Returns:
    an immutable Collection
  See Also:
    `Collections.unmodifiableCollection(java.util.Collection)`

### asSynchronized

    public static Map asSynchronized(Map self)

  A convenience method for creating a synchronized Map.

  Parameters:
    `self` - a Map
  Returns:
    a synchronized Map
  See Also:
    `Collections.synchronizedMap(java.util.Map)`

### asSynchronized

    public static SortedMap asSynchronized(SortedMap self)

  A convenience method for creating a synchronized SortedMap.

  Parameters:
    `self` - a SortedMap
  Returns:
    a synchronized SortedMap
  See Also:
    `Collections.synchronizedSortedMap(java.util.SortedMap)`

### asSynchronized

    public static Collection asSynchronized(Collection self)

  A convenience method for creating a synchronized Collection.

  Parameters:
    `self` - a Collection
  Returns:
    a synchronized Collection
  See Also:
    `Collections.synchronizedCollection(java.util.Collection)`

### asSynchronized

    public static List asSynchronized(List self)

  A convenience method for creating a synchronized List.

  Parameters:
    `self` - a List
  Returns:
    a synchronized List
  See Also:
    `Collections.synchronizedList(java.util.List)`

### asSynchronized

    public static Set asSynchronized(Set self)

  A convenience method for creating a synchronized Set.

  Parameters:
    `self` - a Set
  Returns:
    a synchronized Set
  See Also:
    `Collections.synchronizedSet(java.util.Set)`

### asSynchronized

    public static SortedSet asSynchronized(SortedSet self)

  A convenience method for creating a synchronized SortedSet.

  Parameters:
    `self` - a SortedSet
  Returns:
    a synchronized SortedSet
  See Also:
    `Collections.synchronizedSortedSet(java.util.SortedSet)`

### spread

    public static SpreadMap spread(Map self)

  Synonym for `toSpreadMap(Map)`.

  Parameters:
    `self` - a map
  Returns:
    a newly created Spreadmap

### toSpreadMap

    public static SpreadMap toSpreadMap(Map self)

  Returns a new `SpreadMap` from this map.

  For examples, if there is defined a function like as

  >          def fn(a, b, c, d) { return a + b + c + d }

  , then all of the following three have the same meaning.

  >          println fn(a:1, [b:2, c:3].toSpreadMap(), d:4)
  >          println fn(a:1, *:[b:2, c:3], d:4)
  >          println fn(a:1, b:2, c:3, d:4)

  Parameters:
    `self` - a list to be converted into a spreadmap
  Returns:
    a newly created Spreadmap if this list is not null and its size is positive.
  See Also:
    `SpreadMap.SpreadMap(java.util.Map)`

### toSpreadMap

    public static SpreadMap toSpreadMap(Object[] self)

  Creates a spreadable map from this array.

  Parameters:
    `self` - an object array
  Returns:
    a newly created Spreadmap
  See Also:
    `SpreadMap.SpreadMap(java.lang.Object[])`

### sort

    public static List sort(Collection self)

  Sorts the given collection into a sorted list. The collection items are assumed to be comparable.

  Parameters:
    `self` - the collection to be sorted
  Returns:
    the sorted collection as a List

### sort

    public static Map sort(Map self,
                           Closure closure)

  Sorts the given map into a sorted map using the closure as a comparator.

  Parameters:
    `self` - the map to be sorted
    `closure` - a Closure used as a comparator
  Returns:
    the sorted map

### sort

    public static Object[] sort(Object[] self)

  Sorts the given Object array into sorted order. The array items are assumed to be comparable.

  Parameters:
    `self` - the array to be sorted
  Returns:
    the sorted array

### sort

    public static Iterator sort(Iterator self)

  Sorts the given iterator items into a sorted iterator. The items are assumed to be comparable. The original iterator will become exhausted of elements after completing this method call. A new iterator is produced that traverses the items in sorted order.

  Parameters:
    `self` - the Iterator to be sorted
  Returns:
    the sorted items as an Iterator

### sort

    public static Iterator sort(Iterator self,
                                Comparator comparator)

  Sorts the given iterator items into a sorted iterator using the comparator.

  Parameters:
    `self` - the Iterator to be sorted
    `comparator` - a Comparator used for comparing items
  Returns:
    the sorted items as an Iterator

### sort

    public static List sort(Collection self,
                            Comparator comparator)

  Sorts the Collection using the given comparator. The elements are sorted into a new list, and the existing collection is unchanged.

  Parameters:
    `self` - a collection to be sorted
    `comparator` - a Comparator used for the comparison
  Returns:
    a newly created sorted List

### sort

    public static Object[] sort(Object[] self,
                                Comparator comparator)

  Sorts the given Object array into sorted order using the given comparator.

  Parameters:
    `self` - the array to be sorted
    `comparator` - a Comparator used for the comparison
  Returns:
    the sorted array

### sort

    public static Iterator sort(Iterator self,
                                Closure closure)

  Sorts the given iterator items into a sorted iterator using the closure as a comparator.

  Parameters:
    `self` - the Iterator to be sorted
    `closure` - a Closure used as a comparator
  Returns:
    the sorted items as an Iterator

### sort

    public static Object[] sort(Object[] self,
                                Closure closure)

  Sorts the given Object array into a newly created array using the given comparator.

  Parameters:
    `self` - the array to be sorted
    `closure` - a Closure used as a comparator
  Returns:
    the sorted array

### sort

    public static List sort(Collection self,
                            Closure closure)

  Sorts this Collection using the given closure as a comparator. The closure is passed each item from the collection, and is assumed to return a comparable value (i.e. an int).

  Parameters:
    `self` - a Collection to be sorted
    `closure` - a Closure used as a comparator
  Returns:
    a newly created sorted List

### sort

    public static SortedSet sort(SortedSet self)

  Avoids doing unnecessary work when sorting an already sorted set.

  Parameters:
    `self` - an identity function for an already sorted set
  Returns:
    the sorted set

### pop

    public static Object pop(List self)

  Removes the last item from the List. Using add() and pop() is similar to push and pop on a Stack.

  Parameters:
    `self` - a List
  Returns:
    the item removed from the List
  Throws:
    `NoSuchElementException` - if the list is empty and you try to pop() it.

### push

    public static boolean push(List self,
                               Object value)

  Appends an item to the List. Synonym for add().

  Parameters:
    `self` - a List
    `value` - element to be appended to this list.
  Returns:
    `true` (as per the general contract of the `Collection.add` method).
  Throws:
    `NoSuchElementException` - if the list is empty and you try to pop() it.

### last

    public static Object last(List self)

  Returns the last item from the List.

  Parameters:
    `self` - a List
  Returns:
    the last item from the List
  Throws:
    `NoSuchElementException` - if the list is empty and you try to access the last() item.

### first

    public static Object first(List self)

  Returns the first item from the List.

  Parameters:
    `self` - a List
  Returns:
    the first item from the List
  Throws:
    `NoSuchElementException` - if the list is empty and you try to access the first() item.

### head

    public static Object head(List self)

  Returns the first item from the List.

  Parameters:
    `self` - a List
  Returns:
    the first item from the List
  Throws:
    `NoSuchElementException` - if the list is empty and you try to access the head() item.

### tail

    public static List tail(List self)

  Returns the items from the List excluding the first item.

  Parameters:
    `self` - a List
  Returns:
    a list without its first element
  Throws:
    `NoSuchElementException` - if the list is empty and you try to access the tail() item.

### asList

    public static List asList(Collection self)

  Converts this collection to a List.

  Parameters:
    `self` - a collection to be converted into a List
  Returns:
    a newly created List if this collection is not already a List

### asType

    public static Object asType(Collection col,
                                Class clazz)

  Converts the given collection to another type. A default concrete type is used for List, Set, or SortedSet. If the given type has a constructor taking a collection, that is used. Otherwise, the call is deferred to {link #asType(Object,Class)}. If this collection is already of the given type, the same instance is returned.

  Parameters:
    `col` - a collection
    `clazz` - the desired class
  Returns:
    the object resulting from this type conversion
  See Also:
    `asType(Object,Class)`

### asType

    public static Object asType(Object[] ary,
                                Class clazz)

  Converts the given array to either a List, Set, or SortedSet. If the given class is something else, the call is deferred to {link #asType(Object,Class)}.

  Parameters:
    `ary` - an array
    `clazz` - the desired class
  Returns:
    the object resulting from this type conversion
  See Also:
    `asType(Object,Class)`

### asType

    public static Object asType(Closure cl,
                                Class clazz)

  Coerces the closure to an implementation of the given class. The class is assumed to be an interface or class with a single method definition. The closure is used as the implementation of that single method.

  Parameters:
    `cl` - the implementation of the single method
    `clazz` - the target type
  Returns:
    a Proxy of the given type which wraps this closure.

### asType

    public static Object asType(Map map,
                                Class clazz)

  Coerces this map to the given type, using the map's keys as the public method names, and values as the implementation. Typically the value would be a closure which behaves like the method implementation.

  Parameters:
    `map` - this map
    `clazz` - the target type
  Returns:
    a Proxy of the given type, which defers calls to this map's elements.

### reverse

    public static List reverse(List self)

  Reverses the list. The result is a new List with the identical contents in reverse order.

  Parameters:
    `self` - a List
  Returns:
    a reversed List

### reverse

    public static Iterator reverse(Iterator self)

  Reverses the iterator. The original iterator will become exhausted of elements after determining the reversed values. A new iterator for iterating through the reversed values is returned.

  Parameters:
    `self` - an Iterator
  Returns:
    a reversed Iterator

### plus

    public static Collection plus(Collection left,
                                  Collection right)

  Create a Collection as a union of two collections. If the left collection is a Set, then the returned collection will be a Set otherwise a List. This operation will always create a new object for the result, while the operands remain unchanged.

  Parameters:
    `left` - the left Collection
    `right` - the right Collection
  Returns:
    the merged Collection

### plus

    public static Collection plus(Collection left,
                                  Object right)

  Create a collection as a union of a Collection and an Object. If the collection is a Set, then the returned collection will be a Set otherwise a List. This operation will always create a new object for the result, while the operands remain unchanged.

  Parameters:
    `left` - a Collection
    `right` - an object to add/append
  Returns:
    the resulting Collection

### multiply

    public static List multiply(Collection self,
                                Number factor)

  Create a List composed of the elements of this list, repeated a certain number of times. Note that for non-primitive elements, multiple references to the same instance will be added.

  Parameters:
    `self` - a Collection
    `factor` - the number of times to append
  Returns:
    the multiplied list

### intersect

    public static Collection intersect(Collection left,
                                       Collection right)

  Create a Collection composed of the intersection of both collections. Any elements that exist in both collections are added to the resultant collection.

  Parameters:
    `left` - a Collection
    `right` - a Collection
  Returns:
    a Collection as an intersection of both collections

### disjoint

    public static boolean disjoint(Collection left,
                                   Collection right)

  Returns `true` if the intersection of two collections is empty.

  Parameters:
    `left` - a Collection
    `right` - a Collection
  Returns:
    boolean `true` if the intersection of two collections is empty, `false` otherwise.

### equals

    public static boolean equals(int[] left,
                                 int[] right)

  Compare the contents of this array to the contents of the given array.

  Parameters:
    `left` - an int array
    `right` - the operand array.
  Returns:
    true if the contents of both arrays are equal.

### equals

    public static boolean equals(Object[] left,
                                 List right)

  Determines if the contents of this array are equal to the contents of the given list, in the same order. This returns `false` if either collection is `null`.

  Parameters:
    `left` - this array
    `right` - the list being compared
  Returns:
    true if the contents of both collections are equal

### equals

    public static boolean equals(List left,
                                 Object[] right)

  Determines if the contents of this list are equal to the contents of the given array in the same order. This returns `false` if either collection is `null`.

  Parameters:
    `left` - this List
    `right` - this Object[] being compared to
  Returns:
    true if the contents of both collections are equal

### equals

    public static boolean equals(List left,
                                 List right)

  Compare the contents of two Lists. Order matters. If numbers exist in the Lists, then they are compared as numbers, for example 2 == 2L. If either list is `null`, the result is `false`.

  Parameters:
    `left` - this List
    `right` - the List being compared to.
  Returns:
    boolean `true` if the contents of both lists are identical, `false` otherwise.

### minus

    public static Set minus(Set self,
                            Collection operands)

  Create a Set composed of the elements of the first set minus the elements of the given collection.

  TODO: remove using number comparator?

  Parameters:
    `self` - a set object
    `operands` - the items to remove from the set
  Returns:
    the resulting set

### minus

    public static Set minus(Set self,
                            Object operand)

  Create a Set composed of the elements of the first set minus the operand.

  Parameters:
    `self` - a set object
    `operand` - the operand to remove from the set
  Returns:
    the resulting set

### minus

    public static Object[] minus(Object[] self,
                                 Collection removeMe)

  Create an array composed of the elements of the first array minus the elements of the given collection.

  Parameters:
    `self` - an object array
    `removeMe` - a Collection of elements to remove
  Returns:
    an array with the supplied elements removed

### minus

    public static Object[] minus(Object[] self,
                                 Object[] removeMe)

  Create an array composed of the elements of the first array minus the elements of the given array.

  Parameters:
    `self` - an object array
    `removeMe` - an array of elements to remove
  Returns:
    an array with the supplied elements removed

### minus

    public static List minus(List self,
                             Collection removeMe)

  Create a List composed of the elements of the first list minus the elements of the given collection.

  Parameters:
    `self` - a List
    `removeMe` - a Collection of elements to remove
  Returns:
    a List with the supplied elements removed

### minus

    public static List minus(List self,
                             Object operand)

  Create a new List composed of the elements of the first list minus the operand.

  Parameters:
    `self` - a List object
    `operand` - an element to remove from the list
  Returns:
    the resulting List with the operand removed

### minus

    public static Object[] minus(Object[] self,
                                 Object operand)

  Create a new object array composed of the elements of the first array minus the operand.

  Parameters:
    `self` - an object array
    `operand` - an element to remove from the array
  Returns:
    a new array with the operand removed

### flatten

    public static Collection flatten(Collection self)

  Flatten a collection. This collection and any nested arrays or collections have their contents (recursively) added to the new collection. WARNING: Any Maps found in the collection are flattened to the Map's values and merged into the flattened collection. This behavior may change in a future release. If you don't want Maps to be flattened use flatten(Collection, Closure) with an identity closure.

  Parameters:
    `self` - a Collection to flatten
  Returns:
    a flattened Collection

### flatten

    public static Collection flatten(Collection self,
                                     Closure flattenUsing)

  Flatten a collection. This collection and any nested arrays or collections have their contents (recursively) added to the new collection. For any non-Array, non-Collection object which represents some sort of collective type, the supplied closure should yield the contained items; otherwise, the closure should just return any element which corresponds to a leaf.

  Parameters:
    `self` - a Collection
    `flattenUsing` - a closure to determine how to flatten non-Array, non-Collection elements
  Returns:
    a flattened Collection

### leftShift

    public static Collection leftShift(Collection self,
                                       Object value)

  Overloads the left shift operator to provide an easy way to append objects to a Collection.

  Parameters:
    `self` - a Collection
    `value` - an Object to be added to the collection.
  Returns:
    same collection, after the value was added to it.

### leftShift

    public static Map leftShift(Map self,
                                Map.Entry entry)

  Overloads the left shift operator to provide an easy way to append Map.Entry values to a Map.

  Parameters:
    `self` - a Map
    `entry` - a Map.Entry to be added to the Map.
  Returns:
    same map, after the value has been added to it.

### leftShift

    public static StringBuffer leftShift(String self,
                                         Object value)

  Overloads the left shift operator to provide an easy way to append multiple objects as string representations to a String.

  Parameters:
    `self` - a String
    `value` - an Obect
  Returns:
    a StringBuffer built from this string

### createStringWriter

    protected static StringWriter createStringWriter(String self)

### createStringBufferWriter

    protected static StringBufferWriter createStringBufferWriter(StringBuffer self)

### leftShift

    public static StringBuffer leftShift(StringBuffer self,
                                         Object value)

  Overloads the left shift operator to provide an easy way to append multiple objects as string representations to a StringBuffer.

  Parameters:
    `self` - a StringBuffer
    `value` - a value to append
  Returns:
    the StringBuffer on which this operation was invoked

### leftShift

    public static Writer leftShift(Writer self,
                                   Object value)
                            throws IOException

  Overloads the left shift operator to provide a mechanism to append values to a writer.

  Parameters:
    `self` - a Writer
    `value` - a value to append
  Returns:
    the writer on which this operation was invoked
  Throws:
    `IOException` - if an I/O error occurs.

### leftShift

    public static Number leftShift(Number self,
                                   Number operand)

  Implementation of the left shift operator for integral types. Non integral Number types throw UnsupportedOperationException.

  Parameters:
    `self` - a Number object
    `operand` - the shift distance by which to left shift the number
  Returns:
    the resulting number

### rightShift

    public static Number rightShift(Number self,
                                    Number operand)

  Implementation of the right shift operator for integral types. Non integral Number types throw UnsupportedOperationException.

  Parameters:
    `self` - a Number object
    `operand` - the shift distance by which to right shift the number
  Returns:
    the resulting number

### rightShiftUnsigned

    public static Number rightShiftUnsigned(Number self,
                                            Number operand)

  Implementation of the right shift (unsigned) operator for integral types. Non integral Number types throw UnsupportedOperationException.

  Parameters:
    `self` - a Number object
    `operand` - the shift distance by which to right shift (unsigned) the number
  Returns:
    the resulting number

### write

    public static void write(Writer self,
                             Writable writable)
                      throws IOException

  A helper method so that dynamic dispatch of the writer.write(object) method will always use the more efficient Writable.writeTo(writer) mechanism if the object implements the Writable interface.

  Parameters:
    `self` - a Writer
    `writable` - an object implementing the Writable interface
  Throws:
    `IOException` - if an I/O error occurs.

### leftShift

    public static Writer leftShift(OutputStream self,
                                   Object value)
                            throws IOException

  Overloads the leftShift operator to provide an append mechanism to add values to a stream.

  Parameters:
    `self` - an OutputStream
    `value` - a value to append
  Returns:
    a Writer
  Throws:
    `IOException` - if an I/O error occurs.

### leftShift

    public static void leftShift(ObjectOutputStream self,
                                 Object value)
                          throws IOException

  Overloads the leftShift operator to add objects to an ObjectOutputStream.

  Parameters:
    `self` - an ObjectOutputStream
    `value` - an object to write to the stream
  Throws:
    `IOException` - if an I/O error occurs.
  Since:
    1.1 beta 2

### leftShift

    public static OutputStream leftShift(OutputStream self,
                                         InputStream in)
                                  throws IOException

  Pipe an InputStream into an OutputStream for efficient stream copying.

  Parameters:
    `self` - stream on which to write
    `in` - stream to read from
  Returns:
    the outputstream itself
  Throws:
    `IOException` - if an I/O error occurs.

### leftShift

    public static OutputStream leftShift(OutputStream self,
                                         byte[] value)
                                  throws IOException

  Overloads the leftShift operator to provide an append mechanism to add bytes to a stream.

  Parameters:
    `self` - an OutputStream
    `value` - a value to append
  Returns:
    an OutputStream
  Throws:
    `IOException` - if an I/O error occurs.

### getAt

    public static Object getAt(byte[] array,
                               int index)

  Support the subscript operator for a byte array

  Parameters:
    `array` - a byte array
    `index` - the index of the item to retrieve
  Returns:
    the byte at the given index

### getAt

    public static Object getAt(char[] array,
                               int index)

  Support the subscript operator for a char array

  Parameters:
    `array` - a char array
    `index` - the index of the item to retrieve
  Returns:
    the char at the given index

### getAt

    public static Object getAt(short[] array,
                               int index)

  Support the subscript operator for a short array

  Parameters:
    `array` - a short array
    `index` - the index of the item to retrieve
  Returns:
    the short at the given index

### getAt

    public static Object getAt(int[] array,
                               int index)

  Support the subscript operator for an int array

  Parameters:
    `array` - an int array
    `index` - the index of the item to retrieve
  Returns:
    the int at the given index

### getAt

    public static Object getAt(long[] array,
                               int index)

  Support the subscript operator for a long array

  Parameters:
    `array` - a long array
    `index` - the index of the item to retrieve
  Returns:
    the long at the given index

### getAt

    public static Object getAt(float[] array,
                               int index)

  Support the subscript operator for a float array

  Parameters:
    `array` - a float array
    `index` - the index of the item to retrieve
  Returns:
    the float at the given index

### getAt

    public static Object getAt(double[] array,
                               int index)

  Support the subscript operator for a double array

  Parameters:
    `array` - a double array
    `index` - the index of the item to retrieve
  Returns:
    the double at the given index

### getAt

    public static Object getAt(boolean[] array,
                               int index)

  Support the subscript operator for a boolean array

  Parameters:
    `array` - a boolean array
    `index` - the index of the item to retrieve
  Returns:
    the boolean at the given index

### getAt

    public static Object getAt(byte[] array,
                               Range range)

  Support the subscript operator with a range for a byte array

  Parameters:
    `array` - a byte array
    `range` - a range indicating the indices for the items to retrieve
  Returns:
    list of the retrieved bytes

### getAt

    public static Object getAt(char[] array,
                               Range range)

  Support the subscript operator with a range for a char array

  Parameters:
    `array` - a char array
    `range` - a range indicating the indices for the items to retrieve
  Returns:
    list of the retrieved chars

### getAt

    public static Object getAt(short[] array,
                               Range range)

  Support the subscript operator with a range for a short array

  Parameters:
    `array` - a short array
    `range` - a range indicating the indices for the items to retrieve
  Returns:
    list of the retrieved shorts

### getAt

    public static Object getAt(int[] array,
                               Range range)

  Support the subscript operator with a range for an int array

  Parameters:
    `array` - an int array
    `range` - a range indicating the indices for the items to retrieve
  Returns:
    list of the ints at the given indices

### getAt

    public static Object getAt(long[] array,
                               Range range)

  Support the subscript operator with a range for a long array

  Parameters:
    `array` - a long array
    `range` - a range indicating the indices for the items to retrieve
  Returns:
    list of the retrieved longs

### getAt

    public static Object getAt(float[] array,
                               Range range)

  Support the subscript operator with a range for a float array

  Parameters:
    `array` - a float array
    `range` - a range indicating the indices for the items to retrieve
  Returns:
    list of the retrieved floats

### getAt

    public static Object getAt(double[] array,
                               Range range)

  Support the subscript operator with a range for a double array

  Parameters:
    `array` - a double array
    `range` - a range indicating the indices for the items to retrieve
  Returns:
    list of the retrieved doubles

### getAt

    public static Object getAt(boolean[] array,
                               Range range)

  Support the subscript operator with a range for a boolean array

  Parameters:
    `array` - a boolean array
    `range` - a range indicating the indices for the items to retrieve
  Returns:
    list of the retrieved booleans

### getAt

    public static Object getAt(byte[] array,
                               IntRange range)

  Support the subscript operator with an IntRange for a byte array

  Parameters:
    `array` - a byte array
    `range` - an IntRange indicating the indices for the items to retrieve
  Returns:
    list of the retrieved bytes

### getAt

    public static Object getAt(char[] array,
                               IntRange range)

  Support the subscript operator with an IntRange for a char array

  Parameters:
    `array` - a char array
    `range` - an IntRange indicating the indices for the items to retrieve
  Returns:
    list of the retrieved chars

### getAt

    public static Object getAt(short[] array,
                               IntRange range)

  Support the subscript operator with an IntRange for a short array

  Parameters:
    `array` - a short array
    `range` - an IntRange indicating the indices for the items to retrieve
  Returns:
    list of the retrieved shorts

### getAt

    public static Object getAt(int[] array,
                               IntRange range)

  Support the subscript operator with an IntRange for an int array

  Parameters:
    `array` - an int array
    `range` - an IntRange indicating the indices for the items to retrieve
  Returns:
    list of the retrieved ints

### getAt

    public static Object getAt(long[] array,
                               IntRange range)

  Support the subscript operator with an IntRange for a long array

  Parameters:
    `array` - a long array
    `range` - an IntRange indicating the indices for the items to retrieve
  Returns:
    list of the retrieved longs

### getAt

    public static Object getAt(float[] array,
                               IntRange range)

  Support the subscript operator with an IntRange for a float array

  Parameters:
    `array` - a float array
    `range` - an IntRange indicating the indices for the items to retrieve
  Returns:
    list of the retrieved floats

### getAt

    public static Object getAt(double[] array,
                               IntRange range)

  Support the subscript operator with an IntRange for a double array

  Parameters:
    `array` - a double array
    `range` - an IntRange indicating the indices for the items to retrieve
  Returns:
    list of the retrieved doubles

### getAt

    public static Object getAt(boolean[] array,
                               IntRange range)

  Support the subscript operator with an IntRange for a boolean array

  Parameters:
    `array` - a boolean array
    `range` - an IntRange indicating the indices for the items to retrieve
  Returns:
    list of the retrieved booleans

### getAt

    public static Object getAt(byte[] array,
                               ObjectRange range)

  Support the subscript operator with an ObjectRange for a byte array

  Parameters:
    `array` - a byte array
    `range` - an ObjectRange indicating the indices for the items to retrieve
  Returns:
    list of the retrieved bytes

### getAt

    public static Object getAt(char[] array,
                               ObjectRange range)

  Support the subscript operator with an ObjectRange for a char array

  Parameters:
    `array` - a char array
    `range` - an ObjectRange indicating the indices for the items to retrieve
  Returns:
    list of the retrieved chars

### getAt

    public static Object getAt(short[] array,
                               ObjectRange range)

  Support the subscript operator with an ObjectRange for a short array

  Parameters:
    `array` - a short array
    `range` - an ObjectRange indicating the indices for the items to retrieve
  Returns:
    list of the retrieved shorts

### getAt

    public static Object getAt(int[] array,
                               ObjectRange range)

  Support the subscript operator with an ObjectRange for an int array

  Parameters:
    `array` - an int array
    `range` - an ObjectRange indicating the indices for the items to retrieve
  Returns:
    list of the retrieved ints

### getAt

    public static Object getAt(long[] array,
                               ObjectRange range)

  Support the subscript operator with an ObjectRange for a long array

  Parameters:
    `array` - a long array
    `range` - an ObjectRange indicating the indices for the items to retrieve
  Returns:
    list of the retrieved longs

### getAt

    public static Object getAt(float[] array,
                               ObjectRange range)

  Support the subscript operator with an ObjectRange for a float array

  Parameters:
    `array` - a float array
    `range` - an ObjectRange indicating the indices for the items to retrieve
  Returns:
    list of the retrieved floats

### getAt

    public static Object getAt(double[] array,
                               ObjectRange range)

  Support the subscript operator with an ObjectRange for a double array

  Parameters:
    `array` - a double array
    `range` - an ObjectRange indicating the indices for the items to retrieve
  Returns:
    list of the retrieved doubles

### getAt

    public static Object getAt(boolean[] array,
                               ObjectRange range)

  Support the subscript operator with an ObjectRange for a byte array

  Parameters:
    `array` - a byte array
    `range` - an ObjectRange indicating the indices for the items to retrieve
  Returns:
    list of the retrieved bytes

### getAt

    public static Object getAt(byte[] array,
                               Collection indices)

  Support the subscript operator with a collection for a byte array

  Parameters:
    `array` - a byte array
    `indices` - a collection of indices for the items to retrieve
  Returns:
    list of the bytes at the given indices

### getAt

    public static Object getAt(char[] array,
                               Collection indices)

  Support the subscript operator with a collection for a char array

  Parameters:
    `array` - a char array
    `indices` - a collection of indices for the items to retrieve
  Returns:
    list of the chars at the given indices

### getAt

    public static Object getAt(short[] array,
                               Collection indices)

  Support the subscript operator with a collection for a short array

  Parameters:
    `array` - a short array
    `indices` - a collection of indices for the items to retrieve
  Returns:
    list of the shorts at the given indices

### getAt

    public static Object getAt(int[] array,
                               Collection indices)

  Support the subscript operator with a collection for an int array

  Parameters:
    `array` - an int array
    `indices` - a collection of indices for the items to retrieve
  Returns:
    list of the ints at the given indices

### getAt

    public static Object getAt(long[] array,
                               Collection indices)

  Support the subscript operator with a collection for a long array

  Parameters:
    `array` - a long array
    `indices` - a collection of indices for the items to retrieve
  Returns:
    list of the longs at the given indices

### getAt

    public static Object getAt(float[] array,
                               Collection indices)

  Support the subscript operator with a collection for a float array

  Parameters:
    `array` - a float array
    `indices` - a collection of indices for the items to retrieve
  Returns:
    list of the floats at the given indices

### getAt

    public static Object getAt(double[] array,
                               Collection indices)

  Support the subscript operator with a collection for a double array

  Parameters:
    `array` - a double array
    `indices` - a collection of indices for the items to retrieve
  Returns:
    list of the doubles at the given indices

### getAt

    public static Object getAt(boolean[] array,
                               Collection indices)

  Support the subscript operator with a collection for a boolean array

  Parameters:
    `array` - a boolean array
    `indices` - a collection of indices for the items to retrieve
  Returns:
    list of the booleans at the given indices

### getAt

    public static boolean getAt(BitSet self,
                                int index)

  Support the subscript operator for a Bitset

  Parameters:
    `self` - a BitSet
    `index` - index to retrieve
  Returns:
    value of the bit at the given index
  See Also:
    `BitSet`

### getAt

    public static BitSet getAt(BitSet self,
                               IntRange range)

  Support retrieving a subset of a BitSet using a Range

  Parameters:
    `self` - a BitSet
    `range` - a Range defining the desired subset
  Returns:
    a new BitSet that represents the requested subset
  See Also:
    `BitSet`, `IntRange`

### putAt

    public static Boolean putAt(boolean[] array,
                                int idx,
                                Boolean newValue)

### putAt

    public static Byte putAt(byte[] array,
                             int idx,
                             Object newValue)

### putAt

    public static Character putAt(char[] array,
                                  int idx,
                                  Object newValue)

### putAt

    public static Short putAt(short[] array,
                              int idx,
                              Object newValue)

### putAt

    public static Integer putAt(int[] array,
                                int idx,
                                Object newValue)

### putAt

    public static Long putAt(long[] array,
                             int idx,
                             Object newValue)

### putAt

    public static Float putAt(float[] array,
                              int idx,
                              Object newValue)

### putAt

    public static Double putAt(double[] array,
                               int idx,
                               Object newValue)

### putAt

    public static void putAt(BitSet self,
                             IntRange range,
                             boolean value)

  Support assigning a range of values with a single assignment statement.

  Parameters:
    `self` - a BitSet
    `range` - the range of values to set
    `value` - value
  See Also:
    `BitSet`, `Range`

### putAt

    public static void putAt(BitSet self,
                             int index,
                             boolean value)

  Support subscript-style assignment for a BitSet.

  Parameters:
    `self` - a BitSet
    `index` - index of the entry to set
    `value` - value
  See Also:
    `BitSet`

### size

    public static int size(boolean[] array)

  Allows arrays to behave similar to collections.

  Parameters:
    `array` - a boolean array
  Returns:
    the length of the array
  See Also:
    `Array.getLength(Object)`

### size

    public static int size(byte[] array)

  Allows arrays to behave similar to collections.

  Parameters:
    `array` - a byte array
  Returns:
    the length of the array
  See Also:
    `Array.getLength(Object)`

### size

    public static int size(char[] array)

  Allows arrays to behave similar to collections.

  Parameters:
    `array` - a char array
  Returns:
    the length of the array
  See Also:
    `Array.getLength(Object)`

### size

    public static int size(short[] array)

  Allows arrays to behave similar to collections.

  Parameters:
    `array` - a short array
  Returns:
    the length of the array
  See Also:
    `Array.getLength(Object)`

### size

    public static int size(int[] array)

  Allows arrays to behave similar to collections.

  Parameters:
    `array` - an int array
  Returns:
    the length of the array
  See Also:
    `Array.getLength(Object)`

### size

    public static int size(long[] array)

  Allows arrays to behave similar to collections.

  Parameters:
    `array` - a long array
  Returns:
    the length of the array
  See Also:
    `Array.getLength(Object)`

### size

    public static int size(float[] array)

  Allows arrays to behave similar to collections.

  Parameters:
    `array` - a float array
  Returns:
    the length of the array
  See Also:
    `Array.getLength(Object)`

### size

    public static int size(double[] array)

  Allows arrays to behave similar to collections.

  Parameters:
    `array` - a double array
  Returns:
    the length of the array
  See Also:
    `Array.getLength(Object)`

### toList

    public static List toList(byte[] array)

  Converts this array to a List of the same size, with each element added to the list.

  Parameters:
    `array` - an array
  Returns:
    a list containing the contents of this array.

### toList

    public static List toList(char[] array)

  Converts this array to a List of the same size, with each element added to the list.

  Parameters:
    `array` - an array
  Returns:
    a list containing the contents of this array.

### toList

    public static List toList(short[] array)

  Converts this array to a List of the same size, with each element added to the list.

  Parameters:
    `array` - an array
  Returns:
    a list containing the contents of this array.

### toList

    public static List toList(int[] array)

  Converts this array to a List of the same size, with each element added to the list.

  Parameters:
    `array` - an array
  Returns:
    a list containing the contents of this array.

### toList

    public static List toList(long[] array)

  Converts this array to a List of the same size, with each element added to the list.

  Parameters:
    `array` - an array
  Returns:
    a list containing the contents of this array.

### toList

    public static List toList(float[] array)

  Converts this array to a List of the same size, with each element added to the list.

  Parameters:
    `array` - an array
  Returns:
    a list containing the contents of this array.

### toList

    public static List toList(double[] array)

  Converts this array to a List of the same size, with each element added to the list.

  Parameters:
    `array` - an array
  Returns:
    a list containing the contents of this array.

### encodeBase64

    public static Writable encodeBase64(Byte[] data,
                                        boolean chunked)

  Produce a Writable object which writes the Base64 encoding of the byte array. Calling toString() on the result returns the encoding as a String. For more information on Base64 encoding and chunking see `RFC 4648`.

  Parameters:
    `data` - Byte array to be encoded
    `chunked` - whether or not the Base64 encoded data should be MIME chunked
  Returns:
    object which will write the Base64 encoding of the byte array

### encodeBase64

    public static Writable encodeBase64(Byte[] data)

  Produce a Writable object which writes the Base64 encoding of the byte array. Calling toString() on the result returns the encoding as a String. For more information on Base64 encoding and chunking see `RFC 4648`.

  Parameters:
    `data` - Byte array to be encoded
  Returns:
    object which will write the Base64 encoding of the byte array

### encodeBase64

    public static Writable encodeBase64(byte[] data,
                                        boolean chunked)

  Produce a Writable object which writes the Base64 encoding of the byte array. Calling toString() on the result returns the encoding as a String. For more information on Base64 encoding and chunking see `RFC 4648`.

  Parameters:
    `data` - byte array to be encoded
    `chunked` - whether or not the Base64 encoded data should be MIME chunked
  Returns:
    object which will write the Base64 encoding of the byte array

### encodeBase64

    public static Writable encodeBase64(byte[] data)

  Produce a Writable object which writes the Base64 encoding of the byte array. Calling toString() on the result returns the encoding as a String. For more information on Base64 encoding and chunking see `RFC 4648`.

  Parameters:
    `data` - byte array to be encoded
  Returns:
    object which will write the Base64 encoding of the byte array

### decodeBase64

    public static byte[] decodeBase64(String value)

  Decode the String from Base64 into a byte array.

  Parameters:
    `value` - the string to be decoded
  Returns:
    the decoded bytes as an array

### primitiveArrayGet

    protected static Object primitiveArrayGet(Object self,
                                              int idx)

  Implements the getAt(int) method for primitve type arrays.

  Parameters:
    `self` - an array object
    `idx` - the index of interest
  Returns:
    the returned value from the array

### primitiveArrayGet

    protected static List primitiveArrayGet(Object self,
                                            Range range)

  Implements the getAt(Range) method for primitve type arrays.

  Parameters:
    `self` - an array object
    `range` - the range of indices of interest
  Returns:
    the returned values from the array corresponding to the range

### primitiveArrayGet

    protected static List primitiveArrayGet(Object self,
                                            Collection indices)

  Implements the getAt(Collection) method for primitve type arrays. Each value in the collection argument is assumed to be a valid array index. The value at each index is then added to a list which is returned.

  Parameters:
    `self` - an array object
    `indices` - the indices of interest
  Returns:
    the returned values from the array

### primitiveArrayPut

    protected static Object primitiveArrayPut(Object self,
                                              int idx,
                                              Object newValue)

  Implements the setAt(int idx) method for primitve type arrays.

  Parameters:
    `self` - an object
    `idx` - the index of interest
    `newValue` - the new value to be put into the index of interest
  Returns:
    the added value

### toCharacter

    public static Character toCharacter(String self)

  Converts the given string into a Character object using the first character in the string.

  Parameters:
    `self` - a String
  Returns:
    the first Character

### toBoolean

    public static Boolean toBoolean(String self)

  Converts the given string into a Boolean object. If the trimmed string is "true", "y" or "1" (ignoring case) then the result is true othewrwise it is false.

  Parameters:
    `self` - a String
  Returns:
    The Boolean value

### split

    public static String[] split(String self)

  Convenience method to split a string (with whitespace as delimiter) Like tokenize, but returns an Array of Strings instead of a List

  Parameters:
    `self` - the string to split
  Returns:
    String[] result of split

### tokenize

    public static List tokenize(String self,
                                String token)

  Tokenize a String based on the given string delimiter.

  Parameters:
    `self` - a String
    `token` - the delimiter
  Returns:
    a List of tokens
  See Also:
    `StringTokenizer.StringTokenizer(java.lang.String, java.lang.String)`

### tokenize

    public static List tokenize(String self)

  Tokenize a String (with a whitespace as the delimiter).

  Parameters:
    `self` - a String
  Returns:
    a List of tokens
  See Also:
    `StringTokenizer.StringTokenizer(java.lang.String)`

### plus

    public static String plus(String left,
                              Object value)

  Appends the String representation of the given operand to this string.

  Parameters:
    `left` - a String
    `value` - any Object
  Returns:
    the new string with the object appended

### plus

    public static String plus(Number value,
                              String right)

  Appends a String to the string representation of this number.

  Parameters:
    `value` - a Number
    `right` - a String
  Returns:
    a String

### plus

    public static String plus(StringBuffer left,
                              String value)

  Appends a String to this StringBuffer.

  Parameters:
    `left` - a StringBuffer
    `value` - a String
  Returns:
    a String

### minus

    public static String minus(String self,
                               Object target)

  Remove a part of a String. This replaces the first occurrence of target within self with '' and returns the result. If target is a regex Pattern, the first occurrence of that pattern will be removed (using regex matching), otherwise the first occurrence of target.toString() will be removed.

  Parameters:
    `self` - a String
    `target` - an object representing the part to remove
  Returns:
    a String minus the part to be removed

### contains

    public static boolean contains(String self,
                                   String text)

  Provide an implementation of contains() like `Collection.contains(Object)` to make Strings more polymorphic. This method is not required on JDK 1.5 onwards

  Parameters:
    `self` - a String
    `text` - a String to look for
  Returns:
    true if this string contains the given text

### count

    public static int count(String self,
                            String text)

  Count the number of occurencies of a substring.

  Parameters:
    `self` - a String
    `text` - a substring
  Returns:
    the number of occurrencies of the given string inside this String

### next

    public static String next(String self)

  This method is called by the ++ operator for the class String. It increments the last character in the given string. If the character in the string is Character.MAX_VALUE a Character.MIN_VALUE will be appended. The empty string is incremented to a string consisting of the character Character.MIN_VALUE.

  Parameters:
    `self` - a String
  Returns:
    an incremented String

### previous

    public static String previous(String self)

  This method is called by the -- operator for the class String. It decrements the last character in the given string. If the character in the string is Character.MIN_VALUE it will be deleted. The empty string can't be decremented.

  Parameters:
    `self` - a String
  Returns:
    a String with a decremented digit at the end

### execute

    public static Process execute(String self)
                           throws IOException

  Executes the given string as a command line process. For more control over the process mechanism in JDK 1.5 you can use java.lang.ProcessBuilder.

  Parameters:
    `self` - a command line String
  Returns:
    the Process which has just started for this command line string
  Throws:
    `IOException` - if an IOException occurs.

### execute

    public static Process execute(String[] commandArray)
                           throws IOException

  Executes the command specified by the `String` array that is the parameter. The first item in the array is the command the others are the parameters. For more control over the process mechanism in JDK 1.5 you can use `java.lang.ProcessBuilder`.

  Parameters:
    `commandArray` - an array of `String`containing the command name and parameters as separate items in the array.``
  Returns:
    the Process which has just started for this command line string.
  Throws:
    `IOException` - if an IOException occurs.

### execute

    public static Process execute(String self,
                                  String[] envp,
                                  File dir)
                           throws IOException

  Executes the command specified by the `self` with environments `envp` under the working directory `dir`. For more control over the process mechanism in JDK 1.5 you can use `java.lang.ProcessBuilder`.

  Parameters:
    `self` - a command line String to be executed.
    `envp` - an array of Strings, each element of which has environment variable settings in the format name=value, or `null` if the subprocess should inherit the environment of the current process.
    `dir` - the working directory of the subprocess, or `null` if the subprocess should inherit the working directory of the current process.
  Returns:
    the Process which has just started for this command line string.
  Throws:
    `IOException` - if an IOException occurs.

### execute

    public static Process execute(List commandList)
                           throws IOException

  Executes the command specified by the `String` list that is the parameter. The first item in the array is the command the others are the parameters. All entries must be `String`s. For more control over the process mechanism in JDK 1.5 you can use `java.lang.ProcessBuilder`.

  Parameters:
    `commandList` - a list of `String`containing the command name and parameters as separate items in the list.``
  Returns:
    the Process which has just started for this command line string.
  Throws:
    `IOException` - if an IOException occurs.

### execute

    public static Process execute(String self,
                                  List envp,
                                  File dir)
                           throws IOException

  Executes the command specified by the `self` with environments `envp` under the working directory `dir`. For more control over the process mechanism in JDK 1.5 you can use `java.lang.ProcessBuilder`.

  Parameters:
    `self` - a command line String to be executed.
    `envp` - a List of Strings, each member of which has environment variable settings in the format name=value, or `null` if the subprocess should inherit the environment of the current process.
    `dir` - the working directory of the subprocess, or `null` if the subprocess should inherit the working directory of the current process.
  Returns:
    the Process which has just started for this command line string.
  Throws:
    `IOException` - if an IOException occurs.

### multiply

    public static String multiply(String self,
                                  Number factor)

  Repeat a String a certain number of times.

  Parameters:
    `self` - a String to be repeated
    `factor` - the number of times the String should be repeated
  Returns:
    a String composed of a repetition
  Throws:
    `IllegalArgumentException` - if the number of repetitions is < 0

### toString

    public static String toString(Map self)

  Returns the string representation of the given map.

  Parameters:
    `self` - a Map
  Returns:
    the string representation
  See Also:
    `toMapString(Map)`

### toMapString

    public static String toMapString(Map self)

  Returns the string representation of this map. The string displays the contents of the map, i.e. `{one=1, two=2, three=3}`.

  Parameters:
    `self` - a Map
  Returns:
    the string representation

### toString

    public static String toString(Collection self)

  Returns the string representation of the given collection. The string displays the contents of the collection, i.e. `[1, 2, a]`.

  Parameters:
    `self` - a Collection
  Returns:
    the string representation
  See Also:
    `toListString(Collection)`

### toListString

    public static String toListString(Collection self)

  Returns the string representation of the given list. The string displays the contents of the list, similar to a list literal, i.e. `[1, 2, a]`.

  Parameters:
    `self` - a Collection
  Returns:
    the string representation

### toString

    public static String toString(Object[] self)

  Returns the string representation of this array's contents.

  Parameters:
    `self` - an Object[]
  Returns:
    the string representation
  See Also:
    `toArrayString(Object[])`

### toArrayString

    public static String toArrayString(Object[] self)

  Returns the string representation of the given array. The string displays the contents of the array, similar to an array literal, i.e. `{1, 2, "a"}`.

  Parameters:
    `self` - an Object[]
  Returns:
    the string representation

### toString

    protected static String toString(Object value)

  Create a String representation of this object.

  Parameters:
    `value` - an object
  Returns:
    a string.

### next

    public static Character next(Character self)

  Increment a Character by one.

  Parameters:
    `self` - a Character
  Returns:
    an incremented Number

### next

    public static Number next(Number self)

  Increment a Number by one.

  Parameters:
    `self` - a Number
  Returns:
    an incremented Number

### previous

    public static Character previous(Character self)

  Decrement a Character by one.

  Parameters:
    `self` - a Character
  Returns:
    a decremented Number

### previous

    public static Number previous(Number self)

  Decrement a Number by one.

  Parameters:
    `self` - a Number
  Returns:
    a decremented Number

### plus

    public static Number plus(Character left,
                              Number right)

  Add a Character and a Number. This operation will always create a new object for the result, while the operands remain unchanged. This character should be one of the digits '0' through '9', and the result is addition of the integer conversion of this character plus the operand.

  Parameters:
    `left` - a Character
    `right` - a Number
  Returns:
    the addition of the Character and the Number
  See Also:
    `Integer.valueOf(String)`

### plus

    public static Number plus(Number left,
                              Character right)

  Add a Number and a Character. This assumes the character is one of the digits '0' through '9'.

  Parameters:
    `left` - a Number
    `right` - a Character
  Returns:
    The Number corresponding to the addition of left and right
  See Also:
    `Integer.valueOf(String)`

### plus

    public static Number plus(Character left,
                              Character right)

  Add two Characters. Both characters are assumed to represent digits ('0' through '9') and add the results. This operation will always create a new object for the result, while the operands remain unchanged.

  Parameters:
    `left` - a Character
    `right` - a Character
  Returns:
    the addition of both Characters
  See Also:
    `plus(Number, Character)`

### plus

    public static Number plus(Number left,
                              Number right)

  Add two numbers and return the result.

  Parameters:
    `left` - a Number
    `right` - another Number to add
  Returns:
    the addition of both Numbers

### compareTo

    public static int compareTo(Character left,
                                Number right)

  Compare a Character and a Number. The character is assumed to be a digit (i.e. '0' through '9') which is converted to its Integer representation.

  Parameters:
    `left` - a Character
    `right` - a Number
  Returns:
    the result of the comparison

### compareTo

    public static int compareTo(Number left,
                                Character right)

  Compare a Number and a Character. The character is assumed to be a digit (i.e. '0' through '9') which is converted to its Integer representation.

  Parameters:
    `left` - a Number
    `right` - a Character
  Returns:
    the result of the comparison

### compareTo

    public static int compareTo(Character left,
                                Character right)

  Compare two Characters. Each character is assumed to be a digit (i.e. '0' through '9') which is converted to its Integer representation.

  Parameters:
    `left` - a Character
    `right` - a Character
  Returns:
    the result of the comparison

### compareTo

    public static int compareTo(Number left,
                                Number right)

  Compare two Numbers. Equality (==) for numbers dispatches to this.

  Parameters:
    `left` - a Number
    `right` - another Number to compare to
  Returns:
    the comparision of both numbers

### minus

    public static Number minus(Character left,
                               Number right)

  Subtract a Number from a Character. The character is assumed to be a digit (i.e. '0' through '9') which is converted to its Integer representation.

  Parameters:
    `left` - a Character
    `right` - a Number
  Returns:
    the addition of the Character and the Number

### minus

    public static Number minus(Number left,
                               Character right)

  Subtract a Character from a Number. The character is assumed to be a digit (i.e. '0' through '9') which is converted to its Integer representation.

  Parameters:
    `left` - a Number
    `right` - a Character
  Returns:
    the addition of the Character and the Number

### minus

    public static Number minus(Character left,
                               Character right)

  Subtract one Characters from another by converting them both to their Integer representations. Each character is assumed to be a digit (i.e. '0' through '9') which is converted to its Integer representation.

  Parameters:
    `left` - a Character
    `right` - a Character
  Returns:
    the addition of both Characters

### minus

    public static Number minus(Number left,
                               Number right)

  Substraction of two Numbers.

  Parameters:
    `left` - a Number
    `right` - another Number to substract to the first one
  Returns:
    the substraction

### multiply

    public static Number multiply(Character left,
                                  Number right)

  Multiply a Character by a Number. The character is assumed to be a digit (i.e. '0' through '9') which is converted to its Integer representation.

  Parameters:
    `left` - a Character
    `right` - a Number
  Returns:
    the multiplication of both

### multiply

    public static Number multiply(Number left,
                                  Character right)

  Multiply a Number by a Character. The character is assumed to be a digit (i.e. '0' through '9') which is converted to its Integer representation.

  Parameters:
    `left` - a Number
    `right` - a Character
  Returns:
    the multiplication of both

### multiply

    public static Number multiply(Character left,
                                  Character right)

  Multiply two Characters. Each character is assumed to be a digit (i.e. '0' through '9') which is converted to its Integer representation.

  Parameters:
    `left` - a Character
    `right` - another Character
  Returns:
    the multiplication of both

### multiply

    public static Number multiply(Number left,
                                  Number right)

  Multiply two Numbers.

  Parameters:
    `left` - a Number
    `right` - another Number
  Returns:
    the multiplication of both

### multiply

    public static Number multiply(BigDecimal left,
                                  Double right)

  Multiply a BigDecimal and a Double. Note: This method was added to enforce the Groovy rule of BigDecimal*Double == Double. Without this method, the multiply(BigDecimal) method in BigDecimal would respond and return a BigDecimal instead. Since BigDecimal is prefered over Number, the Number*Number method is not choosen as in older versions of Groovy.

  Parameters:
    `left` - a BigDecimal
    `right` - a Double
  Returns:
    the multiplication of both

### multiply

    public static Number multiply(BigDecimal left,
                                  BigInteger right)

  Multiply a BigDecimal and a BigInteger. Note: This method was added to enforce the Groovy rule of BigDecimal*long == long. Without this method, the multiply(BigDecimal) method in BigDecimal would respond and return a BigDecimal instead. Since BigDecimal is prefered over Number, the Number*Number method is not choosen as in older versions of Groovy. Biginteger is the fallback for all integer types in Groovy

  Parameters:
    `left` - a BigDecimal
    `right` - a BigInteger
  Returns:
    the multiplication of both

### power

    public static Number power(Number self,
                               Number exponent)

  Power of a Number to a certain exponent. Called by the '**' operator.

  Parameters:
    `self` - a Number
    `exponent` - a Number exponent
  Returns:
    a Number to the power of a certain exponent

### div

    public static Number div(Character left,
                             Number right)

  Divide a Character by a Number. The character is assumed to be a digit (i.e. '0' through '9') which is converted to its Integer representation.

  Parameters:
    `left` - a Character
    `right` - a Number
  Returns:
    the multiplication of both

### div

    public static Number div(Number left,
                             Character right)

  Divide a Number by a Character. The character is assumed to be a digit (i.e. '0' through '9') which is converted to its Integer representation.

  Parameters:
    `left` - a Number
    `right` - a Character
  Returns:
    the multiplication of both

### div

    public static Number div(Character left,
                             Character right)

  Divide one Character by another. Each character is assumed to be a digit (i.e. '0' through '9') which is converted to its Integer representation.

  Parameters:
    `left` - a Character
    `right` - another Character
  Returns:
    the multiplication of both

### div

    public static Number div(Number left,
                             Number right)

  Divide two Numbers.

  Parameters:
    `left` - a Number
    `right` - another Number
  Returns:
    a Number resulting of the divide operation

### intdiv

    public static Number intdiv(Character left,
                                Number right)

  Integer Divide a Character by a Number.

  Parameters:
    `left` - a Character
    `right` - a Number
  Returns:
    the integer division of both

### intdiv

    public static Number intdiv(Number left,
                                Character right)

  Integer Divide a Number by a Character.

  Parameters:
    `left` - a Number
    `right` - a Character
  Returns:
    the integer division of both

### intdiv

    public static Number intdiv(Character left,
                                Character right)

  Integer Divide two Characters.

  Parameters:
    `left` - a Character
    `right` - another Character
  Returns:
    the integer division of both

### intdiv

    public static Number intdiv(Number left,
                                Number right)

  Integer Divide two Numbers.

  Parameters:
    `left` - a Number
    `right` - another Number
  Returns:
    a Number (an Integer) resulting of the integer division operation

### or

    public static Number or(Number left,
                            Number right)

  Bitwise OR together two numbers.

  Parameters:
    `left` - a Number
    `right` - another Number to bitwise OR
  Returns:
    the bitwise OR of both Numbers

### and

    public static Number and(Number left,
                             Number right)

  Bitwise AND together two Numbers.

  Parameters:
    `left` - a Number
    `right` - another Number to bitwise AND
  Returns:
    the bitwise AND of both Numbers

### and

    public static BitSet and(BitSet left,
                             BitSet right)

  Bitwise AND together two BitSets.

  Parameters:
    `left` - a BitSet
    `right` - another BitSet to bitwise AND
  Returns:
    the bitwise AND of both BitSets

### xor

    public static BitSet xor(BitSet left,
                             BitSet right)

  Bitwise XOR together two BitSets. Called when the '^' operator is used between two bit sets.

  Parameters:
    `left` - a BitSet
    `right` - another BitSet to bitwise AND
  Returns:
    the bitwise XOR of both BitSets

### bitwiseNegate

    public static BitSet bitwiseNegate(BitSet self)

  Bitwise NEGATE a BitSet.

  Parameters:
    `self` - a BitSet
  Returns:
    the bitwise NEGATE of the BitSet

### or

    public static BitSet or(BitSet left,
                            BitSet right)

  Bitwise OR together two BitSets. Called when the '|' operator is used between two bit sets.

  Parameters:
    `left` - a BitSet
    `right` - another BitSet to bitwise AND
  Returns:
    the bitwise OR of both BitSets

### xor

    public static Number xor(Number left,
                             Number right)

  Bitwise XOR together two Numbers. Called when the '|' operator is used.

  Parameters:
    `left` - a Number
    `right` - another Number to bitwse XOR
  Returns:
    the bitwise XOR of both Numbers

### mod

    public static Number mod(Number left,
                             Number right)

  Performs a division modulus operation. Called by the '%' operator.

  Parameters:
    `left` - a Number
    `right` - another Number to mod
  Returns:
    the modulus result

### unaryMinus

    public static Number unaryMinus(Number left)

  Negates the number. Equivalent to the '-' operator when it preceeds a single operand, i.e. `-10`

  Parameters:
    `left` - a Number
  Returns:
    the negation of the number

### times

    public static void times(Number self,
                             Closure closure)

  Executes the closure this many times, starting from zero. The current index is passed to the closure each time. Example:

      10.times {
         println it
       }

  Prints the numbers 0 through 9.

  Parameters:
    `self` - a Number
    `closure` - the closure to call a number of times

### upto

    public static void upto(Number self,
                            Number to,
                            Closure closure)

  Iterates from this number up to the given number, inclusive, incrementing by one each time.

  Parameters:
    `self` - a Number
    `to` - another Number to go up to
    `closure` - the closure to call

### upto

    public static void upto(long self,
                            Number to,
                            Closure closure)

  Iterates from this number up to the given number, inclusive, incrementing by one each time.

  Parameters:
    `self` - a long
    `to` - the end number
    `closure` - the code to execute for each number

### upto

    public static void upto(Long self,
                            Number to,
                            Closure closure)

  Iterates from this number up to the given number, inclusive, incrementing by one each time.

  Parameters:
    `self` - a Long
    `to` - the end number
    `closure` - the code to execute for each number

### upto

    public static void upto(float self,
                            Number to,
                            Closure closure)

  Iterates from this number up to the given number, inclusive, incrementing by one each time.

  Parameters:
    `self` - a float
    `to` - the end number
    `closure` - the code to execute for each number

### upto

    public static void upto(Float self,
                            Number to,
                            Closure closure)

  Iterates from this number up to the given number, inclusive, incrementing by one each time.

  Parameters:
    `self` - a Float
    `to` - the end number
    `closure` - the code to execute for each number

### upto

    public static void upto(double self,
                            Number to,
                            Closure closure)

  Iterates from this number up to the given number, inclusive, incrementing by one each time.

  Parameters:
    `self` - a double
    `to` - the end number
    `closure` - the code to execute for each number

### upto

    public static void upto(Double self,
                            Number to,
                            Closure closure)

  Iterates from this number up to the given number, inclusive, incrementing by one each time.

  Parameters:
    `self` - a Double
    `to` - the end number
    `closure` - the code to execute for each number

### upto

    public static void upto(BigInteger self,
                            Number to,
                            Closure closure)

  Iterates from this number up to the given number, inclusive, incrementing by one each time. Example:

      0.upto( 10 ) {
         println it
       }

  Prints numbers 0 to 10

  Parameters:
    `self` - a BigInteger
    `to` - the end number
    `closure` - the code to execute for each number

### upto

    public static void upto(BigDecimal self,
                            Number to,
                            Closure closure)

  Iterates from this number up to the given number, inclusive, incrementing by one each time.

      0.upto( 10 ) {
         println it
       }

  Prints numbers 0.1, 1.1, 2.1... to 9.1

  Parameters:
    `self` - a BigDecimal
    `to` - the end number
    `closure` - the code to execute for each number

### downto

    public static void downto(Number self,
                              Number to,
                              Closure closure)

  Iterates from this number down to the given number, inclusive, decrementing by one each time.

  Parameters:
    `self` - a Number
    `to` - another Number to go down to
    `closure` - the closure to call

### downto

    public static void downto(long self,
                              Number to,
                              Closure closure)

  Iterates from this number down to the given number, inclusive, decrementing by one each time.

  Parameters:
    `self` - a long
    `to` - the end number
    `closure` - the code to execute for each number

### downto

    public static void downto(Long self,
                              Number to,
                              Closure closure)

  Iterates from this number down to the given number, inclusive, decrementing by one each time.

  Parameters:
    `self` - a Long
    `to` - the end number
    `closure` - the code to execute for each number

### downto

    public static void downto(float self,
                              Number to,
                              Closure closure)

  Iterates from this number down to the given number, inclusive, decrementing by one each time.

  Parameters:
    `self` - a float
    `to` - the end number
    `closure` - the code to execute for each number

### downto

    public static void downto(Float self,
                              Number to,
                              Closure closure)

  Iterates from this number down to the given number, inclusive, decrementing by one each time.

  Parameters:
    `self` - a Float
    `to` - the end number
    `closure` - the code to execute for each number

### downto

    public static void downto(double self,
                              Number to,
                              Closure closure)

  Iterates from this number down to the given number, inclusive, decrementing by one each time.

  Parameters:
    `self` - a double
    `to` - the end number
    `closure` - the code to execute for each number

### downto

    public static void downto(Double self,
                              Number to,
                              Closure closure)

  Iterates from this number down to the given number, inclusive, decrementing by one each time.

  Parameters:
    `self` - a Double
    `to` - the end number
    `closure` - the code to execute for each number

### downto

    public static void downto(BigInteger self,
                              Number to,
                              Closure closure)

  Iterates from this number down to the given number, inclusive, decrementing by one each time.

  Parameters:
    `self` - a BigInteger
    `to` - the end number
    `closure` - the code to execute for each number

### downto

    public static void downto(BigDecimal self,
                              Number to,
                              Closure closure)

  Iterates from this number down to the given number, inclusive, decrementing by one each time. Each number is passed to the closure. Example:

      10.5.downto(0) {
         println it
       }

  Prints numbers 10.5, 9.5 ... to 0.5.

  Parameters:
    `self` - a BigDecimal
    `to` - the end number
    `closure` - the code to execute for each number

### step

    public static void step(Number self,
                            Number to,
                            Number stepNumber,
                            Closure closure)

  Iterates from this number up to the given number using a step increment. Each intermediate number is passed to the given closure. Example:

      0.step( 10, 2 ) {
         println it
       }

  Prints even numbers 0 through 8.

  Parameters:
    `self` - a Number to start with
    `to` - a Number to go up to, exclusive
    `stepNumber` - a Number representing the step increment
    `closure` - the closure to call

### abs

    public static int abs(Number number)

  Get the absolute value

  Parameters:
    `number` - a Number
  Returns:
    the absolute value of that Number

### abs

    public static long abs(Long number)

  Get the absolute value

  Parameters:
    `number` - a Long
  Returns:
    the absolute value of that Long

### abs

    public static float abs(Float number)

  Get the absolute value

  Parameters:
    `number` - a Float
  Returns:
    the absolute value of that Float

### abs

    public static double abs(Double number)

  Get the absolute value

  Parameters:
    `number` - a Double
  Returns:
    the absolute value of that Double

### round

    public static int round(Float number)

  Get the absolute value

  Parameters:
    `number` - a Float
  Returns:
    the absolute value of that Float

### round

    public static long round(Double number)

  Round the value

  Parameters:
    `number` - a Double
  Returns:
    the absolute value of that Double

### toInteger

    public static Integer toInteger(String self)

  Parse a String into an Integer

  Parameters:
    `self` - a String
  Returns:
    an Integer

### toLong

    public static Long toLong(String self)

  Parse a String into a Long

  Parameters:
    `self` - a String
  Returns:
    a Long

### toShort

    public static Short toShort(String self)

  Parse a String into a Short

  Parameters:
    `self` - a String
  Returns:
    a Short

### toFloat

    public static Float toFloat(String self)

  Parse a String into a Float

  Parameters:
    `self` - a String
  Returns:
    a Float

### toDouble

    public static Double toDouble(String self)

  Parse a String into a Double

  Parameters:
    `self` - a String
  Returns:
    a Double

### toBigInteger

    public static BigInteger toBigInteger(String self)

  Parse a String into a BigInteger

  Parameters:
    `self` - a String
  Returns:
    a BigInteger

### toBigDecimal

    public static BigDecimal toBigDecimal(String self)

  Parse a String into a BigDecimal

  Parameters:
    `self` - a String
  Returns:
    a BigDecimal

### isInteger

    public static boolean isInteger(String self)

  Determine if a String can be parsed into an Integer.

  Parameters:
    `self` - a String
  Returns:
    true if the string can be parsed

### isLong

    public static boolean isLong(String self)

  Determine if a String can be parsed into a Long.

  Parameters:
    `self` - a String
  Returns:
    true if the string can be parsed

### isFloat

    public static boolean isFloat(String self)

  Determine if a String can be parsed into a Float.

  Parameters:
    `self` - a String
  Returns:
    true if the string can be parsed

### isDouble

    public static boolean isDouble(String self)

  Determine if a String can be parsed into a Double.

  Parameters:
    `self` - a String
  Returns:
    true if the string can be parsed

### isBigInteger

    public static boolean isBigInteger(String self)

  Determine if a String can be parsed into a BigInteger.

  Parameters:
    `self` - a String
  Returns:
    true if the string can be parsed

### isBigDecimal

    public static boolean isBigDecimal(String self)

  Determine if a String can be parsed into a BigDecimal.

  Parameters:
    `self` - a String
  Returns:
    true if the string can be parsed

### isNumber

    public static boolean isNumber(String self)

  Determine if a String can be parsed into a Number. Synonym for 'isBigDecimal()'.

  Parameters:
    `self` - a String
  Returns:
    true if the string can be parsed
  See Also:
    `isBigDecimal(String)`

### isUpperCase

    public static boolean isUpperCase(Character self)

  Determine if a Character is uppercase. Synonym for 'Character.isUpperCase(this)'.

  Parameters:
    `self` - a Character
  Returns:
    true if the character is uppercase
  See Also:
    `Character.isUpperCase(char)`

### isLowerCase

    public static boolean isLowerCase(Character self)

  Determine if a Character is lowercase. Synonym for 'Character.isLowerCase(this)'.

  Parameters:
    `self` - a Character
  Returns:
    true if the character is lowercase
  See Also:
    `Character.isLowerCase(char)`

### isLetter

    public static boolean isLetter(Character self)

  Determines if a character is a letter. Synonym for 'Character.isLetter(this)'.

  Parameters:
    `self` - a Character
  Returns:
    true if the character is a letter
  See Also:
    `Character.isLetter(char)`

### isDigit

    public static boolean isDigit(Character self)

  Determines if a character is a digit. Synonym for 'Character.isDigit(this)'.

  Parameters:
    `self` - a Character
  Returns:
    true if the character is a digit
  See Also:
    `Character.isDigit(char)`

### isLetterOrDigit

    public static boolean isLetterOrDigit(Character self)

  Determines if a character is a letter or digit. Synonym for 'Character.isLetterOrDigit(this)'.

  Parameters:
    `self` - a Character
  Returns:
    true if the character is a letter or digit
  See Also:
    `Character.isLetterOrDigit(char)`

### isWhitespace

    public static boolean isWhitespace(Character self)

  Determines if a character is a whitespace character. Synonym for 'Character.isWhitespace(this)'.

  Parameters:
    `self` - a Character
  Returns:
    true if the character is a whitespace character
  See Also:
    `Character.isWhitespace(char)`

### toUpperCase

    public static char toUpperCase(Character self)

  Converts the character to uppercase. Synonym for 'Character.toUpperCase(this)'.

  Parameters:
    `self` - a Character to convert
  Returns:
    the uppercase equivalent of the character, if any; otherwise, the character itself.
  See Also:
    `Character.isUpperCase(char)`, `String.toUpperCase()`

### toLowerCase

    public static char toLowerCase(Character self)

  Converts the character to lowercase. Synonym for 'Character.toLowerCase(this)'.

  Parameters:
    `self` - a Character to convert
  Returns:
    the lowercase equivalent of the character, if any; otherwise, the character itself.
  See Also:
    `Character.isLowerCase(char)`, `String.toLowerCase()`

### toInteger

    public static Integer toInteger(Number self)

  Transform a Number into an Integer

  Parameters:
    `self` - a Number
  Returns:
    an Integer

### toLong

    public static Long toLong(Number self)

  Transform a Number into a Long

  Parameters:
    `self` - a Number
  Returns:
    an Long

### toFloat

    public static Float toFloat(Number self)

  Transform a Number into a Float

  Parameters:
    `self` - a Number
  Returns:
    an Float

### toDouble

    public static Double toDouble(Number self)

  Transform a Number into a Double

  Parameters:
    `self` - a Number
  Returns:
    an Double

### toBigDecimal

    public static BigDecimal toBigDecimal(Number self)

  Transform a Number into a BigDecimal

  Parameters:
    `self` - a Number
  Returns:
    an BigDecimal

### asType

    public static Object asType(Number self,
                                Class c)

  Transform this number to a the given type, using the 'as' operator. The following types are supported in addition to the default `asType(Object,Class)`:
  - BigDecimal
  - BigInteger
  - Double
  - Float

  Parameters:
    `self` - this number
    `c` - the desired type of the transformed result
  Returns:
    an instance of the given type

### toBigInteger

    public static BigInteger toBigInteger(Number self)

  Transform this Number into a BigInteger.

  Parameters:
    `self` - a Number
  Returns:
    an BigInteger

### next

    public static Date next(Date self)

  Increment a Date by one day.

  Parameters:
    `self` - a Date
  Returns:
    the next days date

### next

    public static Date next(Date self)

  Increment a java.sql.Date by one day.

  Parameters:
    `self` - a java.sql.Date
  Returns:
    the next days date

### previous

    public static Date previous(Date self)

  Decrement a Date by one day.

  Parameters:
    `self` - a Date
  Returns:
    the previous days date

### previous

    public static Date previous(Date self)

  Decrement a java.sql.Date by one day.

  Parameters:
    `self` - a java.sql.Date
  Returns:
    the previous days date

### plus

    public static Date plus(Date self,
                            int days)

  Add a number of days to this date and returns the new date.

  Parameters:
    `self` - a Date
    `days` - the number of days to increase
  Returns:
    the new date

### plus

    public static Date plus(Date self,
                            int days)

  Add a number of days to this date and returns the new date.

  Parameters:
    `self` - a java.sql.Date
    `days` - the number of days to increase
  Returns:
    the new date

### minus

    public static Date minus(Date self,
                             int days)

  Subtract a number of days from this date and returns the new date.

  Parameters:
    `self` - a Date
    `days` - the number of days to subtract
  Returns:
    the new date

### minus

    public static Date minus(Date self,
                             int days)

  Subtract a number of days from this date and returns the new date.

  Parameters:
    `self` - a java.sql.Date
    `days` - the number of days to subtract
  Returns:
    the new date

### format

    public static String format(Date self,
                                String format)

  Return a String representing this date in the given format.

  Parameters:
    `self` -
    `format` - the format pattern to use according to `SimpleDateFormat`
  Returns:
    a string representation of this date.
  See Also:
    `SimpleDateFormat`

### getDateString

    public static String getDateString(Date self)

  Return a string representation of the 'day' portion of this date according to the locale-specific format used by `DateFormat`

  Parameters:
    `self` -
  Returns:
    a string representation of this date
  See Also:
    `DateFormat.getDateInstance(int)`, `DateFormat.SHORT`

### getTimeString

    public static String getTimeString(Date self)

  Return a string representation of the time portion of this date according to the locale-specific format used by `DateFormat`

  Parameters:
    `self` -
  Returns:
    a string representing the time portion of this date
  See Also:
    `DateFormat.getTimeInstance(int)`, `DateFormat.MEDIUM`

### getDateTimeString

    public static String getDateTimeString(Date self)

  Return a string representation of the date and time time portion of this Date instance, according to the locale-specific format used by `DateFormat`. This method uses the `DateFormat.SHORT` preset for the day portion and `DateFormat.MEDIUM` for the time portion of the string

  Parameters:
    `self` -
  Returns:
    a string representation of this date and time
  See Also:
    `DateFormat.getDateTimeInstance(int, int)`

### and

    public static Boolean and(Boolean left,
                              Boolean right)

### or

    public static Boolean or(Boolean left,
                             Boolean right)

### xor

    public static Boolean xor(Boolean left,
                              Boolean right)

### newObjectInputStream

    public static ObjectInputStream newObjectInputStream(File file)
                                                  throws IOException

  Create an object input stream for this file.

  Parameters:
    `file` - a file
  Returns:
    an object input stream
  Throws:
    `IOException` - if an IOException occurs.

### newObjectOutputStream

    public static ObjectOutputStream newObjectOutputStream(File file)
                                                    throws IOException

  Create an object output stream for this file.

  Parameters:
    `file` - a file
  Returns:
    an object output stream
  Throws:
    `IOException` - if an IOException occurs.

### eachObject

    public static void eachObject(File self,
                                  Closure closure)
                           throws IOException,
                                  ClassNotFoundException

  Iterates through the given file object by object.

  Parameters:
    `self` - a File
    `closure` - a closure
  Throws:
    `IOException` - if an IOException occurs.
    `ClassNotFoundException` - if the class is not found.
  See Also:
    `eachObject(ObjectInputStream,Closure)`

### eachObject

    public static void eachObject(ObjectInputStream ois,
                                  Closure closure)
                           throws IOException,
                                  ClassNotFoundException

  Iterates through the given object stream object by object. The ObjectInputStream is closed afterwards.

  Parameters:
    `ois` - an ObjectInputStream, closed after the operation
    `closure` - a closure
  Throws:
    `IOException` - if an IOException occurs.
    `ClassNotFoundException` - if the class is not found.

### withObjectInputStream

    public static Object withObjectInputStream(File file,
                                               Closure closure)
                                        throws IOException

  Create a new ObjectInputStream for this file and pass it to the closure. This method ensures the stream is closed after the closure returns.

  Parameters:
    `file` - a File
    `closure` - a closure
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `withStream(InputStream,Closure)`

### withObjectOutputStream

    public static Object withObjectOutputStream(File file,
                                                Closure closure)
                                         throws IOException

  Create a new ObjectOutputStream for this file and then pass it to the closure. This method ensures the stream is closed after the closure returns.

  Parameters:
    `file` - a File
    `closure` - a closure
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `withStream(OutputStream,Closure)`

### eachLine

    public static Object eachLine(String self,
                                  Closure closure)

  Iterates through this String line by line. Each line is passed to the given 1 or 2 arg closure. If a 2 arg closure is found the line count is passed as the second argument.

  Parameters:
    `self` - a String
    `closure` - a closure
  Returns:
    the last value returned by the closure
  See Also:
    `eachLine(String, int, groovy.lang.Closure)`

### eachLine

    public static Object eachLine(String self,
                                  int firstLine,
                                  Closure closure)

  Iterates through this String line by line. Each line is passed to the given 1 or 2 arg closure. If a 2 arg closure is found the line count is passed as the second argument.

  Parameters:
    `self` - a String
    `firstLine` - the count of the first line
    `closure` - a closure
  Returns:
    the last value returned by the closure

### eachLine

    public static Object eachLine(File self,
                                  Closure closure)
                           throws IOException

  Iterates through this file line by line. Each line is passed to the given 1 or 2 arg closure. The file reader is closed before this method returns.

  Parameters:
    `self` - a File
    `closure` - a closure
  Returns:
    the last value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `eachLine(java.io.File, int, groovy.lang.Closure)`

### eachLine

    public static Object eachLine(File self,
                                  int firstLine,
                                  Closure closure)
                           throws IOException

  Iterates through this file line by line. Each line is passed to the given 1 or 2 arg closure. The file reader is closed before this method returns.

  Parameters:
    `self` - a File
    `firstLine` - the count of the first line
    `closure` - a closure
  Returns:
    the last value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `eachLine(java.io.Reader, int, groovy.lang.Closure)`

### eachLine

    public static Object eachLine(InputStream stream,
                                  String charset,
                                  Closure closure)
                           throws IOException

  Iterates through this stream reading with the provided charset, passing each line to the given 1 or 2 arg closure. The stream is closed before this method returns.

  Parameters:
    `stream` - a stream
    `charset` - opens the stream with a specified charset
    `closure` - a closure
  Returns:
    the last value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `eachLine(java.io.InputStream, String, int, groovy.lang.Closure)`

### eachLine

    public static Object eachLine(InputStream stream,
                                  String charset,
                                  int firstLine,
                                  Closure closure)
                           throws IOException

  Iterates through this stream reading with the provided charset, passing each line to the given 1 or 2 arg closure. The stream is closed after this method returns.

  Parameters:
    `stream` - a stream
    `charset` - opens the stream with a specified charset
    `firstLine` - the count of the first line
    `closure` - a closure
  Returns:
    the last value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `eachLine(Reader,Closure)`

### eachLine

    public static Object eachLine(InputStream stream,
                                  Closure closure)
                           throws IOException

  Iterates through this stream, passing each line to the given 1 or 2 arg closure. The stream is closed before this method returns.

  Parameters:
    `stream` - a stream
    `closure` - a closure
  Returns:
    the last value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `eachLine(java.io.InputStream, int, groovy.lang.Closure)`

### eachLine

    public static Object eachLine(InputStream stream,
                                  int firstLine,
                                  Closure closure)
                           throws IOException

  Iterates through this stream, passing each line to the given 1 or 2 arg closure. The stream is closed before this method returns.

  Parameters:
    `stream` - a stream
    `firstLine` - the count of the first line
    `closure` - a closure
  Returns:
    the last value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `eachLine(java.io.Reader, int, groovy.lang.Closure)`

### eachLine

    public static Object eachLine(URL url,
                                  Closure closure)
                           throws IOException

  Iterates through the lines read from the URL's associated input stream passing each line to the given 1 or 2 arg closure. The stream is closed before this method returns.

  Parameters:
    `url` - a URL to open and read
    `closure` - a closure to apply on each line
  Returns:
    the last value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `eachLine(java.net.URL, int, groovy.lang.Closure)`

### eachLine

    public static Object eachLine(URL url,
                                  int firstLine,
                                  Closure closure)
                           throws IOException

  Iterates through the lines read from the URL's associated input stream passing each line to the given 1 or 2 arg closure. The stream is closed before this method returns.

  Parameters:
    `url` - a URL to open and read
    `firstLine` - the count of the first line
    `closure` - a closure to apply on each line
  Returns:
    the last value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `eachLine(java.io.InputStream, int, groovy.lang.Closure)`

### eachLine

    public static Object eachLine(URL url,
                                  String charset,
                                  Closure closure)
                           throws IOException

  Iterates through the lines read from the URL's associated input stream passing each line to the given 1 or 2 arg closure. The stream is closed before this method returns.

  Parameters:
    `url` - a URL to open and read
    `charset` - opens the stream with a specified charset
    `closure` - a closure to apply on each line
  Returns:
    the last value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `eachLine(java.net.URL, String, int, groovy.lang.Closure)`

### eachLine

    public static Object eachLine(URL url,
                                  String charset,
                                  int firstLine,
                                  Closure closure)
                           throws IOException

  Iterates through the lines read from the URL's associated input stream passing each line to the given 1 or 2 arg closure. The stream is closed before this method returns.

  Parameters:
    `url` - a URL to open and read
    `charset` - opens the stream with a specified charset
    `firstLine` - the count of the first line
    `closure` - a closure to apply on each line
  Returns:
    the last value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `eachLine(java.io.Reader, int, groovy.lang.Closure)`

### eachLine

    public static Object eachLine(Reader self,
                                  Closure closure)
                           throws IOException

  Iterates through the given reader line by line. Each line is passed to the given 1 or 2 arg closure. If the closure has two arguments, the line count is passed as the second argument. The Reader is closed before this method returns.

  Parameters:
    `self` - a Reader, closed after the method returns
    `closure` - a closure
  Returns:
    the last value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.

### eachLine

    public static Object eachLine(Reader self,
                                  int firstLine,
                                  Closure closure)
                           throws IOException

  Iterates through the given reader line by line. Each line is passed to the given 1 or 2 arg closure. If the closure has two arguments, the line count is passed as the second argument. The Reader is closed before this method returns.

  Parameters:
    `self` - a Reader, closed after the method returns
    `firstLine` - the count of the first line
    `closure` - a closure which will be passed each line (or for 2 argument closures the line and count)
  Returns:
    the last value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.

### splitEachLine

    public static Object splitEachLine(File self,
                                       String sep,
                                       Closure closure)
                                throws IOException

  Iterates through this file line by line, splitting on the seperator. The list of tokens for each line is then passed to the given closure. Finally the resources used for processing the file are closed.

  Parameters:
    `self` - a File
    `sep` - a String separator
    `closure` - a closure
  Returns:
    the last value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `splitEachLine(Reader,String,Closure)`

### splitEachLine

    public static Object splitEachLine(Reader self,
                                       String sep,
                                       Closure closure)
                                throws IOException

  Iterates through the given reader line by line, splitting each line using the given separator. The list of tokens for each line is then passed to the given closure. The Reader is closed afterwards.

  Parameters:
    `self` - a Reader, closed after the method returns
    `sep` - a String separator
    `closure` - a closure
  Returns:
    the last value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `String.split(String)`

### splitEachLine

    public static Object splitEachLine(InputStream stream,
                                       String sep,
                                       String charset,
                                       Closure closure)
                                throws IOException

  Iterates through the given InputStream line by line using the specified encoding, splitting each line using the given separator. The list of tokens for each line is then passed to the given closure. Finally, the stream is closed.

  Parameters:
    `stream` - an InputStream
    `sep` - a String separator
    `charset` - opens the stream with a specified charset
    `closure` - a closure
  Returns:
    the last value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `splitEachLine(Reader,String,Closure)`

### splitEachLine

    public static Object splitEachLine(InputStream stream,
                                       String sep,
                                       Closure closure)
                                throws IOException

  Iterates through the given InputStream line by line, splitting each line using the given separator. The list of tokens for each line is then passed to the given closure. The stream is closed before the method returns.

  Parameters:
    `stream` - an InputStream
    `sep` - a String separator
    `closure` - a closure
  Returns:
    the last value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `splitEachLine(Reader,String,Closure)`

### splitEachLine

    public static Object splitEachLine(String self,
                                       String sep,
                                       Closure closure)

  Iterates through the given String line by line, splitting each line using the given separator. The list of tokens for each line is then passed to the given closure.

  Parameters:
    `self` - a String
    `sep` - a String separator
    `closure` - a closure
  Returns:
    the last value returned by the closure
  See Also:
    `String.split(String)`

### readLine

    public static String readLine(Reader self)
                           throws IOException

  Read a single, whole line from the given Reader.

  Parameters:
    `self` - a Reader
  Returns:
    a line
  Throws:
    `IOException` - if an IOException occurs.

### readLine

    public static String readLine(InputStream stream)
                           throws IOException

  Deprecated. use Reader#readLine instead please

  Just throws a DeprecationException. DO NOT USE. It used to read a single, whole line from the given InputStream.

  Parameters:
    `stream` - an InputStream
  Returns:
    a line
  Throws:
    `IOException` - if an IOException occurs.

### readLines

    public static List readLines(String self)

  Return the lines of a String as a List of Strings.

  Parameters:
    `self` - a String object
  Returns:
    a list of lines

### readLines

    public static List readLines(File file)
                          throws IOException

  Reads the file into a list of Strings, with one item for each line.

  Parameters:
    `file` - a File
  Returns:
    a List of lines
  Throws:
    `IOException` - if an IOException occurs.

### getText

    public static String getText(File file,
                                 String charset)
                          throws IOException

  Read the content of the File using the specified encoding and return it as a String.

  Parameters:
    `file` - the file whose content we want to read
    `charset` - the charset used to read the content of the file
  Returns:
    a String containing the content of the file
  Throws:
    `IOException` - if an IOException occurs.

### getText

    public static String getText(File file)
                          throws IOException

  Read the content of the File and returns it as a String.

  Parameters:
    `file` - the file whose content we want to read
  Returns:
    a String containing the content of the file
  Throws:
    `IOException` - if an IOException occurs.

### getText

    public static String getText(URL url)
                          throws IOException

  Read the content of this URL and returns it as a String.

  Parameters:
    `url` - URL to read content from
  Returns:
    the text from that URL
  Throws:
    `IOException` - if an IOException occurs.

### getText

    public static String getText(URL url,
                                 String charset)
                          throws IOException

  Read the data from this URL and return it as a String. The connection stream is closed before this method returns.

  Parameters:
    `url` - URL to read content from
    `charset` - opens the stream with a specified charset
  Returns:
    the text from that URL
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `URLConnection.getInputStream()`

### getText

    public static String getText(InputStream is)
                          throws IOException

  Read the content of this InputStream and return it as a String. The stream is closed before this method returns.

  Parameters:
    `is` - an input stream
  Returns:
    the text from that URL
  Throws:
    `IOException` - if an IOException occurs.

### getText

    public static String getText(InputStream is,
                                 String charset)
                          throws IOException

  Read the content of this InputStream using specified charset and return it as a String. The stream is closed before this method returns.

  Parameters:
    `is` - an input stream
    `charset` - opens the stream with a specified charset
  Returns:
    the text from that URL
  Throws:
    `IOException` - if an IOException occurs.

### getText

    public static String getText(Reader reader)
                          throws IOException

  Read the content of the Reader and return it as a String. The reader is closed before this method returns.

  Parameters:
    `reader` - a Reader whose content we want to read
  Returns:
    a String containing the content of the buffered reader
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `getText(BufferedReader)`

### getText

    public static String getText(BufferedReader reader)
                          throws IOException

  Read the content of the BufferedReader and return it as a String. The BufferedReader is closed afterwards.

  Parameters:
    `reader` - a BufferedReader whose content we want to read
  Returns:
    a String containing the content of the buffered reader
  Throws:
    `IOException` - if an IOException occurs.

### writeLine

    public static void writeLine(BufferedWriter writer,
                                 String line)
                          throws IOException

  Write the text and append a newline (using the platform's line-ending).

  Parameters:
    `writer` - a BufferedWriter
    `line` - the line to write
  Throws:
    `IOException` - if an IOException occurs.

### write

    public static void write(File file,
                             String text)
                      throws IOException

  Write the text to the File.

  Parameters:
    `file` - a File
    `text` - the text to write to the File
  Throws:
    `IOException` - if an IOException occurs.

### setText

    public static void setText(File file,
                               String text)
                        throws IOException

  Synonym for write(text) allowing file.text = 'foo'.

  Parameters:
    `file` - a File
    `text` - the text to write to the File
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `write(File, String)`

### leftShift

    public static File leftShift(File file,
                                 Object text)
                          throws IOException

  Write the text to the File.

  Parameters:
    `file` - a File
    `text` - the text to write to the File
  Returns:
    the original file
  Throws:
    `IOException` - if an IOException occurs.

### leftShift

    public static File leftShift(File file,
                                 byte[] bytes)
                          throws IOException

  Write bytes to a File.

  Parameters:
    `file` - a File
    `bytes` - the byte array to append to the end of the File
  Returns:
    the original file
  Throws:
    `IOException` - if an IOException occurs.

### write

    public static void write(File file,
                             String text,
                             String charset)
                      throws IOException

  Write the text to the File, using the specified encoding.

  Parameters:
    `file` - a File
    `text` - the text to write to the File
    `charset` - the charset used
  Throws:
    `IOException` - if an IOException occurs.

### append

    public static void append(File file,
                              Object text)
                       throws IOException

  Append the text at the end of the File.

  Parameters:
    `file` - a File
    `text` - the text to append at the end of the File
  Throws:
    `IOException` - if an IOException occurs.

### append

    public static void append(File file,
                              byte[] bytes)
                       throws IOException

  Append bytes to the end of a File.

  Parameters:
    `file` - a File
    `bytes` - the byte array to append to the end of the File
  Throws:
    `IOException` - if an IOException occurs.

### append

    public static void append(File file,
                              Object text,
                              String charset)
                       throws IOException

  Append the text at the end of the File, using a specified encoding.

  Parameters:
    `file` - a File
    `text` - the text to append at the end of the File
    `charset` - the charset used
  Throws:
    `IOException` - if an IOException occurs.

### readLines

    public static List readLines(Reader reader)
                          throws IOException

  Reads the reader into a list of Strings, with one entry for each line. The reader is closed before this method returns.

  Parameters:
    `reader` - a Reader
  Returns:
    a List of lines
  Throws:
    `IOException` - if an IOException occurs.

### eachFile

    public static void eachFile(File self,
                                Closure closure)
                         throws FileNotFoundException,
                                IllegalArgumentException

  Invokes the closure for each file in the given directory

  Parameters:
    `self` - a File
    `closure` - a closure
  Throws:
    `FileNotFoundException` - if the given directory does not exist
    `IllegalArgumentException` - if the provided File object does not represent a directory
  See Also:
    `File.listFiles()`

### eachDir

    public static void eachDir(File self,
                               Closure closure)
                        throws FileNotFoundException,
                               IllegalArgumentException

  Invokes the closure for each directory in this directory, ignoring regular files.

  Parameters:
    `self` - a directory
    `closure` - a closure
  Throws:
    `FileNotFoundException` - if the given directory does not exist
    `IllegalArgumentException` - if the provided File object does not represent a directory

### eachFileRecurse

    public static void eachFileRecurse(File self,
                                       Closure closure)
                                throws FileNotFoundException,
                                       IllegalArgumentException

  Invokes the closure for each descendant file in this directory. Sub-directories are recursively searched in a depth-first fashion.

  Parameters:
    `self` - a File
    `closure` - a closure
  Throws:
    `FileNotFoundException` - if the given directory does not exist
    `IllegalArgumentException` - if the provided File object does not represent a directory

### eachDirRecurse

    public static void eachDirRecurse(File self,
                                      Closure closure)
                               throws FileNotFoundException,
                                      IllegalArgumentException

  Invokes the closure for each descendant directory of this directory. Sub-directories are recursively searched in a depth-first fashion. Only directories are passed to the closure; regular files are ignored.

  Parameters:
    `self` - a directory
    `closure` - a closure
  Throws:
    `FileNotFoundException` - if the given directory does not exist
    `IllegalArgumentException` - if the provided File object does not represent a directory
  Since:
    1.1 beta 1
  See Also:
    `eachFileRecurse(File,Closure,boolean)`

### eachFileMatch

    public static void eachFileMatch(File self,
                                     Object filter,
                                     Closure closure)
                              throws FileNotFoundException,
                                     IllegalArgumentException

  Invokes the closure for each file whose name (file.name) matches the given filter in the given directory - calling the isCase() method to determine if a match occurs. This method can be used with different kinds of filters like regular expressions, classes, ranges etc.

  Parameters:
    `self` - a file
    `filter` - the filter to perform on the directory (using the isCase(object) method)
    `closure` - the closure to invoke
  Throws:
    `FileNotFoundException` - if the given directory does not exist
    `IllegalArgumentException` - if the provided File object does not represent a directory

### eachDirMatch

    public static void eachDirMatch(File self,
                                    Object filter,
                                    Closure closure)
                             throws FileNotFoundException,
                                    IllegalArgumentException

  Invokes the closure for each directory whose name (dir.name) matches the given filter in the given directory - calling the isCase() method to determine if a match occurs. This method can be used with different kinds of filters like regular expressions, classes, ranges etc.

  Parameters:
    `self` - a file
    `filter` - the filter to perform on the directory (using the isCase(object) method)
    `closure` - the closure to invoke
  Throws:
    `FileNotFoundException` - if the given directory does not exist
    `IllegalArgumentException` - if the provided File object does not represent a directory
  Since:
    1.1 beta 1

### runAfter

    public static TimerTask runAfter(Timer timer,
                                     int delay,
                                     Closure closure)

  Allows a simple syntax for using timers. This timer will execute the given closure after the given delay.

  Parameters:
    `timer` - a timer object
    `delay` - the delay in milliseconds before running the closure code
    `closure` - the closure to invoke
  Returns:
    The timer task which has been scheduled.

### newReader

    public static BufferedReader newReader(File file)
                                    throws IOException

  Create a buffered reader for this file.

  Parameters:
    `file` - a File
  Returns:
    a BufferedReader
  Throws:
    `IOException` - if an IOException occurs.

### newReader

    public static BufferedReader newReader(File file,
                                           String charset)
                                    throws FileNotFoundException,
                                           UnsupportedEncodingException

  Create a buffered reader for this file, using the specified charset as the encoding.

  Parameters:
    `file` - a File
    `charset` - the charset for this File
  Returns:
    a BufferedReader
  Throws:
    `FileNotFoundException` - if the File was not found
    `UnsupportedEncodingException` - if the encoding specified is not supported

### newReader

    public static BufferedReader newReader(InputStream self)

  Creates a reader for this input stream.

  Parameters:
    `self` - an input stream
  Returns:
    a reader

### newReader

    public static BufferedReader newReader(InputStream self,
                                           String charset)
                                    throws UnsupportedEncodingException

  Creates a reader for this input stream, using the specified charset as the encoding.

  Parameters:
    `self` - an input stream
    `charset` - the charset for this input stream
  Returns:
    a reader
  Throws:
    `UnsupportedEncodingException` - if the encoding specified is not supported

### withReader

    public static Object withReader(File file,
                                    Closure closure)
                             throws IOException

  Create a new BufferedReader for this file and then passes it into the closure, ensuring the reader is closed after the closure returns.

  Parameters:
    `file` - a file object
    `closure` - a closure
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.

### withReader

    public static Object withReader(File file,
                                    String charset,
                                    Closure closure)
                             throws IOException

  Create a new BufferedReader for this file using the specified charset and then passes it into the closure, ensuring the reader is closed after the closure returns.

  Parameters:
    `file` - a file object
    `charset` - the charset for this input stream
    `closure` - a closure
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.

### newOutputStream

    public static BufferedOutputStream newOutputStream(File file)
                                                throws IOException

  Create a buffered output stream for this file.

  Parameters:
    `file` - a file object
  Returns:
    the created OutputStream
  Throws:
    `IOException` - if an IOException occurs.

### newDataOutputStream

    public static DataOutputStream newDataOutputStream(File file)
                                                throws IOException

  Creates a new data output stream for this file.

  Parameters:
    `file` - a file object
  Returns:
    the created DataOutputStream
  Throws:
    `IOException` - if an IOException occurs.

### withOutputStream

    public static Object withOutputStream(File file,
                                          Closure closure)
                                   throws IOException

  Creates a new OutputStream for this file and passes it into the closure. This method ensures the stream is closed after the closure returns.

  Parameters:
    `file` - a File
    `closure` - a closure
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `withStream(OutputStream,Closure)`

### withInputStream

    public static Object withInputStream(File file,
                                         Closure closure)
                                  throws IOException

  Create a new InputStream for this file and passes it into the closure. This method ensures the stream is closed after the closure returns.

  Parameters:
    `file` - a File
    `closure` - a closure
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `withStream(InputStream,Closure)`

### withInputStream

    public static Object withInputStream(URL url,
                                         Closure closure)
                                  throws IOException

  Creates a new InputStream for this URL and passes it into the closure. This method ensures the stream is closed after the closure returns.

  Parameters:
    `url` - a URL
    `closure` - a closure
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `withStream(InputStream,Closure)`

### withDataOutputStream

    public static Object withDataOutputStream(File file,
                                              Closure closure)
                                       throws IOException

  Create a new DataOutputStream for this file and passes it into the closure. This method ensures the stream is closed after the closure returns.

  Parameters:
    `file` - a File
    `closure` - a closure
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `withStream(OutputStream,Closure)`

### withDataInputStream

    public static Object withDataInputStream(File file,
                                             Closure closure)
                                      throws IOException

  Create a new DataInputStream for this file and passes it into the closure. This method ensures the stream is closed after the closure returns.

  Parameters:
    `file` - a File
    `closure` - a closure
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `withStream(InputStream,Closure)`

### newWriter

    public static BufferedWriter newWriter(File file)
                                    throws IOException

  Create a buffered writer for this file.

  Parameters:
    `file` - a File
  Returns:
    a BufferedWriter
  Throws:
    `IOException` - if an IOException occurs.

### newWriter

    public static BufferedWriter newWriter(File file,
                                           boolean append)
                                    throws IOException

  Creates a buffered writer for this file, optionally appending to the existing file content.

  Parameters:
    `file` - a File
    `append` - true if data should be appended to the file
  Returns:
    a BufferedWriter
  Throws:
    `IOException` - if an IOException occurs.

### newWriter

    public static BufferedWriter newWriter(File file,
                                           String charset,
                                           boolean append)
                                    throws IOException

  Helper method to create a buffered writer for a file. If the given charset is "UTF-16BE" or "UTF-16LE", the requisite byte order mark is written to the stream before the writer is returned.

  Parameters:
    `file` - a File
    `charset` - the name of the encoding used to write in this file
    `append` - true if in append mode
  Returns:
    a BufferedWriter
  Throws:
    `IOException` - if an IOException occurs.

### newWriter

    public static BufferedWriter newWriter(File file,
                                           String charset)
                                    throws IOException

  Creates a buffered writer for this file, writing data using the given encoding.

  Parameters:
    `file` - a File
    `charset` - the name of the encoding used to write in this file
  Returns:
    a BufferedWriter
  Throws:
    `IOException` - if an IOException occurs.

### withWriter

    public static Object withWriter(File file,
                                    Closure closure)
                             throws IOException

  Creates a new BufferedWriter for this file, passes it to the closure, and ensures the stream is flushed and closed after the closure returns.

  Parameters:
    `file` - a File
    `closure` - a closure
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.

### withWriter

    public static Object withWriter(File file,
                                    String charset,
                                    Closure closure)
                             throws IOException

  Creates a new BufferedWriter for this file, passes it to the closure, and ensures the stream is flushed and closed after the closure returns. The writer will use the given charset encoding.

  Parameters:
    `file` - a File
    `charset` - the charset used
    `closure` - a closure
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.

### withWriterAppend

    public static Object withWriterAppend(File file,
                                          String charset,
                                          Closure closure)
                                   throws IOException

  Create a new BufferedWriter which will append to this file. The writer is passed to the closure and will be closed before this method returns.

  Parameters:
    `file` - a File
    `charset` - the charset used
    `closure` - a closure
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.

### withWriterAppend

    public static Object withWriterAppend(File file,
                                          Closure closure)
                                   throws IOException

  Create a new BufferedWriter for this file in append mode. The writer is passed to the closure and is closed after the closure returns.

  Parameters:
    `file` - a File
    `closure` - a closure
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.

### newPrintWriter

    public static PrintWriter newPrintWriter(File file)
                                      throws IOException

  Create a new PrintWriter for this file.

  Parameters:
    `file` - a File
  Returns:
    the created PrintWriter
  Throws:
    `IOException` - if an IOException occurs.

### newPrintWriter

    public static PrintWriter newPrintWriter(File file,
                                             String charset)
                                      throws IOException

  Create a new PrintWriter for this file, using specified charset.

  Parameters:
    `file` - a File
    `charset` - the charset
  Returns:
    a PrintWriter
  Throws:
    `IOException` - if an IOException occurs.

### withPrintWriter

    public static Object withPrintWriter(File file,
                                         Closure closure)
                                  throws IOException

  Create a new PrintWriter for this file which is then passed it into the given closure. This method ensures its the writer is closed after the closure returns.

  Parameters:
    `file` - a File
    `closure` - the closure to invoke with the PrintWriter
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.

### withPrintWriter

    public static Object withPrintWriter(File file,
                                         String charset,
                                         Closure closure)
                                  throws IOException

  Create a new PrintWriter with a specified charset for this file. The writer is passed to the closure, and will be closed before this method returns.

  Parameters:
    `file` - a File
    `charset` - the charset
    `closure` - the closure to invoke with the PrintWriter
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.

### withWriter

    public static Object withWriter(Writer writer,
                                    Closure closure)
                             throws IOException

  Allows this writer to be used within the closure, ensuring that it is flushed and closed before this method returns.

  Parameters:
    `writer` - the writer which is used and then closed
    `closure` - the closure that the writer is passed into
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.

### withReader

    public static Object withReader(Reader reader,
                                    Closure closure)
                             throws IOException

  Allows this reader to be used within the closure, ensuring that it is closed before this method returns.

  Parameters:
    `reader` - the reader which is used and then closed
    `closure` - the closure that the writer is passed into
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.

### withStream

    public static Object withStream(InputStream stream,
                                    Closure closure)
                             throws IOException

  Allows this input stream to be used within the closure, ensuring that it is flushed and closed before this method returns.

  Parameters:
    `stream` - the stream which is used and then closed
    `closure` - the closure that the stream is passed into
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.

### readLines

    public static List readLines(InputStream stream)
                          throws IOException

  Reads the stream into a list, with one element for each line.

  Parameters:
    `stream` - a stream
  Returns:
    a List of lines
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `readLines(Reader)`

### withReader

    public static Object withReader(URL url,
                                    Closure closure)
                             throws IOException

  Helper method to create a new BufferedReader for a URL and then passes it to the closure. The reader is closed after the closure returns.

  Parameters:
    `url` - a URL
    `closure` - the closure to invoke with the reader
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.

### withReader

    public static Object withReader(URL url,
                                    String charset,
                                    Closure closure)
                             throws IOException

  Helper method to create a new Reader for a URL and then passes it to the closure. The reader is closed after the closure returns.

  Parameters:
    `url` - a URL
    `charset` - the charset used
    `closure` - the closure to invoke with the reader
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.

### withReader

    public static Object withReader(InputStream in,
                                    Closure closure)
                             throws IOException

  Helper method to create a new Reader for a stream and then passes it into the closure. The reader (and this stream) is closed after the closure returns.

  Parameters:
    `in` - a stream
    `closure` - the closure to invoke with the InputStream
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `InputStreamReader`

### withReader

    public static Object withReader(InputStream in,
                                    String charset,
                                    Closure closure)
                             throws IOException

  Helper method to create a new Reader for a stream and then passes it into the closure. The reader (and this stream) is closed after the closure returns.

  Parameters:
    `in` - a stream
    `charset` - the charset used to decode the stream
    `closure` - the closure to invoke with the reader
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `InputStreamReader`

### withWriter

    public static Object withWriter(OutputStream stream,
                                    Closure closure)
                             throws IOException

  Creates a writer from this stream, passing it to the given closure. This method ensures the stream is closed after the closure returns.

  Parameters:
    `stream` - the stream which is used and then closed
    `closure` - the closure that the writer is passed into
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `withWriter(Writer,Closure)`

### withWriter

    public static Object withWriter(OutputStream stream,
                                    String charset,
                                    Closure closure)
                             throws IOException

  Creates a writer from this stream, passing it to the given closure. This method ensures the stream is closed after the closure returns.

  Parameters:
    `stream` - the stream which is used and then closed
    `charset` - the charset used
    `closure` - the closure that the writer is passed into
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `withWriter(Writer,Closure)`

### withStream

    public static Object withStream(OutputStream os,
                                    Closure closure)
                             throws IOException

  Passes this OutputStream to the closure, ensuring that the stream is closed after the closure returns, regardless of errors.

  Parameters:
    `os` - the stream which is used and then closed
    `closure` - the closure that the stream is passed into
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.

### newInputStream

    public static BufferedInputStream newInputStream(File file)
                                              throws FileNotFoundException

  Creates a buffered input stream for this file.

  Parameters:
    `file` - a File
  Returns:
    a BufferedInputStream of the file
  Throws:
    `FileNotFoundException` - if the file is not found.

### newInputStream

    public static BufferedInputStream newInputStream(URL url)
                                              throws MalformedURLException,
                                                     IOException

  Creates a buffered input stream for this URL.

  Parameters:
    `url` - a URL
  Returns:
    a BufferedInputStream for the URL
  Throws:
    `MalformedURLException` - is thrown if the URL is not well formed
    `IOException` - if an I/O error occurs while creating the input stream

### newReader

    public static BufferedReader newReader(URL url)
                                    throws MalformedURLException,
                                           IOException

  Creates a buffered reader for this URL.

  Parameters:
    `url` - a URL
  Returns:
    a BufferedReader for the URL
  Throws:
    `MalformedURLException` - is thrown if the URL is not well formed
    `IOException` - if an I/O error occurs while creating the input stream

### newReader

    public static BufferedReader newReader(URL url,
                                           String charset)
                                    throws MalformedURLException,
                                           IOException

  Creates a buffered reader for this URL using the given encoding.

  Parameters:
    `url` - a URL
    `charset` - opens the stream with a specified charset
  Returns:
    a BufferedReader for the URL
  Throws:
    `MalformedURLException` - is thrown if the URL is not well formed
    `IOException` - if an I/O error occurs while creating the input stream

### newDataInputStream

    public static DataInputStream newDataInputStream(File file)
                                              throws FileNotFoundException

  Create a data input stream for this file

  Parameters:
    `file` - a File
  Returns:
    a DataInputStream of the file
  Throws:
    `FileNotFoundException` - if the file is not found.

### eachByte

    public static void eachByte(File self,
                                Closure closure)
                         throws IOException

  Traverse through each byte of this File

  Parameters:
    `self` - a File
    `closure` - a closure
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `eachByte(InputStream,Closure)`

### eachByte

    public static void eachByte(Byte[] self,
                                Closure closure)

  Traverse through each byte of this Byte array. Alias for each.

  Parameters:
    `self` - a Byte array
    `closure` - a closure
  See Also:
    `each(Object,Closure)`

### eachByte

    public static void eachByte(byte[] self,
                                Closure closure)

  Traverse through each byte of this byte array. Alias for each.

  Parameters:
    `self` - a byte array
    `closure` - a closure
  See Also:
    `each(Object,Closure)`

### eachByte

    public static void eachByte(InputStream is,
                                Closure closure)
                         throws IOException

  Traverse through each byte of the specified stream. The stream is closed after the closure returns.

  Parameters:
    `is` - stream to iterate over, closed after the method call
    `closure` - closure to apply to each byte
  Throws:
    `IOException` - if an IOException occurs.

### eachByte

    public static void eachByte(URL url,
                                Closure closure)
                         throws IOException

  Reads the InputStream from this URL, passing each byte to the given closure. The URL stream will be closed before this method returns.

  Parameters:
    `url` - url to iterate over
    `closure` - closure to apply to each byte
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `eachByte(InputStream,Closure)`

### transformChar

    public static void transformChar(Reader self,
                                     Writer writer,
                                     Closure closure)
                              throws IOException

  Transforms each character from this reader by passing it to the given closure. The Closure should return each transformed character, which will be passed to the Writer. The reader and writer will be both be closed before this method returns.

  Parameters:
    `self` - a Reader object
    `writer` - a Writer to receive the transformed characters
    `closure` - a closure that performs the required transformation
  Throws:
    `IOException` - if an IOException occurs.

### transformLine

    public static void transformLine(Reader reader,
                                     Writer writer,
                                     Closure closure)
                              throws IOException

  Transforms the lines from a reader with a Closure and write them to a writer. Both Reader and Writer are closed after the operation.

  Parameters:
    `reader` - Lines of text to be transformed. Reader is closed afterwards.
    `writer` - Where transformed lines are written. Writer is closed afterwards.
    `closure` - Single parameter closure that is called to transform each line of text from the reader, before writing it to the writer.
  Throws:
    `IOException` - if an IOException occurs.

### filterLine

    public static void filterLine(Reader reader,
                                  Writer writer,
                                  Closure closure)
                           throws IOException

  Filter the lines from a reader and write them on the writer, according to a closure which returns true if the line should be included. Both Reader and Writer are closed after the operation.

  Parameters:
    `reader` - a reader, closed after the call
    `writer` - a writer, closed after the call
    `closure` - the closure which returns booleans
  Throws:
    `IOException` - if an IOException occurs.

### filterLine

    public static Writable filterLine(File self,
                                      Closure closure)
                               throws IOException

  Filters the lines of a File and creates a Writeable in return to stream the filtered lines.

  Parameters:
    `self` - a File
    `closure` - a closure which returns a boolean indicating to filter the line or not
  Returns:
    a Writable closure
  Throws:
    `IOException` - if `self` is not readable
  See Also:
    `filterLine(Reader,Closure)`

### filterLine

    public static void filterLine(File self,
                                  Writer writer,
                                  Closure closure)
                           throws IOException

  Filter the lines from this File, and write them to the given writer based on the given closure predicate.

  Parameters:
    `self` - a File
    `writer` - a writer destination to write filtered lines to
    `closure` - a closure which takes each line as a parameter and returns `true` if the line should be written to this writer.
  Throws:
    `IOException` - if `self` is not readable
  See Also:
    `filterLine(Reader,Writer,Closure)`

### filterLine

    public static Writable filterLine(Reader reader,
                                      Closure closure)

  Filter the lines from this Reader, and return a Writable which can be used to stream the filtered lines to a destination. The closure should return `true` if the line should be passed to the writer.

  Parameters:
    `reader` - this reader
    `closure` - a closure used for filtering
  Returns:
    a Writable which will use the closure to filter each line from the reader when the Writable#writeTo(Writer) is called.

### toRowResult

    public static GroovyRowResult toRowResult(ResultSet rs)
                                       throws SQLException

  Returns a GroovyRowResult given a ResultSet.

  Parameters:
    `rs` - a ResultSet
  Returns:
    the resulting GroovyRowResult
  Throws:
    `SQLException` - if a database error occurs

### filterLine

    public static Writable filterLine(InputStream self,
                                      Closure predicate)

  Filter lines from an input stream using a closure predicate. The closure will be passed each line as a String, and it should return `true` if the line should be passed to the writer.

  Parameters:
    `self` - an input stream
    `predicate` - a closure which returns boolean and takes a line
  Returns:
    a writable which writes out the filtered lines
  See Also:
    `filterLine(Reader, Closure)`

### filterLine

    public static void filterLine(InputStream self,
                                  Writer writer,
                                  Closure predicate)
                           throws IOException

  Uses a closure to filter lines from this InputStream and pass them to the given writer. The closure will be passed each line as a String, and it should return `true` if the line should be passed to the writer.

  Parameters:
    `self` - the InputStream
    `writer` - a writer to write output to
    `predicate` - a closure which returns true if a line should be accepted
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `filterLine(Reader,Writer,Closure)`

### readBytes

    public static byte[] readBytes(File file)
                            throws IOException

  Reads the content of the file into a byte array.

  Parameters:
    `file` - a File
  Returns:
    a byte array with the contents of the file.
  Throws:
    `IOException` - if an IOException occurs.

### withStreams

    public static Object withStreams(Socket socket,
                                     Closure closure)
                              throws IOException

  Passes the Socket's InputStream and OutputStream to the closure. The streams will be closed after the closure returns, even if an exception is thrown.

  Parameters:
    `socket` - a Socket
    `closure` - a Closure
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.

### withObjectStreams

    public static Object withObjectStreams(Socket socket,
                                           Closure closure)
                                    throws IOException

  Creates an InputObjectStream and an OutputObjectStream from a Socket, and passes them to the closure. The streams will be closed after the closure returns, even if an exception is thrown.

  Parameters:
    `socket` - this Socket
    `closure` - a Closure
  Returns:
    the value returned by the closure
  Throws:
    `IOException` - if an IOException occurs.
  Since:
    1.1 beta 2

### leftShift

    public static Writer leftShift(Socket self,
                                   Object value)
                            throws IOException

  Overloads the left shift operator to provide an append mechanism to add things to the output stream of a socket

  Parameters:
    `self` - a Socket
    `value` - a value to append
  Returns:
    a Writer
  Throws:
    `IOException` - if an IOException occurs.

### leftShift

    public static OutputStream leftShift(Socket self,
                                         byte[] value)
                                  throws IOException

  Overloads the left shift operator to provide an append mechanism to add bytes to the output stream of a socket

  Parameters:
    `self` - a Socket
    `value` - a value to append
  Returns:
    an OutputStream
  Throws:
    `IOException` - if an IOException occurs.

### accept

    public static Socket accept(ServerSocket serverSocket,
                                Closure closure)
                         throws IOException

  Accepts a connection and passes the resulting Socket to the closure which runs in a new Thread.

  Parameters:
    `serverSocket` - a ServerSocket
    `closure` - a Closure
  Returns:
    a Socket
  Throws:
    `IOException` - if an IOException occurs.
  See Also:
    `ServerSocket.accept()`

### asWritable

    public static File asWritable(File file)

  Converts this File to a `Writable`.

  Parameters:
    `file` - a File
  Returns:
    a File which wraps the input file and which implements Writable

### asType

    public static Object asType(File f,
                                Class c)

  Converts this File to a `Writable` or delegates to default `asType(Object,Class)`.

  Parameters:
    `f` - a File
    `c` - the desired class
  Returns:
    the converted object

### asWritable

    public static File asWritable(File file,
                                  String encoding)

  Allows a file to return a Writable implementation that can output itself to a Writer stream.

  Parameters:
    `file` - a File
    `encoding` - the encoding to be used when reading the file's contents
  Returns:
    File which wraps the input file and which implements Writable

### toList

    public static List toList(String self)

  Converts the given String into a List of strings of one character.

  Parameters:
    `self` - a String
  Returns:
    a List of characters (a 1-character String)

### getChars

    public static char[] getChars(String self)

  Converts the given String into an array of characters. Alias for toCharArray.

  Parameters:
    `self` - a String
  Returns:
    an array of characters
  See Also:
    `String.toCharArray()`

### asType

    public static Object asType(GString self,
                                Class c)

  Converts the GString to a File, or delegates to the default `asType(Object,Class)`

  Parameters:
    `self` - a GString
    `c` - the desired class
  Returns:
    the converted object

### asType

    public static Object asType(String self,
                                Class c)

  Provides a method to perform custom 'dynamic' type conversion to the given class using the `as` operator.

  Example: `'123' as Double`

  By default, the following types are supported:

  - List
  - BigDecimal
  - BigInteger
  - Long
  - Integer
  - Short
  - Byte
  - Character
  - Double
  - Float
  - File
  - Subclasses of Enum (Java 5 and above)
  If any other type is given, the call is delegated to `asType(Object,Class)`.

  Parameters:
    `self` - a String
    `c` - the desired class
  Returns:
    the converted object

### getIn

    public static InputStream getIn(Process self)

  An alias method so that a process appears similar to System.out, System.in, System.err; you can use process.in, process.out, process.err in a similar fashion.

  Parameters:
    `self` - a Process instance
  Returns:
    the InputStream for the process

### getText

    public static String getText(Process self)
                          throws IOException

  Read the text of the output stream of the Process.

  Parameters:
    `self` - a Process instance
  Returns:
    the text of the output
  Throws:
    `IOException` - if an IOException occurs.

### getErr

    public static InputStream getErr(Process self)

  An alias method so that a process appears similar to System.out, System.in, System.err; you can use process.in, process.out, process.err in a similar fashion.

  Parameters:
    `self` - a Process instance
  Returns:
    the error InputStream for the process

### getOut

    public static OutputStream getOut(Process self)

  An alias method so that a process appears similar to System.out, System.in, System.err; you can use process.in, process.out, process.err in a similar fashion.

  Parameters:
    `self` - a Process instance
  Returns:
    the OutputStream for the process

### leftShift

    public static Writer leftShift(Process self,
                                   Object value)
                            throws IOException

  Overloads the left shift operator (<<) to provide an append mechanism to pipe data to a Process.

  Parameters:
    `self` - a Process instance
    `value` - a value to append
  Returns:
    a Writer
  Throws:
    `IOException` - if an IOException occurs.

### leftShift

    public static OutputStream leftShift(Process self,
                                         byte[] value)
                                  throws IOException

  Overloads the left shift operator to provide an append mechanism to pipe into a Process

  Parameters:
    `self` - a Process instance
    `value` - data to append
  Returns:
    an OutputStream
  Throws:
    `IOException` - if an IOException occurs.

### waitForOrKill

    public static void waitForOrKill(Process self,
                                     long numberOfMillis)

  Wait for the process to finish during a certain amount of time, otherwise stops the process.

  Parameters:
    `self` - a Process
    `numberOfMillis` - the number of milliseconds to wait before stopping the process

### consumeProcessOutput

    public static void consumeProcessOutput(Process self)

  Gets the output and error streams from a process and reads them to keep the process from blocking due to a full output buffer. For this, two Threads are started, so this method will return immediately.

  Parameters:
    `self` - a Process

### consumeProcessOutput

    public static void consumeProcessOutput(Process self,
                                            StringBuffer output,
                                            StringBuffer error)

  Gets the output and error streams from a process and reads them to keep the process from blocking due to a full output buffer. The processed stream data is appended to the supplied StringBuffer. For this, two Threads are started, so this method will return immediately.

  Parameters:
    `self` - a Process
    `output` - a StringBuffer to capture the process stdout
    `error` - a StringBuffer to capture the process stderr

### consumeProcessOutput

    public static void consumeProcessOutput(Process self,
                                            OutputStream output,
                                            OutputStream error)

  Gets the output and error streams from a process and reads them to keep the process from blocking due to a full output buffer. The processed stream data is appended to the supplied OutputStream. For this, two Threads are started, so this method will return immediately.

  Parameters:
    `self` - a Process
    `output` - an OutputStream to capture the process stdout
    `error` - an OutputStream to capture the process stderr

### consumeProcessErrorStream

    public static void consumeProcessErrorStream(Process self,
                                                 StringBuffer error)

  Gets the error stream from a process and reads it to keep the process from blocking due to a full buffer. The processed stream data is appended to the supplied StringBuffer. A new Thread is started, so this method will return immediately.

  Parameters:
    `self` - a Process
    `error` - a StringBuffer to capture the process stderr

### consumeProcessErrorStream

    public static void consumeProcessErrorStream(Process self,
                                                 OutputStream err)

  Gets the error stream from a process and reads it to keep the process from blocking due to a full buffer. The processed stream data is appended to the supplied OutputStream. A new Thread is started, so this method will return immediately.

  Parameters:
    `self` - a Process
    `err` - an OutputStream to capture the process stderr

### consumeProcessErrorStream

    public static void consumeProcessErrorStream(Process self,
                                                 Writer err)

  Gets the error stream from a process and reads it to keep the process from blocking due to a full buffer. The processed stream data is appended to the supplied Writer. A new Thread is started, so this method will return immediately.

  Parameters:
    `self` - a Process
    `err` - a Writer to capture the process stderr

### consumeProcessOutputStream

    public static void consumeProcessOutputStream(Process self,
                                                  StringBuffer output)

  Gets the output stream from a process and reads it to keep the process from blocking due to a full output buffer. The processed stream data is appended to the supplied StringBuffer. A new Thread is started, so this method will return immediately.

  Parameters:
    `self` - a Process
    `output` - a StringBuffer to capture the process stdout

### consumeProcessOutputStream

    public static void consumeProcessOutputStream(Process self,
                                                  OutputStream output)

  Gets the output stream from a process and reads it to keep the process from blocking due to a full output buffer. The processed stream data is appended to the supplied OutputStream. A new Thread is started, so this method will return immediately.

  Parameters:
    `self` - a Process
    `output` - an OutputStream to capture the process stdout

### consumeProcessOutputStream

    public static void consumeProcessOutputStream(Process self,
                                                  Writer output)

  Gets the output stream from a process and reads it to keep the process from blocking due to a full output buffer. The processed stream data is appended to the supplied Writer. A new Thread is started, so this method will return immediately.

  Parameters:
    `self` - a Process
    `output` - a Writer to capture the process stdout

### withWriter

    public static void withWriter(Process self,
                                  Closure closure)

  Creates a new BufferedWriter as stdin for this process, passes it to the closure, and ensures the stream is flushed and closed after the closure returns. A new Thread is started, so this method will return immediately.

  Parameters:
    `self` - a Process
    `closure` - a closure

### withOutputStream

    public static void withOutputStream(Process self,
                                        Closure closure)

  Creates a new buffered OutputStream as stdin for this process, passes it to the closure, and ensures the stream is flushed and closed after the closure returns. A new Thread is started, so this method will return immediately.

  Parameters:
    `self` - a Process
    `closure` - a closure

### pipeTo

    public static Process pipeTo(Process left,
                                 Process right)
                          throws IOException

  Allows one Process to asynchronously pipe data to another Process.

  Parameters:
    `left` - a Process instance
    `right` - a Process to pipe output to
  Returns:
    the second Process to allow chaining
  Throws:
    `IOException` - if an IOException occurs.

### or

    public static Process or(Process left,
                             Process right)
                      throws IOException

  Overrides the or operator to allow one Process to asynchronously pipe data to another Process.

  Parameters:
    `left` - a Process instance
    `right` - a Process to pipe output to
  Returns:
    the second Process to allow chaining
  Throws:
    `IOException` - if an IOException occurs.

### eachMatch

    public static void eachMatch(String self,
                                 String regex,
                                 Closure closure)

  Process each regex group matched substring of the given string. If the closure parameter takes one argument, an array with all match groups is passed to it. If the closure takes as many arguments as there are match groups, then each parameter will be one match group.

  Parameters:
    `self` - the source string
    `regex` - a Regex string
    `closure` - a closure with one parameter or as much parameters as groups

### each

    public static Matcher each(Matcher self,
                               Closure closure)

  Process each matched substring of the given group matcher. The object passed to the closure is an array of strings, matched per a successful match.

  Parameters:
    `self` - the source matcher
    `closure` - a closure
  Returns:
    the matcher

### findIndexOf

    public static int findIndexOf(Object self,
                                  Closure closure)

  Iterates over the elements of an iterable collection of items and returns the index of the first item that matches the condition specified in the closure.

  Parameters:
    `self` - the iteration object over which to iterate
    `closure` - the filter to perform a match on the collection
  Returns:
    an integer that is the index of the first matched object or -1 if no match was found

### findIndexOf

    public static int findIndexOf(Object self,
                                  int startIndex,
                                  Closure closure)

  Iterates over the elements of an iterable collection of items, starting from a specified startIndex, and returns the index of the first item that matches the condition specified in the closure.

  Parameters:
    `self` - the iteration object over which to iterate
    `startIndex` - start matching from this index
    `closure` - the filter to perform a match on the collection
  Returns:
    an integer that is the index of the first matched object or -1 if no match was found

### findLastIndexOf

    public static int findLastIndexOf(Object self,
                                      Closure closure)

  Iterates over the elements of an iterable collection of items and returns the index of the last item that matches the condition specified in the closure.

  Parameters:
    `self` - the iteration object over which to iterate
    `closure` - the filter to perform a match on the collection
  Returns:
    an integer that is the index of the last matched object or -1 if no match was found

### findLastIndexOf

    public static int findLastIndexOf(Object self,
                                      int startIndex,
                                      Closure closure)

  Iterates over the elements of an iterable collection of items, starting from a specified startIndex, and returns the index of the last item that matches the condition specified in the closure.

  Parameters:
    `self` - the iteration object over which to iterate
    `startIndex` - start matching from this index
    `closure` - the filter to perform a match on the collection
  Returns:
    an integer that is the index of the last matched object or -1 if no match was found

### findIndexValues

    public static List findIndexValues(Object self,
                                       Closure closure)

  Iterates over the elements of an iterable collection of items and returns the index values of the items that match the condition specified in the closure.

  Parameters:
    `self` - the iteration object over which to iterate
    `closure` - the filter to perform a match on the collection
  Returns:
    a list of integers corresponding to the index values of all matched objects

### findIndexValues

    public static List findIndexValues(Object self,
                                       int startIndex,
                                       Closure closure)

  Iterates over the elements of an iterable collection of items, starting from a specified startIndex, and returns the index values of the items that match the condition specified in the closure.

  Parameters:
    `self` - the iteration object over which to iterate
    `startIndex` - start matching from this index
    `closure` - the filter to perform a match on the collection
  Returns:
    a list of integers corresponding to the index values of all matched objects

### getRootLoader

    public static ClassLoader getRootLoader(ClassLoader self)

  Iterates through the classloader parents until it finds a loader with a class named "org.codehaus.groovy.tools.RootLoader". If there is no such class `null` will be returned. The name is used for comparison because a direct comparison using == may fail as the class may be loaded through different classloaders.

  Parameters:
    `self` - a ClassLoader
  Returns:
    the rootLoader for the ClassLoader
  See Also:
    `RootLoader`

### asType

    public static Object asType(Object obj,
                                Class type)

  Converts a given object to a type. This method is used through the "as" operator and is overloadable as any other operator.

  Parameters:
    `obj` - the object to convert
    `type` - the goal type
  Returns:
    the resulting object

### newInstance

    public static Object newInstance(Class c)

  Convenience method to dynamically create a new instance of this class. Calls the default constructor.

  Parameters:
    `c` - a class
  Returns:
    a new instance of this class

### newInstance

    public static Object newInstance(Class c,
                                     Object[] args)

  Helper to construct a new instance from the given arguments. The constructor is called based on the number and types in the args array. Use `newInstance(null)` or simply `newInstance()` for the default (no-arg) constructor.

  Parameters:
    `c` - a class
    `args` - the constructor arguments
  Returns:
    a new instance of this class.

### getMetaClass

    public static MetaClass getMetaClass(Class c)

  Adds a "metaClass" property to all class objects so you can use the syntax `String.metaClass.myMethod = { println "foo" }`

  Parameters:
    `c` - The java.lang.Class instance
  Returns:
    An MetaClass instance

### getMetaClass

    public static MetaClass getMetaClass(Object obj)

  Obtains a MetaClass for an object either from the registry or in the case of a GroovyObject from the object itself.

  Parameters:
    `obj` - The object in question
  Returns:
    The MetaClass

### iterator

    public static Iterator iterator(Object o)

  Attempts to create an Iterator for the given object by first converting it to a Collection.

  Parameters:
    `o` - an object
  Returns:
    an Iterator for the given Object.
  See Also:
    `DefaultTypeTransformation.asCollection(Object)`

### iterator

    public static Iterator iterator(Enumeration enumeration)

  Allows an Enumeration to behave like an Iterator. Note that the `remove()` method is unsupported since the underlying Enumeration does not provide a mechanism for removing items.

  Parameters:
    `enumeration` - an Enumeration object
  Returns:
    an Iterator for the given Enumeration

### iterator

    public static Iterator iterator(NodeList nodeList)

  Makes NodeList iterable by returning a read-only Iterator which traverses over each Node.

  Parameters:
    `nodeList` - a NodeList
  Returns:
    an Iterator for a NodeList

### iterator

    public static Iterator iterator(Matcher matcher)

  Retuns an `Iterator` which traverses each match.

  Parameters:
    `matcher` - a Matcher object
  Returns:
    an Iterator for a Matcher
  See Also:
    `Matcher.group()`

### iterator

    public static Iterator iterator(Reader self)

  Creates an iterator which will traverse through the reader a line at a time.

  Parameters:
    `self` - a Reader object
  Returns:
    an Iterator for the Reader
  See Also:
    `BufferedReader.readLine()`

### iterator

    public static Iterator iterator(InputStream self)

  Standard iterator for a input stream which iterates through the stream content in a byte-based fashion.

  Parameters:
    `self` - an InputStream object
  Returns:
    an Iterator for the InputStream

### iterator

    public static Iterator iterator(DataInputStream self)

  Standard iterator for a data input stream which iterates through the stream content a byte at a time.

  Parameters:
    `self` - a DataInputStream object
  Returns:
    an Iterator for the DataInputStream

### iterator

    public static Iterator iterator(File self)
                             throws IOException

  Deprecated. use File#eachLine instead please

  Just throws a DeprecationException. DO NOT USE. It used to provide an iterator for text file content one line at a time.

  Parameters:
    `self` - a file object
  Returns:
    a line-based iterator
  Throws:
    `IOException` - if there is a problem processing the file (e.g. file is not found)

### iterator

    public static Iterator iterator(Iterator self)

  An identity function for iterators, supporting 'duck-typing' when trying to get an iterator for each object within a collection, some of which may already be iterators.

  Parameters:
    `self` - an iterator object
  Returns:
    itself

Overview | Package | Class | Tree | Deprecated | Index | Help
| Copyright © 2003-2008 The Codehaus. All rights reserved.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD